﻿Imports Microsoft.VisualStudio.TestTools.UnitTesting

Imports ESB.Adaptors.Application.Services.ConventionOverConfig



'''<summary>
'''This is a test class for InjectLocalConfigIntoPipelineTest and is intended
'''to contain all InjectLocalConfigIntoPipelineTest Unit Tests
'''</summary>
<TestClass()> _
Public Class InjectLocalConfigIntoPipelineTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region


    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest0()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 0
        Dim expected As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub
    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest1()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 1
        Dim expected As String = "esb.net.services.process.workflow2.workflow1"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest2()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 2
        Dim expected As String = "esb.net.services.process.workflow2"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest3()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 3
        Dim expected As String = "esb.net.services.process"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub

    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest4()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 4
        Dim expected As String = "esb.net.services"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub


    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest5()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 5
        Dim expected As String = "esb.net"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub


    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest6()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 6
        Dim expected As String = "esb"
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        ' Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub


    '''<summary>
    '''A test for GetParentServiceName
    '''</summary>
    <TestMethod(), _
     DeploymentItem("ESB.Adaptors.Application.Services.ConventionOverConfig.dll")> _
    Public Sub GetParentServiceNameTest7()
        Dim target As InjectLocalConfigIntoPipeline_Accessor = New InjectLocalConfigIntoPipeline_Accessor() ' TODO: Initialize to an appropriate value

        'sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ' Return:
        ' esb.net.services.process.workflow2.workflow1, 
        ' esb.net.services.process.workflow2
        ' esb.net.services.process

        Dim sServiceName As String = "esb.net.services.process.workflow2.workflow1.step1"
        Dim lNumLevels As Integer = 7
        Dim expected As String = ""
        Dim actual As String
        actual = target.GetParentServiceName(sServiceName, lNumLevels)
        Assert.AreEqual(expected, actual)
        'Assert.Inconclusive("Verify the correctness of this test method.")
    End Sub


End Class
