' ===============================================================================
' Microsoft Configuration Management Application Block for .NET
' http://msdn.microsoft.com/library/en-us/dnbda/html/cmab.asp
'
' CustomConfigurationData.vb
'
' The class that contains the configuration for the sample application
'
' For more information see the Configuration Management Application Block Implementation Overview. 
' 
' ===============================================================================
' Copyright (C) 2000-2001 Microsoft Corporation
' All rights reserved.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
' OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
' LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
' FITNESS FOR A PARTICULAR PURPOSE.
' ==============================================================================

Imports System
'Imports System.Drawing
Imports System.Xml

Public Class CustomConfigurationData


Public Sub New()
End Sub 'New 

Public Property ContextManager() As ContextManagerCfg
    Get
        Return _ContextManager
    End Get
    Set(ByVal Value As ContextManagerCfg)
        _ContextManager = Value
    End Set
End Property
Private _ContextManager As ContextManagerCfg


Public Class ContextManagerCfg
    Public Property ServerContextManagerObjectImplementation() As ObjectImplementationCfg
        Get
            Return _ServerContextManagerObjectImplementation
        End Get
        Set(ByVal Value As ObjectImplementationCfg)
            _ServerContextManagerObjectImplementation = Value
        End Set
    End Property
    Private _ServerContextManagerObjectImplementation As ObjectImplementationCfg

    Public Property ClientContextManagerObjectImplementation() As ObjectImplementationCfg
        Get
            Return _ClientContextManagerObjectImplementation
        End Get
        Set(ByVal Value As ObjectImplementationCfg)
            _ClientContextManagerObjectImplementation = Value
        End Set
    End Property
    Private _ClientContextManagerObjectImplementation As ObjectImplementationCfg

End Class

Public Class ObjectImplementationCfg
    Public Property ObjectName() As String
        Get
            Return _ObjectName
        End Get
        Set(ByVal Value As String)
            _ObjectName = Value
        End Set
    End Property
    Private _ObjectName As String

    Public Property AssemblyPath() As String
        Get
            Return _AssemblyPath
        End Get
        Set(ByVal Value As String)
            _AssemblyPath = Value
        End Set
    End Property
    Private _AssemblyPath As String
    End Class
End Class