Public class SequentialWorkflowSample
    Inherits SequentialWorkflowActivity

    Private m_nAmount As Integer
    Public Property Amount() As Integer
        Get
            Return m_nAmount
        End Get
        Set(ByVal value As Integer)
            m_nAmount = value
        End Set
    End Property


    Private m_eStatus As eStatusType
    Public Property Status() As eStatusType
        Get
            Return m_eStatus
        End Get
        Set(ByVal value As eStatusType)
            m_eStatus = value
        End Set
    End Property


    Private Sub IsApproved(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ConditionalEventArgs)
        e.Result = Amount < 500
    End Sub

    Public Enum eStatusType
        None
        Approved
        Rejected
    End Enum

    Private Sub OnApproved(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Status = eStatusType.Approved
    End Sub

    Private Sub OnRejected(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Status = eStatusType.Rejected
    End Sub
End Class
