<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
	<SystemEntryPoints>
		<xsl:for-each select="configuration/ESB.Core.Services.Server/CustomConfigurationData/SystemEntryPointManager/SystemEntryPoint">
			<SystemEntryPoint>
				<xsl:attribute name="CustomParamValue">
					<xsl:value-of select="Custom/ParamValue"/>
				</xsl:attribute>
				<xsl:attribute name="CustomParamName">
					<xsl:value-of select="Custom/ParamName"/>
				</xsl:attribute>
				<xsl:attribute name="AssemblyPath">
					<xsl:value-of select="AssemblyPath"/>
				</xsl:attribute>
				<xsl:attribute name="ObjectName">
					<xsl:value-of select="ObjectName"/>
				</xsl:attribute>
				<xsl:attribute name="Enabled">
					<xsl:value-of select="@enabled"/>
				</xsl:attribute>
				<xsl:attribute name="Name">
					<xsl:value-of select="@name"/>
				</xsl:attribute>
			</SystemEntryPoint>
		</xsl:for-each>
		</SystemEntryPoints>
	</xsl:template>
</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="ESB.Core.Services.Server.Wcf.config" htmlbaseurl="" outputurl="" processortype="internal" useresolver="yes" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="ESB.Core.Services.Server.Wcf.config" srcSchemaRoot="configuration" AssociatedInstance="" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition><template match="/"><block path="xsl:for&#x2D;each" x="426" y="18"/></template></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->