<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:date="http://exslt.org/dates-and-times">
	<!-- cv = common variable -->
	<xsl:variable name="cvTodayDateddMMyyyy" select="date:format-date(date:date(),'dd/MM/yyyy')" />
	<xsl:variable name="cvCurrentTime24" select="date:format-date(date:time(),'HH:mm:ss ')" />
	<xsl:variable name="cvCurrentTime12" select="date:format-date($cvCurrentTime24,'h:mm:ss')" />
	<xsl:variable name="cvCurrentTime12AMPM">
		<xsl:choose>
			<xsl:when test="substring($cvCurrentTime24,1,2) &gt; 12">
				<xsl:value-of select="concat($cvCurrentTime12,' PM')" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat($cvCurrentTime12,' AM')" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="cvDateFormatddMMyyyy" select="'dd/MM/yyyy'"/>
	<xsl:variable name="cvDateFormatyyyy-MM-dd" select="'yyyy-MM-dd'"/>
	<xsl:variable name="cvUpperCaseLetters" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
	<xsl:variable name="cvLowerCaseLetters" select="'abcdefghijklmnopqrstuvwxyz'"/>

</xsl:stylesheet>