'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On 
Public Module ESBConstants


    '++Routing

    Public Const vbQuote As String = "'"

    Public Enum eRoutingAdaptorType
        eTransportAdaptor = 1
        eApplicationAdaptor = 2
    End Enum

    Public Const C_sESBRootPath As String = "ESBRootPath"


    Public Const TRANSPORT_ADAPTER As String = "TRANSPORT"
    Public Const APPLICATION_ADAPTER As String = "APPLICATION"
    Public Const PROPERTY_CURRENTCOMPANY As String = "MyCompany"

    Public Const PROPERTY_NeverRouteMessages As String = "NeverRouteMessages"
    Public Const C_sNeverRouteMessagesFlagValueTrue As String = "1"
    Public Const C_sNeverRouteMessagesFlagValueFalse As String = "0"

    Public Const C_sRegistryValue_UseQueuesAndMessageCorrelationManager As String = "UseQueuesAndMessageCorrelationManager"

    Public Const C_sRequestSourceComputer As String = "RequestSourceComputer"
    Public Const C_sRequestSourceIPAddress As String = "RequestSourceIPAddress"
    Public Const C_sRequestSourceUser As String = "RequestSourceUser"

    Public Const C_sCustomParamESBCore As String = "ESBCore"
    Public Const C_sCustomParamToAddress As String = "ToAddress"
    Public Const C_sCustomParamFromAddress As String = "FromAddress"
    Public Const C_sCustomParamToAddressTransportType As String = "ToAddressTransportType"
    Public Const C_sCustomParamFromAddressTransportType As String = "FromAddressTransportType"
    Public Const C_sCustomParamOverrideDestinationServerURL As String = "OverrideDestinationServerURL"
    Public Const C_sCustomParamOverrideTransportType As String = "OverrideTransportType"

    Public Const C_sCustomParamQueueDeliveryMethod As String = "QueueDeliveryMethod"
    Public Const C_sCustomParamValueQueueDeliveryExpress As String = "QueueDeliveryMethodExpress"
    Public Const C_sCustomParamValueQueueDeliveryRecoverable As String = "QueueDeliveryMethodRecoverable"

    Public Const C_sCustomParamSendResponses As String = "SendResponses"
    Public Const C_sCustomParamSendResponsesValueTrue As String = "1"
    Public Const C_sCustomParamSendResponsesValueFalse As String = "0"



    '--Routing

    Public Const C_sESBContext As String = "ESBContext"

    '++Unique ID
    Public Const C_sCustomParamUniqueID As String = "UniqueID"
    Public Const C_sCustomParamNodeRequestID As String = "NodeRequestID"
    Public Const C_sCustomParamNodeRequestIDSource As String = "NodeRequestIDSource"
    '--

    '++Async
    Public Const C_sRunAsyncOnSync As String = "RunAsyncOnSync"  '0 or 1...
    Public Const C_sRunAsyncOnSyncFalse As String = "0"
    Public Const C_sRunAsyncOnSyncTrue As String = "1"
    '--Async

    '++EnvelopeType
    Public Enum eEnvelopeType
        eEnvelopeJSK = 1
        eEnvelopeE3 = 2
        eEnvelopeUnknown = 3
    End Enum


    '--EnvelopeType


    Public Const C_sLoggingValue_QueuePathName As String = "MSMQLoggerQueuePathName"
    Public Const C_sLoggingValue_HeaderQueuePathName As String = "MessageIDToActivityIDmapQueue"
    Public Const C_sLoggingValue_LogRequestResponse As String = "LogRequestResponse"
    Public Const C_sLoggingValue_LogServiceMetering As String = "LogServiceMetering"
    Public Const C_sLoggingValue_MSMQSystemEntryPointName As String = "MSMQSystemEntryPoint"
    Public Const C_sLoggingValue_MSSQLSystemEntryPointName As String = "MSSqlSystemEntryPoint"


    Public Const C_sPipelineManager_CustomParamRequestQ As String = "ESBRequestQ"
    Public Const C_sPipelineManager_ControlFlowExecution As String = "ControlFlowExecution"
    Public Const C_sPipelineManager_SimpleFlowExecution As String = "LinearFlowExecution" 'default value...



    '++RequestHandlerProxy

    Public Const C_sDestinationServerWSDL As String = "DestinationServerWSDL"
    Public Const C_sDestinationServerURL As String = "DestinationServerURL"
    Public Const C_sDestinationServerURLHTTPPrefix As String = "HTTP"
    Public Const C_sDestinationServerURLSOAPPrefix As String = "SOAP"
    Public Const C_sConfiguredClientTransport As String = "Transport"

    Public Const C_sSoapRpcTimeout As String = "SoapRpcTimeout"
    Public Const C_sSoapDocumentTimeout As String = "SoapDocumentTimeout"
    Public Const C_sHttpTimeout As String = "HttpTimeout"
    Public Const C_sWSE3ClientPolicyConfigEntryName As String = "ESB.ClientPolicy"

    'Note this value is also defined in the Management Console's constants!!!
    Public Const C_sClientNumExecutionTimes As String = "ESB.Client.NumExecutionTimes"
    Public Const C_sInprocClientEndPointName As String = "ESB.Client.InprocClientEndPointName"


    '--RequestHandlerProxy

    '++PipelineManager
    Public Const C_sPipelineManager_ContinueProcessingPipelineCustomParamName As String = "ContinueProcessingPipeline"
    Public Const C_bPipelineManager_ContinueProcessingPipelineCustomParamNameTrue As String = "1"
    Public Const C_bPipelineManager_ContinueProcessingPipelineCustomParamNameFalse As String = "0"

    Public Const C_sPipelineManager As String = "PipelineManager"
    Public Const C_sPipelineManager_PipelineID As String = "PipelineID"
    Public Const C_sPipelineManager_OverrideResolveName As String = "OverrideResolveName"
    Public Const C_sPipelineManager_ContextOverride As String = "ContextOverride"
    Public Const C_sOverrideProcessInParallel As String = "OverrideProcessInParallel"

    '++PipelineManager

    '++Attachments
    Public Const C_sAttachments_StorageBasePath As String = "StorageBasePath"
    Public Const C_sAttachmentProcessorRoleServer As String = "Server"
    Public Const C_sAttachmentProcessorRoleClient As String = "Client"

    'if the parameter set to 1, save attachments, if 0 - don't
    Public Const C_sCustomParamSaveAttachments As String = "SaveAttachments"
    Public Const C_sSaveAttachmentsFalse As String = "0"
    Public Const C_sSaveAttachmentsTrue As String = "1"
    '--Attachments

	'++Workflow
    Public Const C_sCustomParamWorkflowBookmarkName As String = "WorkflowBookmarkName"
    Public Const C_sCustomParamWorkflowRequiresPersistence As String = "WorkflowRequiresPersistence"
    Public Const C_sCustomParamWorkflowResumeExistingWorkflow As String = "ResumeExistingWorkflow"

    '--Workflow
	
    '++TestArea

    Public Const C_sTestAreaRegistryKeyPath As String = "SOFTWARE\CSC\ESB\TestArea"
    Public Const C_sTestAreaRegistryValue_SleepTime As String = "SleepTime"
    Public Const C_sTestAreaRegistryValue_XMLRequestDataFilePath As String = "XMLRequestDataFilePath"

    Public Const C_sTestAreaRegistryValue_MSMQTestLogFilePath As String = "TestLogFilePath"
    Public Const C_sTestAreaRegistryValue_MSMQEditor As String = "Editor"
    Public Const C_sTestAreaRegistryValue_MSMQSaveFilesToPath As String = "SaveFilesToPath"

    Public Const C_sStressTesterRegistryKeyPath As String = "SOFTWARE\CSC\ESB\TestArea\StressTester\CSCSelector"
    Public Const C_sStressTesterRegistryValue_IAppAdaptorImplementationProgID As String = "IAppAdaptorImplementationProgID"


    Public Const C_sServicePipelineCfg As String = "urn:au.com.keystroke.esb.config.servicePipelineCfg.version_1_0_7_0"
    Public Const C_sSimulation As String = "Simulation"
    Public Const C_sSimulation_SupportMode_Supported As String = "eSupported"
    Public Const C_sSimulation_SupportMode_NotSupported As String = "eNotSupported"

End Module