'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' 'Base class for ESB components
' </summary>
'-----------------------------------------------------------------------------
Imports System.EnterpriseServices
Imports ESB.Core.Services.Logger
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope

'NOTE: Classes derived from this only run under COM+!
<EventTrackingEnabled(True), Transaction(TransactionOption.Supported)> _
Public Class ESBServicedComponent
    Inherits System.EnterpriseServices.ServicedComponent


    '''-----------------------------------------------------------------------------
    ''' <summary>
    ''' Clients copy this section and change class name...
    ''' </summary>
    ''' <remarks></remarks>
    ''' <history>
    ''' 	[Administrator] 	9/10/2003	Created
    ''' </history>
    '''-----------------------------------------------------------------------------
    Public Sub New()

    End Sub

    Public Overridable Sub ProcessMsgAsync(ByVal oEnvRq As IEnvelope) 'Implements Core.Interfaces.IProcessMsgCLR.IProcessMsg.NET.IProcessMsg.ProcessMsgAsync
        Throw New NotImplementedException
    End Sub

    Public Overridable Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope 'Implements Core.Interfaces.IProcessMsgCLR.IProcessMsg.NET.IProcessMsg.ProcessMsgSync
        Throw New NotImplementedException
    End Function

    Public Overridable Function GetContext() As ESB.Core.Interfaces.ServerContext.IServerContext
        Dim oServerContext As ESB.Core.Interfaces.ServerContext.IServerContext
        oServerContext = CType(CType(ESB.Core.Services.ContextManager.getContextManager(True), ESB.Core.Services.ContextManager).GetExistingContext, ESB.Core.Interfaces.ServerContext.IServerContext)
        Return oServerContext
    End Function

End Class