Option Strict Off
Option Explicit On
Module Utils
	
	Const ForReading As Short = 1
	Const ForWriting As Short = 2
	Const BlockSize As Integer = 32768
	
	
	
	
	Function ReadFileContents(ByRef sFilePath As String) As String
		
		Dim fso, f As Object
		fso = CreateObject("Scripting.FileSystemObject")
		'UPGRADE_WARNING: Couldn't resolve default property of object fso.OpenTextFile. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		f = fso.OpenTextFile(sFilePath, ForReading)
		'UPGRADE_WARNING: Couldn't resolve default property of object f.ReadAll. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		ReadFileContents = f.ReadAll
		'UPGRADE_WARNING: Couldn't resolve default property of object f.Close. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		f.Close()


	End Function
	
	Function WriteToFile(ByRef sFilePath As String, ByRef sContents As String) As Object
		'Scripting.FileSystemObject
		'Scripting.TextStream
		
		Dim fso, f As Object
		fso = CreateObject("Scripting.FileSystemObject")
		'UPGRADE_WARNING: Couldn't resolve default property of object fso.OpenTextFile. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
        f = fso.OpenTextFile(sFilePath, ForWriting)
		'UPGRADE_WARNING: Couldn't resolve default property of object f.Write. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		f.Write(sContents)
		'UPGRADE_WARNING: Couldn't resolve default property of object f.Close. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		f.Close()
		
	End Function
	Function CreateAndWriteToFile(ByRef sFilePath As String, ByRef sContents As String) As String
		On Error GoTo CreateAndWriteToFileErr
		
        Dim oFile As New ESB.Util.File

        oFile.Write(sFilePath, sContents)

        Return ""
		
		Exit Function
CreateAndWriteToFileErr: 
		CreateAndWriteToFile = "Error writing to file:" & sFilePath
	End Function
	
	
	Public Function TrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String
		
		Dim sTemp As String
		sTemp = LTrimStr(sOverallStringToSearch, sPartialStringToTrimOut)
		sTemp = RTrimStr(sTemp, sPartialStringToTrimOut)
		
		TrimStr = sTemp
		
	End Function
	
	Public Function RTrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String
		
		
		Dim lPos As Integer
		Dim sTemp As String
		
		If Len(sOverallStringToSearch) = 0 Then
			RTrimStr = ""
			Exit Function
		End If
		
		sTemp = sOverallStringToSearch
		
		Do 
			lPos = InStr(Len(sTemp), sTemp, sPartialStringToTrimOut, 0)
			If lPos = Len(sTemp) Then
				sTemp = Left(sTemp, Len(sTemp) - 1)
			End If
		Loop Until lPos <> Len(sTemp) + 1
		
		RTrimStr = sTemp
		
		
		
	End Function
	Public Function LTrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String
		
		Dim lPos As Integer
		Dim sTemp As String
		
		If Len(sOverallStringToSearch) = 0 Then
			LTrimStr = ""
			Exit Function
		End If
		
		
		sTemp = sOverallStringToSearch
		
		Do 
			lPos = InStr(1, sTemp, sPartialStringToTrimOut, 0)
			If lPos = 1 Then
				sTemp = Right(sTemp, Len(sTemp) - 1)
			End If
		Loop Until lPos <> 1
		
		LTrimStr = sTemp
		
	End Function
	
	Public Function GetThisComputerName() As String
        Return System.Environment.MachineName
    End Function

    Function ReadFileContentsBinary(ByRef Source As String) As Object
        Dim SourceFile, NumBlocks, i As Short
        Dim FileLength, LeftOver As Integer
        Dim FileData As String
        Dim RetVal As Object

        Dim Totalfiledata As String

        On Error GoTo Err_ReadFileContentsBinary

        ' Open the source file.
        SourceFile = FreeFile()
        FileOpen(SourceFile, Source, OpenMode.Binary, OpenAccess.Read)

        ' Get the length of the file.
        FileLength = LOF(SourceFile)
        If FileLength = 0 Then
            'UPGRADE_WARNING: Couldn't resolve default property of object ReadFileContentsBinary. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
            ReadFileContentsBinary = 0
            Exit Function
        End If


        ' Read the leftover data, writing it to the table.
        FileData = New String(Chr(32), LeftOver)
        'UPGRADE_WARNING: Get was upgraded to FileGet and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
        FileGet(SourceFile, FileData)
        'T(sField).AppendChunk (FileData)
        Totalfiledata = Totalfiledata & FileData


        ' Read the remaining blocks of data, writing them to the table.
        FileData = New String(Chr(32), BlockSize)
        For i = 1 To NumBlocks
            'UPGRADE_WARNING: Get was upgraded to FileGet and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
            FileGet(SourceFile, FileData)
            Totalfiledata = Totalfiledata & FileData
        Next i

        FileClose(SourceFile)
        'UPGRADE_WARNING: Couldn't resolve default property of object ReadFileContentsBinary. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
        ReadFileContentsBinary = FileLength
        Exit Function

Err_ReadFileContentsBinary:
        'UPGRADE_WARNING: Couldn't resolve default property of object ReadFileContentsBinary. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
        ReadFileContentsBinary = Err.Number
        Exit Function



    End Function
End Module