'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Option Strict Off
Option Explicit On
Namespace ESB.Management.Portal

    Public Module ESBConstants

        '++Routing
        Public Const C_sESBRootPath As String = "ESBRootPath"

        Public Enum eRoutingAdaptorType
            eTransportAdaptor = 1
            eApplicationAdaptor = 2
        End Enum

        Public Const TRANSPORT_ADAPTER As String = "TRANSPORT"
        Public Const APPLICATION_ADAPTER As String = "APPLICATION"
        Public Const PROPERTY_CURRENTCOMPANY As String = "MyCompany"

        Public Const PROPERTY_NeverRouteMessages As String = "NeverRouteMessages"
        Public Const C_sNeverRouteMessagesFlagValueTrue As String = "1"
        Public Const C_sNeverRouteMessagesFlagValueFalse As String = "0"

        Public Const C_sRegistryValue_UseQueuesAndMessageCorrelationManager As String = "UseQueuesAndMessageCorrelationManager"

        Public Const C_sRequestSourceComputer As String = "RequestSourceComputer"
        Public Const C_sRequestSourceIPAddress As String = "RequestSourceIPAddress"
        Public Const C_sRequestSourceUser As String = "RequestSourceUser"
        '--Routing


        '++EnvelopeType
        Public Enum eEnvelopeType
            eEnvelopeJSK = 1
            eEnvelopeE3 = 2
        End Enum
        '--EnvelopeType



        '++HTTPRecvAdaptor
        Public Const C_sHTTPRecvAdaptorRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\Transports\HTTPRecvAdaptor"
        Public Const C_sHTTPRecvAdaptorRegistryeValue_RegistrySettingsOverrideURLQueryStringParameters As String = "RegistrySettingsOverrideURLQueryStringParameters"
        Public Const C_sHTTPRecvAdaptorRegistryeValue_SynchronousOperation As String = "SynchronousOperation"
        '--HTTPRecvAdaptor


        '++ System ProgID's
        Public Const C_sProgID_MSMQQueueInfo As String = "MSMQ.MSMQQueueInfo"
        Public Const C_sProgID_IWshNetwork_Class As String = "IWshRuntimeLibrary.IWshNetwork_Class"
        Public Const C_sProgID_SharedPropertyGroupManager As String = "MTxSpm.SharedPropertyGroupManager.1"


        '-- System ProgID's

        '++ESB ProgID's
        Public Const C_sProgID_Registry As String = "Registry.Registry"
        Public Const C_sProgID_Keystroke_MSMQ As String = "MSMQ.MSMQ"
        Public Const C_sProgID_JSKEnvelope As String = "JSK.Envelope"
        Public Const C_sProgID_SelectorSelect As String = "Selector.Select"
        Public Const C_sProgID_MSMQRecvAdaptor As String = "MSMQRecvAdaptor.MSMQRecv"
        Public Const C_sProgID_Timer As String = "Timer.Timer"
        Public Const C_sProgID_MSMQTransportAdaptor As String = "MSMQAdaptor.MSMQSend"
        Public Const C_sProgID_PipelineManager As String = "Pipeline.Manager"
        Public Const C_sProgID_e3EnvelopeHandler As String = "e3EnvelopeHandler.e3RequestHandler"
        Public Const C_sProgID_XSLTManager As String = "XSLTManager.Manager"
        Public Const C_sProgID_XSLTProcessor As String = "XSLTManager.XSLTProcessor"

        Public Const C_sProgID_MSXMLFreeThreadedDomDocument30 As String = "Msxml2.FreeThreadedDOMDocument.3.0"
        Public Const C_sProgID_MSXMLDomDocument30 As String = "Msxml2.DOMDocument.3.0"

        '--ESB ProgID's

        '++ESB
        Public Const C_sRegistryHive_HKEY_LOCAL_MACHINE As String = "HKEY_LOCAL_MACHINE"

        Public Const C_sProgID_PlgErrorXML_ErrorXMLHelper As String = "PlgErrorXML.ErrorXMLHelper"
        Public Const C_sProgID_PlgErrorXML_ErrorXML As String = "PlgErrorXML.ErrorXML"

        Public Const C_sESBRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB"
        Public Const C_sESBPipelineManagerRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\PipelineManager"
        Public Const C_sESBDocumentTransformManagerRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\DocumentTransformManager"
        Public Const C_sESBRegistryKeyValue_ESBPipelineConfigFilePath As String = "ESBPipelineConfigFilePath"
        Public Const C_sESBRegistryKeyValue_ESBDocumentTransformConfigFilePath As String = "ESBDocumentTransformConfigFilePath"

        Public Const C_sESBDALRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\Dal"
        Public Const C_sBiztalkRegistryValue_UDLFilePath As String = "BiztalkUDLFilePath"

        Public Const C_sESBQueuesRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\Queues"
        Public Const C_sESBQueuesRegistryValue_RequestQueuePathName As String = "RequestQueuePathName"

        Public Const C_se3EnvelopeHandlerRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\e3EnvelopeHandler"
        Public Const C_se3EnvelopeHandlerRegistryKeyValue_e3ToJSKXSLFilePath As String = "e3ToJSKEnvelopeXSLTFilePath"
        Public Const C_se3EnvelopeHandlerRegistryKeyValue_JSKToe3XSLFilePath As String = "JSKtoe3EnvelopeXSLTFilePath"

        'Note this value is also defined in the Core constants!!!
        Public Const C_sClientNumExecutionTimes As String = "ESB.Client.NumExecutionTimes"
        Public Const C_sWcfClientEndPointName As String = "ESB.Client.WcfClientEndPointName"


        '--ESB

        '++RecvAdaptor
        Public Const C_sRecvAdaptorRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\MessageCorrelationManager"

        Public Const C_sRecvAdaptorRegistryValue_MiddleTierComputerName As String = "MiddleTierComputerName"
        Public Const C_sRecvAdaptorRegistryValue_msTimeout As String = "msTimeout"
        Public Const C_sRecvAdaptorRegistryValue_msPollTime As String = "msPollTime"
        Public Const C_sRecvAdaptorRegistryValue_DeleteQ As String = "DeleteQ"
        Public Const C_sRecvAdaptorRegistryValue_UseTempQ As String = "UseTempQ"
        '--RecvAdaptor

        Public Const C_sRegistryValue_GetGUID As String = "GetGUID"

        '++RequestHandlerProxy
        Public Const C_sRequestHandlerProxyRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\Client\RequestHandlerProxy"
        Public Const C_sRecvAdaptorRegistryValue_DestinationServerURL As String = "DestinationServerURL"
        Public Const C_sRecvAdaptorRegistryValue_DestinationServerURLHTTPPrefix As String = "HTTP"
        Public Const C_sRecvAdaptorRegistryValue_DestinationServerURLSOAPPrefix As String = "SOAP"
        Public Const C_sRecvAdaptorRegistryValue_ConfiguredClientTransport As String = "Transport"

        '--RequestHandlerProxy

        '++Logging Settings
        Public Const C_sLoggingRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\Logging"
        'Public Const C_sLoggingValue_QueuePathName As String = "QueuePathName"
        Public Const C_sLoggingValue_QueuePathName_Detail As String = "MSMQLoggerQueuePathName_Detail"
        Public Const C_sLoggingValue_QueuePathName_Header As String = "MSMQLoggerQueuePathName_Header"
        Public Const C_sLoggingValue_QueueDirectFormatName As String = "QueueDirectFormatName"
        Public Const C_sLoggingValue_QLabel As String = "QLabel"
        Public Const C_sLoggingValue_UseDirectFormatName As String = "UseDirectFormatName"
        Public Const C_sLoggingValue_ServerLogLocation As String = "ServerLogLocation"
        Public Const C_sLoggingValue_ReadSettingsFromRegEveryTime As String = "ReadSettingsFromRegEveryTime"
        Public Const C_sLoggingValue_ClientLogLocation As String = "ClientLogLocation"
        Public Const C_sLoggingValue_DatabaseUDLPath As String = "DatabaseUDLPath"
        Public Const C_sLoggingValue_LogMask As String = "LogMask"
        '--Logging Settings

        '++RequestHandlerProxy ProgID's
        Public Const C_sProgID_RequestHandlerProxy As String = "RequestHandlerProxy.RequestHandler"


        '--RequestHandlerProxy ProgID's

        '++TestArea

        Public Const C_sTestAreaRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\TestArea"
        Public Const C_sTestAreaRegistryValue_SleepTime As String = "SleepTime"
        Public Const C_sTestAreaRegistryValue_XMLRequestDataFilePath As String = "XMLRequestDataFilePath"

        Public Const C_sTestAreaRegistryValue_MSMQTestLogFilePath As String = "TestLogFilePath"
        Public Const C_sTestAreaRegistryValue_MSMQEditor As String = "Editor"
        Public Const C_sTestAreaRegistryValue_MSMQSaveFilesToPath As String = "SaveFilesToPath"

        Public Const C_sStressTesterRegistryKeyPath As String = "SOFTWARE\Keystroke\ESB\TestArea\StressTester\KeystrokeSelector"
        Public Const C_sStressTesterRegistryValue_IAppAdaptorImplementationProgID As String = "IAppAdaptorImplementationProgID"


        '++TestArea ProgId's

        '--TestArea ProgId's


        '--TestArea

        Public Const C_sServicePipelineCfg As String = "urn:au.com.keystroke.esb.config.servicePipelineCfg.version_1_0_7_0"

        Public Const C_sProgID_ADODB_Connection As String = "ADODB.Connection"
    End Module
End Namespace
