Imports System
Imports System.Diagnostics
Imports System.Collections.Generic
Imports System.Xml.Serialization
Imports System.Collections
Imports System.Xml.Schema
Imports System.ComponentModel

Namespace ServiceDefinition

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class ServiceDefinition

        Private serviceField As Service

        Private characteristicsField As Characteristics

        Private documentationField As Documentation

        Private businessAttributesField As BusinessAttributes

        Private serviceImplementaionField As ServiceImplementationType

        Public Sub New()
            MyBase.New()
            If (Me.serviceImplementaionField Is Nothing) Then
                Me.serviceImplementaionField = New ServiceImplementationType
            End If
            If (Me.businessAttributesField Is Nothing) Then
                Me.businessAttributesField = New BusinessAttributes
            End If
            If (Me.documentationField Is Nothing) Then
                Me.documentationField = New Documentation
            End If
            If (Me.characteristicsField Is Nothing) Then
                Me.characteristicsField = New Characteristics
            End If
            If (Me.serviceField Is Nothing) Then
                Me.serviceField = New Service
            End If
        End Sub

        '''<remarks/>
        Public Property Service() As Service
            Get
                Return Me.serviceField
            End Get
            Set(ByVal value As Service)
                Me.serviceField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Characteristics() As Characteristics
            Get
                Return Me.characteristicsField
            End Get
            Set(ByVal value As Characteristics)
                Me.characteristicsField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Documentation() As Documentation
            Get
                Return Me.documentationField
            End Get
            Set(ByVal value As Documentation)
                Me.documentationField = value
            End Set
        End Property

        '''<remarks/>
        Public Property BusinessAttributes() As BusinessAttributes
            Get
                Return Me.businessAttributesField
            End Get
            Set(ByVal value As BusinessAttributes)
                Me.businessAttributesField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceImplementaion() As ServiceImplementationType
            Get
                Return Me.serviceImplementaionField
            End Get
            Set(ByVal value As ServiceImplementationType)
                Me.serviceImplementaionField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Service

        Private distinguishedServiceNameField As DistinguishedServiceName

        Private requestField As Request

        Private responseField As Response

        Private serviceProviderNameField As String

        Private serviceKeysField As List(Of ServiceServiceKeys)

        Public Sub New()
            MyBase.New()
            If (Me.serviceKeysField Is Nothing) Then
                Me.serviceKeysField = New List(Of ServiceServiceKeys)
            End If
            If (Me.responseField Is Nothing) Then
                Me.responseField = New Response
            End If
            If (Me.requestField Is Nothing) Then
                Me.requestField = New Request
            End If
            If (Me.distinguishedServiceNameField Is Nothing) Then
                Me.distinguishedServiceNameField = New DistinguishedServiceName
            End If
        End Sub

        '''<remarks/>
        Public Property DistinguishedServiceName() As DistinguishedServiceName
            Get
                Return Me.distinguishedServiceNameField
            End Get
            Set(ByVal value As DistinguishedServiceName)
                Me.distinguishedServiceNameField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Request() As Request
            Get
                Return Me.requestField
            End Get
            Set(ByVal value As Request)
                Me.requestField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Response() As Response
            Get
                Return Me.responseField
            End Get
            Set(ByVal value As Response)
                Me.responseField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceProviderName() As String
            Get
                Return Me.serviceProviderNameField
            End Get
            Set(ByVal value As String)
                Me.serviceProviderNameField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("ServiceKeys")> _
        Public Property ServiceKeys() As List(Of ServiceServiceKeys)
            Get
                Return Me.serviceKeysField
            End Get
            Set(ByVal value As List(Of ServiceServiceKeys))
                Me.serviceKeysField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class DistinguishedServiceName

        Private systemNameField As String

        Private systemVersionField As String

        Private contextField As String

        Private serviceNameField As String

        Private serviceNamespaceField As String

        Private serviceVersionField As String

        Private descriptionField As String

        '''<remarks/>
        Public Property SystemName() As String
            Get
                Return Me.systemNameField
            End Get
            Set(ByVal value As String)
                Me.systemNameField = value
            End Set
        End Property

        '''<remarks/>
        Public Property SystemVersion() As String
            Get
                Return Me.systemVersionField
            End Get
            Set(ByVal value As String)
                Me.systemVersionField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Context() As String
            Get
                Return Me.contextField
            End Get
            Set(ByVal value As String)
                Me.contextField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceName() As String
            Get
                Return Me.serviceNameField
            End Get
            Set(ByVal value As String)
                Me.serviceNameField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceNamespace() As String
            Get
                Return Me.serviceNamespaceField
            End Get
            Set(ByVal value As String)
                Me.serviceNamespaceField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceVersion() As String
            Get
                Return Me.serviceVersionField
            End Get
            Set(ByVal value As String)
                Me.serviceVersionField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Description() As String
            Get
                Return Me.descriptionField
            End Get
            Set(ByVal value As String)
                Me.descriptionField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.Xml.Serialization.XmlIncludeAttribute(GetType(SmtpTransportType)), _
     System.Xml.Serialization.XmlIncludeAttribute(GetType(HttpTransportType)), _
     System.Xml.Serialization.XmlIncludeAttribute(GetType(SoapWsAddressingTransportType)), _
     System.Xml.Serialization.XmlIncludeAttribute(GetType(SoapDocLitTransportType)), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class BaseTransportType
    End Class

    '''<remarks/>
    <System.Xml.Serialization.XmlIncludeAttribute(GetType(HttpTransportType)), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class SmtpTransportType
        Inherits BaseTransportType
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class HttpTransportType
        Inherits SmtpTransportType
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class SoapWsAddressingTransportType
        Inherits BaseTransportType

        Private wsdlField As String

        '''<remarks/>
        Public Property Wsdl() As String
            Get
                Return Me.wsdlField
            End Get
            Set(ByVal value As String)
                Me.wsdlField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class SoapDocLitTransportType
        Inherits BaseTransportType

        Private wsdlField As String

        '''<remarks/>
        Public Property Wsdl() As String
            Get
                Return Me.wsdlField
            End Get
            Set(ByVal value As String)
                Me.wsdlField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class ServiceImplementationType

        Private transportField As List(Of ServiceImplementationTypeTransport)

        Private primaryEsbPlatformField As List(Of System.String)

        Public Sub New()
            MyBase.New()
            If (Me.primaryEsbPlatformField Is Nothing) Then
                Me.primaryEsbPlatformField = New List(Of System.String)
            End If
            If (Me.transportField Is Nothing) Then
                Me.transportField = New List(Of ServiceImplementationTypeTransport)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Transport")> _
        Public Property Transport() As List(Of ServiceImplementationTypeTransport)
            Get
                Return Me.transportField
            End Get
            Set(ByVal value As List(Of ServiceImplementationTypeTransport))
                Me.transportField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("PrimaryEsbPlatform")> _
        Public Property PrimaryEsbPlatform() As List(Of System.String)
            Get
                Return Me.primaryEsbPlatformField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.primaryEsbPlatformField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class ServiceImplementationTypeTransport

        Private itemField As ServiceImplementationTypeTransportEndpoint

        Public Sub New()
            MyBase.New()
            If (Me.itemField Is Nothing) Then
                Me.itemField = New ServiceImplementationTypeTransportEndpoint
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Endpoint")> _
        Public Property Item() As ServiceImplementationTypeTransportEndpoint
            Get
                Return Me.itemField
            End Get
            Set(ByVal value As ServiceImplementationTypeTransportEndpoint)
                Me.itemField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class ServiceImplementationTypeTransportEndpoint

        Private addressField As Object

        Private addressTypeField As Object

        '''<remarks/>
        Public Property Address() As Object
            Get
                Return Me.addressField
            End Get
            Set(ByVal value As Object)
                Me.addressField = value
            End Set
        End Property

        '''<remarks/>
        Public Property AddressType() As Object
            Get
                Return Me.addressTypeField
            End Get
            Set(ByVal value As Object)
                Me.addressTypeField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Request

        Private documentField As List(Of Document)

        Private attachmentField As List(Of Attachment)

        Private validateField As Boolean

        Private validateFieldSpecified As Boolean

        Public Sub New()
            MyBase.New()
            If (Me.attachmentField Is Nothing) Then
                Me.attachmentField = New List(Of Attachment)
            End If
            If (Me.documentField Is Nothing) Then
                Me.documentField = New List(Of Document)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Document")> _
        Public Property Document() As List(Of Document)
            Get
                Return Me.documentField
            End Get
            Set(ByVal value As List(Of Document))
                Me.documentField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Attachment")> _
        Public Property Attachment() As List(Of Attachment)
            Get
                Return Me.attachmentField
            End Get
            Set(ByVal value As List(Of Attachment))
                Me.attachmentField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlAttributeAttribute()> _
        Public Property Validate() As Boolean
            Get
                Return Me.validateField
            End Get
            Set(ByVal value As Boolean)
                Me.validateField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property ValidateSpecified() As Boolean
            Get
                Return Me.validateFieldSpecified
            End Get
            Set(ByVal value As Boolean)
                Me.validateFieldSpecified = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Document

        Private schemaField As Schema

        Private descriptionField As String

        Public Sub New()
            MyBase.New()
            If (Me.schemaField Is Nothing) Then
                Me.schemaField = New Schema
            End If
        End Sub

        '''<remarks/>
        Public Property Schema() As Schema
            Get
                Return Me.schemaField
            End Get
            Set(ByVal value As Schema)
                Me.schemaField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Description() As String
            Get
                Return Me.descriptionField
            End Get
            Set(ByVal value As String)
                Me.descriptionField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Schema

        Private nameField As String

        Private namespaceField As String

        Private urlField As String

        Private nodeConstraintsField As List(Of System.String)

        Private validateField As Boolean

        Private validateFieldSpecified As Boolean

        Public Sub New()
            MyBase.New()
            If (Me.nodeConstraintsField Is Nothing) Then
                Me.nodeConstraintsField = New List(Of System.String)
            End If
        End Sub

        '''<remarks/>
        Public Property Name() As String
            Get
                Return Me.nameField
            End Get
            Set(ByVal value As String)
                Me.nameField = value
            End Set
        End Property

        '''<remarks/>
        Public Property [Namespace]() As String
            Get
                Return Me.namespaceField
            End Get
            Set(ByVal value As String)
                Me.namespaceField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Url() As String
            Get
                Return Me.urlField
            End Get
            Set(ByVal value As String)
                Me.urlField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("NodeConstraints")> _
        Public Property NodeConstraints() As List(Of System.String)
            Get
                Return Me.nodeConstraintsField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.nodeConstraintsField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlAttributeAttribute()> _
        Public Property Validate() As Boolean
            Get
                Return Me.validateField
            End Get
            Set(ByVal value As Boolean)
                Me.validateField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property ValidateSpecified() As Boolean
            Get
                Return Me.validateFieldSpecified
            End Get
            Set(ByVal value As Boolean)
                Me.validateFieldSpecified = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Attachment

        Private indexField As String

        Private nameField As String

        Private typeField As String

        Private descriptionField As String

        '''<remarks/>
        Public Property Index() As String
            Get
                Return Me.indexField
            End Get
            Set(ByVal value As String)
                Me.indexField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Name() As String
            Get
                Return Me.nameField
            End Get
            Set(ByVal value As String)
                Me.nameField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Type() As String
            Get
                Return Me.typeField
            End Get
            Set(ByVal value As String)
                Me.typeField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Description() As String
            Get
                Return Me.descriptionField
            End Get
            Set(ByVal value As String)
                Me.descriptionField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Response

        Private documentField As List(Of Document)

        Private attachmentField As List(Of Attachment)

        Private validateField As Boolean

        Private validateFieldSpecified As Boolean

        Public Sub New()
            MyBase.New()
            If (Me.attachmentField Is Nothing) Then
                Me.attachmentField = New List(Of Attachment)
            End If
            If (Me.documentField Is Nothing) Then
                Me.documentField = New List(Of Document)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Document")> _
        Public Property Document() As List(Of Document)
            Get
                Return Me.documentField
            End Get
            Set(ByVal value As List(Of Document))
                Me.documentField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Attachment")> _
        Public Property Attachment() As List(Of Attachment)
            Get
                Return Me.attachmentField
            End Get
            Set(ByVal value As List(Of Attachment))
                Me.attachmentField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlAttributeAttribute()> _
        Public Property Validate() As Boolean
            Get
                Return Me.validateField
            End Get
            Set(ByVal value As Boolean)
                Me.validateField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property ValidateSpecified() As Boolean
            Get
                Return Me.validateFieldSpecified
            End Get
            Set(ByVal value As Boolean)
                Me.validateFieldSpecified = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0")> _
    Partial Public Class ServiceServiceKeys

        Private serviceKeyXPathField As Object

        Private serviceKeyAliasField As Object

        '''<remarks/>
        Public Property ServiceKeyXPath() As Object
            Get
                Return Me.serviceKeyXPathField
            End Get
            Set(ByVal value As Object)
                Me.serviceKeyXPathField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ServiceKeyAlias() As Object
            Get
                Return Me.serviceKeyAliasField
            End Get
            Set(ByVal value As Object)
                Me.serviceKeyAliasField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Characteristics

        Private synchronizationTypeField As SynchronizationType

        Private synchronizationTypeFieldSpecified As Boolean

        Private transactionalField As String

        Private aggregatedResultField As String

        Private peakLoadField As String

        Private availabilityField As String

        Private responseTimeTargetField As String

        Private parallelProvidersField As String

        Private priorityField As String

        Private messageExchangePatternField As String

        Private serviceTypeField As List(Of System.String)

        Public Sub New()
            MyBase.New()
            If (Me.serviceTypeField Is Nothing) Then
                Me.serviceTypeField = New List(Of System.String)
            End If
        End Sub

        '''<remarks/>
        Public Property SynchronizationType() As SynchronizationType
            Get
                Return Me.synchronizationTypeField
            End Get
            Set(ByVal value As SynchronizationType)
                Me.synchronizationTypeField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property SynchronizationTypeSpecified() As Boolean
            Get
                Return Me.synchronizationTypeFieldSpecified
            End Get
            Set(ByVal value As Boolean)
                Me.synchronizationTypeFieldSpecified = value
            End Set
        End Property

        '''<remarks/>
        Public Property Transactional() As String
            Get
                Return Me.transactionalField
            End Get
            Set(ByVal value As String)
                Me.transactionalField = value
            End Set
        End Property

        '''<remarks/>
        Public Property AggregatedResult() As String
            Get
                Return Me.aggregatedResultField
            End Get
            Set(ByVal value As String)
                Me.aggregatedResultField = value
            End Set
        End Property

        '''<remarks/>
        Public Property PeakLoad() As String
            Get
                Return Me.peakLoadField
            End Get
            Set(ByVal value As String)
                Me.peakLoadField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Availability() As String
            Get
                Return Me.availabilityField
            End Get
            Set(ByVal value As String)
                Me.availabilityField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ResponseTimeTarget() As String
            Get
                Return Me.responseTimeTargetField
            End Get
            Set(ByVal value As String)
                Me.responseTimeTargetField = value
            End Set
        End Property

        '''<remarks/>
        Public Property ParallelProviders() As String
            Get
                Return Me.parallelProvidersField
            End Get
            Set(ByVal value As String)
                Me.parallelProvidersField = value
            End Set
        End Property

        '''<remarks/>
        Public Property Priority() As String
            Get
                Return Me.priorityField
            End Get
            Set(ByVal value As String)
                Me.priorityField = value
            End Set
        End Property

        '''<remarks/>
        Public Property MessageExchangePattern() As String
            Get
                Return Me.messageExchangePatternField
            End Get
            Set(ByVal value As String)
                Me.messageExchangePatternField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("ServiceType")> _
        Public Property ServiceType() As List(Of System.String)
            Get
                Return Me.serviceTypeField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.serviceTypeField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Public Enum SynchronizationType

        '''<remarks/>
        Synchronous

        '''<remarks/>
        Asynchronous
    End Enum

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Documentation

        Private descriptionField As List(Of System.String)

        Private messageAndAttributeFlowField As List(Of System.String)

        Private specialRequirementsConstraintsAndCommentsField As List(Of System.String)

        Private integrationArchitecturePatternField As List(Of System.Object)

        Public Sub New()
            MyBase.New()
            If (Me.integrationArchitecturePatternField Is Nothing) Then
                Me.integrationArchitecturePatternField = New List(Of System.Object)
            End If
            If (Me.specialRequirementsConstraintsAndCommentsField Is Nothing) Then
                Me.specialRequirementsConstraintsAndCommentsField = New List(Of System.String)
            End If
            If (Me.messageAndAttributeFlowField Is Nothing) Then
                Me.messageAndAttributeFlowField = New List(Of System.String)
            End If
            If (Me.descriptionField Is Nothing) Then
                Me.descriptionField = New List(Of System.String)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Description")> _
        Public Property Description() As List(Of System.String)
            Get
                Return Me.descriptionField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.descriptionField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("MessageAndAttributeFlow")> _
        Public Property MessageAndAttributeFlow() As List(Of System.String)
            Get
                Return Me.messageAndAttributeFlowField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.messageAndAttributeFlowField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("SpecialRequirementsConstraintsAndComments")> _
        Public Property SpecialRequirementsConstraintsAndComments() As List(Of System.String)
            Get
                Return Me.specialRequirementsConstraintsAndCommentsField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.specialRequirementsConstraintsAndCommentsField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("IntegrationArchitecturePattern")> _
        Public Property IntegrationArchitecturePattern() As List(Of System.Object)
            Get
                Return Me.integrationArchitecturePatternField
            End Get
            Set(ByVal value As List(Of System.Object))
                Me.integrationArchitecturePatternField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class BusinessAttributes

        Private requestNodeConstraintsField As List(Of System.String)

        Private responseNodeConstraintsField As List(Of System.String)

        Private standardReturnCodesField As List(Of System.String)

        Public Sub New()
            MyBase.New()
            If (Me.standardReturnCodesField Is Nothing) Then
                Me.standardReturnCodesField = New List(Of System.String)
            End If
            If (Me.responseNodeConstraintsField Is Nothing) Then
                Me.responseNodeConstraintsField = New List(Of System.String)
            End If
            If (Me.requestNodeConstraintsField Is Nothing) Then
                Me.requestNodeConstraintsField = New List(Of System.String)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("RequestNodeConstraints")> _
        Public Property RequestNodeConstraints() As List(Of System.String)
            Get
                Return Me.requestNodeConstraintsField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.requestNodeConstraintsField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("ResponseNodeConstraints")> _
        Public Property ResponseNodeConstraints() As List(Of System.String)
            Get
                Return Me.responseNodeConstraintsField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.responseNodeConstraintsField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("StandardReturnCodes")> _
        Public Property StandardReturnCodes() As List(Of System.String)
            Get
                Return Me.standardReturnCodesField
            End Get
            Set(ByVal value As List(Of System.String))
                Me.standardReturnCodesField = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("Xsd2Code", "1.0.2996.4791"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, [Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0", IsNullable:=False)> _
    Partial Public Class Services

        Private serviceDefinitionField As List(Of ServiceDefinition)

        Public Sub New()
            MyBase.New()
            If (Me.serviceDefinitionField Is Nothing) Then
                Me.serviceDefinitionField = New List(Of ServiceDefinition)
            End If
        End Sub

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("ServiceDefinition")> _
        Public Property ServiceDefinition() As List(Of ServiceDefinition)
            Get
                Return Me.serviceDefinitionField
            End Get
            Set(ByVal value As List(Of ServiceDefinition))
                Me.serviceDefinitionField = value
            End Set
        End Property
    End Class
End Namespace
