﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="Instances.aspx.vb" Inherits="Authenticated_System_Instances_Instances" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Registered ESB Instances</title>
    <link href="~/Styles.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
    <p class="H2">
        Registered/Published Instances</p>
    <p class="H2">
        <asp:Button ID="Button1" runat="server" Text="Register/Re-register this instance" />
    </p>
    <asp:GridView ID="GridView1" runat="server" AllowPaging="True" AllowSorting="True"
        AutoGenerateColumns="False" DataKeyNames="index" DataSourceID="SqlDataSource1"
        CellPadding="4" ForeColor="#333333" CellSpacing="1" CssClass="ESBGridStyle">
        <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
        <RowStyle BackColor="#EFF3FB" />
        <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
        <PagerSettings Position="TopAndBottom" />
        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <EditRowStyle BackColor="#2461BF" />
        <AlternatingRowStyle BackColor="White" />
        <Columns>
            <asp:CommandField ShowSelectButton="True" />
            <asp:BoundField DataField="index" HeaderText="index" InsertVisible="False" ReadOnly="True"
                SortExpression="index" />
            <asp:TemplateField HeaderText="EMC Url">
                <ItemTemplate>
                    <asp:HyperLink ID="HyperLink1" runat="server">
                        <a Target="_blank" href="http://<%#Databinder.Eval(Container.dataItem,"host")%>/ESB/<%#Databinder.Eval(Container.dataItem,"ESBInstanceName")%>/Manage/Default.aspx?Authenticated/System/Instances/Instances.aspx" >
                        http://<%#Databinder.Eval(Container.dataItem,"host")%>/ESB/<%#Databinder.Eval(Container.dataItem,"ESBInstanceName")%>/Manage/</a>
                    </asp:HyperLink>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="Service Catalog">
                <ItemTemplate>
                    <asp:HyperLink ID="HyperLink2" runat="server">
                        <a Target="_blank" href="http://<%#Databinder.Eval(Container.dataItem,"host")%>/ESB/<%#Databinder.Eval(Container.dataItem,"ESBInstanceName")%>/Manage/Default.aspx?Authenticated/System/XMLConfigurationFiles/ManagePipelineCfg.aspx" >
                        View Service Catalog</a>
                    </asp:HyperLink>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:BoundField DataField="host" HeaderText="host" SortExpression="host" />
            <asp:BoundField DataField="ESBInstanceName" HeaderText="ESBInstanceName" SortExpression="ESBInstanceName" />
            <asp:BoundField DataField="FullyQualifiedInstanceName" HeaderText="FullyQualifiedInstanceName"
                SortExpression="FullyQualifiedInstanceName" />
            <asp:BoundField DataField="ServiceDomainName" HeaderText="ServiceDomainName" SortExpression="ServiceDomainName" />
            <asp:BoundField DataField="ClusterName" HeaderText="ClusterName" SortExpression="ClusterName" />
            <asp:BoundField DataField="IsServiceDomainEntryPoint" HeaderText="IsServiceDomainEntryPoint"
                SortExpression="IsServiceDomainEntryPoint" />
            <asp:BoundField DataField="FirstRecorded" HeaderText="FirstRecorded" SortExpression="FirstRecorded" />
            <asp:BoundField DataField="LastUpdated" HeaderText="LastUpdated" SortExpression="LastUpdated" />
        </Columns>
    </asp:GridView>
    </div>
    <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
        SelectCommand="SELECT * FROM [Services.EnterprisePacks.Management.InstancesHeader]">
    </asp:SqlDataSource>
    <br />
    Note: Instance registration can be setup to be done automatically at startup of
    any instance transports.<br />
    It can also be done by executing the au.com.keystroke.services.activity.instancePublisher.PublishInstanceDetails
    CoC service.</form>
</body>
</html>
