Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.IO

Namespace ESB.Management.Portal

    Partial Class ClearSqlLogs
        Inherits System.Web.UI.Page

        Dim m_bConnected As Boolean = False
        Dim m_Conn As SqlConnection
        Dim m_sConnString As String

       
#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.OleDbSelectCommand1 = New System.Data.OleDb.OleDbCommand
            Me.OleDbConnection1 = New System.Data.OleDb.OleDbConnection
            Me.OleDbInsertCommand1 = New System.Data.OleDb.OleDbCommand
            Me.OleDbUpdateCommand1 = New System.Data.OleDb.OleDbCommand
            Me.OleDbDeleteCommand1 = New System.Data.OleDb.OleDbCommand
            Me.OleDbDataAdapter1 = New System.Data.OleDb.OleDbDataAdapter
            Me.objESBViewLogsSummary = New ESB.Management.Portal.ESBViewLogsSummary
            CType(Me.objESBViewLogsSummary, System.ComponentModel.ISupportInitialize).BeginInit()
            '
            'OleDbSelectCommand1
            '
            Me.OleDbSelectCommand1.CommandText = "SELECT [index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, C" & _
            "ontext, RequestSourceHost, Status, Duration FROM ESBLogHeader"
            Me.OleDbSelectCommand1.Connection = Me.OleDbConnection1
            '
            'OleDbConnection1
            '
            Me.OleDbConnection1.ConnectionString = "Provider=SQLOLEDB.1;" & System.Configuration.ConfigurationManager.AppSettings("MsSqlLoggerConnectionString")
            '
            'OleDbInsertCommand1
            '
            Me.OleDbInsertCommand1.CommandText = "INSERT INTO ESBLogHeader([index], LogTime, MessageID, DomainInternalMessageID, " & _
            "ActivityID, ResolveName, Context, RequestSourceHost) VALUES (?, ?, ?, ?, ?, ?, ?" & _
            ", ?); SELECT [index], LogTime, MessageID, DomainInternalMessageID, ActivityID, Resolve" & _
            "Name, Context, RequestSourceHost FROM ESBLogHeader WHERE ([index] = ?)"
            Me.OleDbInsertCommand1.Connection = Me.OleDbConnection1
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("index", System.Data.OleDb.OleDbType.Integer, 4, "index"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("LogTime", System.Data.OleDb.OleDbType.VarWChar, 50, "LogTime"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("MessageID", System.Data.OleDb.OleDbType.VarWChar, 50, "MessageID"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("DomainInternalMessageID", System.Data.OleDb.OleDbType.VarWChar, 50, "DomainInternalMessageID"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("ActivityID", System.Data.OleDb.OleDbType.VarWChar, 50, "ActivityID"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("ResolveName", System.Data.OleDb.OleDbType.VarWChar, 50, "ResolveName"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Context", System.Data.OleDb.OleDbType.VarWChar, 50, "Context"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("RequestSourceHost", System.Data.OleDb.OleDbType.VarWChar, 50, "RequestSourceHost"))
            Me.OleDbInsertCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Select_index", System.Data.OleDb.OleDbType.Integer, 4, "index"))
            '
            'OleDbUpdateCommand1
            '
            Me.OleDbUpdateCommand1.CommandText = "UPDATE ESBLogHeader SET [index] = ?, LogTime = ?, MessageID = ?, Internal" & _
            "MessageID = ?, ActivityID = ?, ResolveName = ?, Context = ?, RequestSourceHost =" & _
            " ? WHERE ([index] = ?) AND (ActivityID = ? OR ? IS NULL AND ActivityID IS NULL) " & _
            "AND (Context = ? OR ? IS NULL AND Context IS NULL) AND (DomainInternalMessageID = ? OR" & _
            " ? IS NULL AND DomainInternalMessageID IS NULL) AND (LogTime = ? OR ? IS NULL AND LogT" & _
            "ime IS NULL) AND (MessageID = ? OR ? IS NULL AND MessageID IS NULL) AND (Request" & _
            "SourceHost = ? OR ? IS NULL AND RequestSourceHost IS NULL) AND (ResolveName = ? " & _
            "OR ? IS NULL AND ResolveName IS NULL); SELECT [index], LogTime, MessageID, Inter" & _
            "nalMessageID, ActivityID, ResolveName, Context, RequestSourceHost FROM KeystrokeIntero" & _
            "pLogSummary WHERE ([index] = ?)"
            Me.OleDbUpdateCommand1.Connection = Me.OleDbConnection1
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("index", System.Data.OleDb.OleDbType.Integer, 4, "index"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("LogTime", System.Data.OleDb.OleDbType.VarWChar, 50, "LogTime"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("MessageID", System.Data.OleDb.OleDbType.VarWChar, 50, "MessageID"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("DomainInternalMessageID", System.Data.OleDb.OleDbType.VarWChar, 50, "DomainInternalMessageID"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("ActivityID", System.Data.OleDb.OleDbType.VarWChar, 50, "ActivityID"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("ResolveName", System.Data.OleDb.OleDbType.VarWChar, 50, "ResolveName"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Context", System.Data.OleDb.OleDbType.VarWChar, 50, "Context"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("RequestSourceHost", System.Data.OleDb.OleDbType.VarWChar, 50, "RequestSourceHost"))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_index", System.Data.OleDb.OleDbType.Integer, 4, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "index", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ActivityID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ActivityID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ActivityID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ActivityID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_Context", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "Context", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_Context1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "Context", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_DomainInternalMessageID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "DomainInternalMessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_DomainInternalMessageID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "DomainInternalMessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_LogTime", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "LogTime", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_LogTime1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "LogTime", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_MessageID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "MessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_MessageID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "MessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_RequestSourceHost", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "RequestSourceHost", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_RequestSourceHost1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "RequestSourceHost", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ResolveName", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ResolveName", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ResolveName1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ResolveName", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbUpdateCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Select_index", System.Data.OleDb.OleDbType.Integer, 4, "index"))
            '
            'OleDbDeleteCommand1
            '
            Me.OleDbDeleteCommand1.CommandText = "DELETE FROM ESBLogHeader WHERE ([index] = ?) AND (ActivityID = ? OR ? IS " & _
            "NULL AND ActivityID IS NULL) AND (Context = ? OR ? IS NULL AND Context IS NULL) " & _
            "AND (DomainInternalMessageID = ? OR ? IS NULL AND DomainInternalMessageID IS NULL) AND (LogT" & _
            "ime = ? OR ? IS NULL AND LogTime IS NULL) AND (MessageID = ? OR ? IS NULL AND Me" & _
            "ssageID IS NULL) AND (RequestSourceHost = ? OR ? IS NULL AND RequestSourceHost I" & _
            "S NULL) AND (ResolveName = ? OR ? IS NULL AND ResolveName IS NULL)"
            Me.OleDbDeleteCommand1.Connection = Me.OleDbConnection1
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_index", System.Data.OleDb.OleDbType.Integer, 4, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "index", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ActivityID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ActivityID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ActivityID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ActivityID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_Context", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "Context", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_Context1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "Context", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_DomainInternalMessageID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "DomainInternalMessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_DomainInternalMessageID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "DomainInternalMessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_LogTime", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "LogTime", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_LogTime1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "LogTime", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_MessageID", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "MessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_MessageID1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "MessageID", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_RequestSourceHost", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "RequestSourceHost", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_RequestSourceHost1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "RequestSourceHost", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ResolveName", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ResolveName", System.Data.DataRowVersion.Original, Nothing))
            Me.OleDbDeleteCommand1.Parameters.Add(New System.Data.OleDb.OleDbParameter("Original_ResolveName1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "ResolveName", System.Data.DataRowVersion.Original, Nothing))
            '
            'OleDbDataAdapter1
            '
            Me.OleDbDataAdapter1.DeleteCommand = Me.OleDbDeleteCommand1
            Me.OleDbDataAdapter1.InsertCommand = Me.OleDbInsertCommand1
            Me.OleDbDataAdapter1.SelectCommand = Me.OleDbSelectCommand1
            Me.OleDbDataAdapter1.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", "ESBLogHeader", New System.Data.Common.DataColumnMapping() {New System.Data.Common.DataColumnMapping("index", "index"), New System.Data.Common.DataColumnMapping("LogTime", "LogTime"), New System.Data.Common.DataColumnMapping("MessageID", "MessageID"), New System.Data.Common.DataColumnMapping("DomainInternalMessageID", "DomainInternalMessageID"), New System.Data.Common.DataColumnMapping("ActivityID", "ActivityID"), New System.Data.Common.DataColumnMapping("ResolveName", "ResolveName"), New System.Data.Common.DataColumnMapping("Context", "Context"), New System.Data.Common.DataColumnMapping("RequestSourceHost", "RequestSourceHost")})})
            Me.OleDbDataAdapter1.UpdateCommand = Me.OleDbUpdateCommand1
            '
            'objESBViewLogsSummary
            '
            Me.objESBViewLogsSummary.DataSetName = "ESBViewLogsSummary"
            Me.objESBViewLogsSummary.Locale = New System.Globalization.CultureInfo("en-AU")
            CType(Me.objESBViewLogsSummary, System.ComponentModel.ISupportInitialize).EndInit()

        End Sub
        Protected WithEvents OleDbSelectCommand1 As System.Data.OleDb.OleDbCommand
        Protected WithEvents OleDbInsertCommand1 As System.Data.OleDb.OleDbCommand
        Protected WithEvents OleDbUpdateCommand1 As System.Data.OleDb.OleDbCommand
        Protected WithEvents OleDbDeleteCommand1 As System.Data.OleDb.OleDbCommand
        Protected WithEvents OleDbConnection1 As System.Data.OleDb.OleDbConnection
        Protected WithEvents OleDbDataAdapter1 As System.Data.OleDb.OleDbDataAdapter
        Protected WithEvents objESBViewLogsSummary As ESB.Management.Portal.ESBViewLogsSummary


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub btnEmptyDatabaseTableLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEmptyDatabaseTableLog.Click
            Try
                Dim oQry As String = "Truncate table ESBLogDetail"
                Dim iNumRowsAffected As Integer

                Connect()
                Dim SAcordDa As New SqlCommand("TRUNCATE TABLE ESBLogHeader TRUNCATE TABLE ESBLogDetail", m_Conn)
                iNumRowsAffected = SAcordDa.ExecuteNonQuery()

                Label1.Text = "SQL Log Tables Truncated."

            Catch ex As Exception
                Label1.Text = ex.ToString
                Label1.ForeColor = Color.Red
                ExceptionManager.Publish(ex)
                Throw
            Finally
                disconnect()
            End Try

        End Sub

        Private Function Connect() As Boolean

            If m_bConnected = False Then
                'Get from ServerConfig file....
                m_sConnString = System.Configuration.ConfigurationManager.AppSettings("MsSqlLoggerConnectionString")

                'm_sConnString = "Data Source=localhost; Integrated Security=SSPI; Initial Catalog=ESBLogDetail;"
                'm_sConnString = Me.OleDbConnection1.ConnectionString()

                m_Conn = New SqlConnection(m_sConnString)
                m_Conn.Open()
                m_bConnected = True
            End If

        End Function

        Private Function disconnect() As Boolean
            m_Conn.Close()
            m_bConnected = False
        End Function
    End Class

End Namespace
