
Partial Class Authenticated_System_LogsManagement_ViewLogsDB3
    Inherits System.Web.UI.Page
    Const C_nRequestXmlIndex As Integer = 19


    Enum eTabs
        eFilters = 0
        eRequests = 1
        eActivities = 2
        eActivityDetails = 3
        eXmlLogData = 4
        eReSubmit = 5
    End Enum


    Dim m_sText As String

    Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
        MultiView1.ActiveViewIndex = Int32.Parse(e.Item.Value)

    End Sub

    Protected Sub GridView2_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowDataBound, GridView1.RowDataBound
        '  Make sure that this is a data row and not a header or footer.
        If e.Row.RowType = DataControlRowType.DataRow Then
            '  Get the value of the manager field.
            'Dim sStatusValue As String = CType(DataBinder.Eval(e.Row.DataItem, "Status"), String)
            Dim sStatusValue As String = CType(DataBinder.GetPropertyValue(e.Row.DataItem, "Status"), String)


            '  Set the text and background color.
            If sStatusValue = "eSuccess" Then
                'leave the color alone
            ElseIf sStatusValue = "eWarnings" Then
                e.Row.BackColor = System.Drawing.Color.Yellow
            ElseIf sStatusValue = "eErrors" Then
                e.Row.BackColor = System.Drawing.Color.Red
            ElseIf sStatusValue = "eFailed" Then
                e.Row.BackColor = System.Drawing.Color.OrangeRed
            ElseIf sStatusValue = "eInconsistentEnvelope" Then
                e.Row.BackColor = System.Drawing.Color.Orange
            ElseIf sStatusValue = "" Then
                e.Row.BackColor = System.Drawing.Color.Blue 'pending...?
            Else
                'Some sort of unknown error...
                e.Row.BackColor = System.Drawing.Color.DarkRed
            End If
        End If
    End Sub

    Protected Sub GridView3_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView3.RowDataBound
        '  Make sure that this is a data row and not a header or footer.
        If e.Row.RowType = DataControlRowType.DataRow Then
            '  Get the value of the manager field.
            'Dim sStatusValue As String = CType(DataBinder.Eval(e.Row.DataItem, "Status"), String)
            Dim sStatusValue As String = CType(DataBinder.GetPropertyValue(e.Row.DataItem, "Status"), String)

            '  Set the text and background color.
            If sStatusValue.ToUpper = "OK" Then
                'leave the color alone
            ElseIf sStatusValue.ToUpper = "WARNING" Then
                e.Row.BackColor = System.Drawing.Color.Yellow
            ElseIf sStatusValue.ToUpper = "ERROR" Then
                e.Row.BackColor = System.Drawing.Color.Red
            Else
                'Some sort of unknown error...
                e.Row.BackColor = System.Drawing.Color.DarkRed
            End If
        End If
    End Sub
    Protected Sub GridView3_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView3.SelectedIndexChanged
        'when a record in the Activity Trace is selected, show the LogText for it
        MultiView1.ActiveViewIndex = eTabs.eXmlLogData
        Menu1.Items(eTabs.eXmlLogData).Selected = True

    End Sub

    Protected Sub GridView2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView2.SelectedIndexChanged
        'when a record in the Activity Trace is selected, show the LogText for it
        MultiView1.ActiveViewIndex = eTabs.eActivityDetails
        Menu1.Items(eTabs.eActivityDetails).Selected = True

    End Sub

    Protected Sub GridView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView1.SelectedIndexChanged
        MultiView1.ActiveViewIndex = eTabs.eActivities
        Menu1.Items(eTabs.eActivities).Selected = True

    End Sub


    Protected Sub View4_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles XmlLogData.PreRender


        Dim x As New ESB.Core.XMLSchemaClasses.XMLUtil
        If GridView4.Rows(0).Cells(0).Text <> "" And GridView4.Rows(0).Cells(0).Text <> "_EMPTY_" Then
            TextBox2.Text = x.PrettyFormatXML(GridView4.Rows(0).Cells(0).Text)
        End If

    End Sub


    Protected Sub btnFormatXml_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFormatXml.Click
        Try
            Dim x As New ESB.Core.XMLSchemaClasses.XMLUtil
            TextBox2.Text = x.PrettyFormatXML(GridView4.Rows(0).Cells(0).Text)

        Catch ex As Exception
            Label1.Text = ex.ToString

        End Try

    End Sub

    Protected Sub Menu1_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu1.PreRender
        For Each oItem As MenuItem In Menu1.Items
            If oItem.Selected = True Then
                oItem.SeparatorImageUrl = "~/images/selectedtab.jpg"
            Else
                oItem.SeparatorImageUrl = "~/images/unselectedtab.gif"
            End If
        Next
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'if qry string is passed then assume it's the Sender's MessageID, and do a search/filter etc. based upon it...

        If Not IsPostBack Then

            Dim sSenderMsgID As String = Request.QueryString("SenderMessageID")
            If sSenderMsgID <> "" Then
                txtMessageID.Text = sSenderMsgID
                MultiView1.ActiveViewIndex = eTabs.eRequests
                Menu1.Items(eTabs.eRequests).Selected = True
            End If
        End If

    End Sub

   
    Protected Sub ResubmitButton_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        'Clear the    txtMessageID.Text so that the resubmit actually shows the Response after sending the request off...
        txtMessageID.Text = ""

        'Get id & copy into Resubmission table...
        Dim linkButton As LinkButton = CType(sender, LinkButton)
        'Dim sRqXml As String = Integer.Parse(linkButton.CommandArgument())

        Dim sRqXml As String = linkButton.CommandArgument()
        'Dim sRqXml As String = System.Web.HttpUtility.HtmlDecode(GridView2.Rows(0).Cells(C_nRequestXmlIndex).Text)
        SendRequestUserControl1.RequestXml = sRqXml
        'SendRequestUserControl1.RequestXml = "<?xml version=""1.0"" encoding=""utf-8""?>" & sRqXml
        SendRequestUserControl1.ShowRequestListTree = False
        MultiView1.ActiveViewIndex = eTabs.eReSubmit
        Menu1.Items(eTabs.eReSubmit).Selected = True

        
    End Sub

    Protected Sub btnSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        MultiView1.ActiveViewIndex = eTabs.eRequests
        Menu1.Items(eTabs.eRequests).Selected = True

    End Sub

    Protected Sub btnClearSearchCriteria_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnClearSearchCriteria.Click
        Response.Redirect(Request.Url.AbsolutePath)
    End Sub
End Class
