<%@ Page Language="VB" AutoEventWireup="false" CodeFile="ViewLogsDB3.aspx.vb" Inherits="Authenticated_System_LogsManagement_ViewLogsDB3" %>

<%@ Register Src="../../../UserControls/SendRequestUserControl.ascx" TagName="SendRequestUserControl"
    TagPrefix="uc1" %>

<%@ Register Assembly="wwDataBinder" Namespace="MsdnMag.Web.Controls" TagPrefix="ww" %>


<%@ Register Assembly="Microsoft.ReportViewer.WebForms, Version=8.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"
    Namespace="Microsoft.Reporting.WebForms" TagPrefix="rsweb" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Untitled Page</title>

    <script language="javascript" type="text/javascript">
// <!CDATA[


// ]]>
    </script>

</head>
<body style="height: 100%; width: 100%;">
    <form id="form1" style="height: 100%" runat="server">
        <asp:Menu ID="Menu1" runat="server" Orientation="Horizontal" Width="477px" BackColor="#B5C7DE"
            DynamicHorizontalOffset="2" Font-Names="Verdana" Font-Size="0.8em" ForeColor="#284E98"
            StaticSubMenuIndent="10px">
            <Items>
                <asp:MenuItem Text="Requests" Value="0"></asp:MenuItem>
                <asp:MenuItem Text="Activities" Value="1"></asp:MenuItem>
                <asp:MenuItem Text="Activity Details" Value="2"></asp:MenuItem>
                <asp:MenuItem Text="XmlLogData" Value="3"></asp:MenuItem>
                <asp:MenuItem Text="ReSubmit" Value="4"></asp:MenuItem>
            </Items>
            <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <DynamicHoverStyle BackColor="#284E98" ForeColor="White" />
            <DynamicMenuStyle BackColor="#B5C7DE" />
            <StaticSelectedStyle BackColor="#507CD1" />
            <DynamicSelectedStyle BackColor="#507CD1" />
            <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <StaticHoverStyle BackColor="#284E98" ForeColor="White" />
        </asp:Menu>
        <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
            <asp:View ID="View1" runat="server">
                <strong><span style="color: blue">Request List</span></strong><asp:GridView ID="GridView1"
                    runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False"
                    DataKeyNames="index" DataSourceID="SqlDataSource1" PageSize="50">
                    <Columns>
                        <%--<asp:TemplateField ShowHeader="False">
                            <ItemTemplate>
                                <asp:LinkButton ID="ResubmitButton" runat="server" CausesValidation="false" CommandName=""
                                    OnClick="ResubmitButton_Click" Text="Resubmit"></asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>--%>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="index" HeaderText="index" InsertVisible="False" ReadOnly="True" SortExpression="index" />
                      
                        <asp:BoundField DataField="ServiceDomainName" HeaderText="ServiceDomainName" SortExpression="ServiceDomainName" />
                        <asp:BoundField DataField="ESBInstanceName" HeaderText="ESBInstanceName" SortExpression="ESBInstanceName" />
                        <asp:BoundField DataField="ClusterName" HeaderText="ClusterName" SortExpression="ClusterName" />
                        <asp:BoundField DataField="ComputerName" HeaderText="ComputerName" SortExpression="ComputerName" />
                        <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                        <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                        <asp:BoundField DataField="ConversationID" HeaderText="ConversationID" SortExpression="ConversationID" />
                        <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                        <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID" SortExpression="DomainInternalMessageID" />
                        <asp:BoundField DataField="NodeRequestID" HeaderText="NodeRequestID" SortExpression="NodeRequestID" />
                        <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                        <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                        <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                        <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                        <asp:BoundField DataField="ServiceKeys" HeaderText="ServiceKeys" SortExpression="ServiceKeys" />
                        <asp:BoundField DataField="TransportUrl" HeaderText="TransportUrl" SortExpression="TransportUrl" />
                        <asp:BoundField DataField="TransportType" HeaderText="TransportType" SortExpression="TransportType" />
                        <asp:BoundField DataField="TransportProfile" HeaderText="TransportProfile" SortExpression="TransportProfile" />
                          <asp:CheckBoxField DataField="IsNodeInstanceRequestMessage" HeaderText="IsNodeInstanceRequestMessage"
                            ReadOnly="True" SortExpression="IsNodeInstanceRequestMessage">
                            <ItemStyle Width="5px" />
                        </asp:CheckBoxField>
                        <asp:CheckBoxField DataField="IsServiceDomainRequestMessage" HeaderText="IsServiceDomainRequestMessage"
                            ReadOnly="True" SortExpression="IsServiceDomainRequestMessage" />
                        <asp:CheckBoxField DataField="IsServiceDomainEntryPoint" HeaderText="IsServiceDomainEntryPoint"
                            ReadOnly="True" SortExpression="IsServiceDomainEntryPoint" />
                    </Columns>
                </asp:GridView>
                <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                    SelectCommand="SELECT [index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, Context, RequestSourceHost, Duration, Status, UserName, ServiceKeys, ComputerName, IsServiceDomainEntryPoint, ServiceDomainName, ClusterName, NodeRequestID, ConversationID, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, ESBInstanceName, TransportUrl, TransportType, TransportProfile FROM ESBLogHeader WHERE (IsNodeInstanceRequestMessage = 1) ORDER BY [index], LogTime, DomainInternalMessageID">
                </asp:SqlDataSource>
                <br />
                <span style="color: blue"><strong>Activities for Selected Request</strong>&nbsp;</span>
                <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                    SelectCommand="SELECT [index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, Context, RequestSourceHost, Duration, Status, ComputerName, UserName, RequestXML, ResponseXML, ServiceKeys, ConversationID, NodeRequestID, ClusterName, ServiceDomainName, IsServiceDomainEntryPoint, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, ESBInstanceName, TransportUrl, TransportType FROM ESBLogHeader WHERE (DomainInternalMessageID = (SELECT DomainInternalMessageID FROM ESBLogHeader AS ESBLogHeader_1 WHERE ([index] = @index )))">
                    <SelectParameters>
                        <asp:ControlParameter ControlID="GridView1" Name="index" PropertyName="SelectedValue"
                            Type="String" />
                    </SelectParameters>
                </asp:SqlDataSource>
            </asp:View>
             <asp:View ID="View2" runat="server">
                <asp:GridView ID="GridView2" runat="server" AllowPaging="True" AllowSorting="True"
                    AutoGenerateColumns="False" DataKeyNames="index" DataSourceID="SqlDataSource2" PageSize="50">
                    <Columns>
                     <asp:TemplateField ShowHeader="False">
                            <ItemTemplate>
                                <asp:LinkButton ID="ResubmitButton" runat="server" CausesValidation="false" CommandName=""
                                    OnClick="ResubmitButton_Click" Text="Resubmit"></asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="index" HeaderText="index" InsertVisible="False" ReadOnly="True" SortExpression="index" />
                        <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                        <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                        <asp:BoundField DataField="ConversationID" HeaderText="ConversationID" SortExpression="ConversationID" />
                        <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                        <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID" SortExpression="DomainInternalMessageID" />
                        <asp:BoundField DataField="NodeRequestID" HeaderText="NodeRequestID" SortExpression="NodeRequestID" />
                        <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                        <asp:BoundField DataField="ServiceDomainName" HeaderText="ServiceDomainName" SortExpression="ServiceDomainName" />
                        <asp:BoundField DataField="ClusterName" HeaderText="ClusterName" SortExpression="ClusterName" />
                        <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                        <asp:BoundField DataField="ComputerName" HeaderText="ComputerName" SortExpression="ComputerName" />
                        <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                        <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                        <asp:BoundField DataField="ServiceKeys" HeaderText="ServiceKeys" SortExpression="ServiceKeys" />
                        <asp:BoundField DataField="RequestXML" HeaderText="RequestXML" SortExpression="RequestXML" />
                        <asp:BoundField DataField="ResponseXML" HeaderText="ResponseXML" SortExpression="ResponseXML" />
                        <asp:BoundField DataField="IsServiceDomainEntryPoint" HeaderText="IsServiceDomainEntryPoint" SortExpression="IsServiceDomainEntryPoint" />
                    </Columns>
                </asp:GridView>
                </asp:View>
            <asp:View ID="View3" runat="server">
                <br />
                <span style="color: blue"><strong>Trace for Selected Activity</strong>&nbsp;</span>
                <asp:GridView ID="GridView3" runat="server" AllowSorting="True" AutoGenerateColumns="False"
                    DataKeyNames="Index" DataSourceID="SqlDataSource3" PageSize="50">
                    <Columns>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" InsertVisible="False" ReadOnly="True"
                            SortExpression="Index" />
                        <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                        <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                        <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID" SortExpression="DomainInternalMessageID" />
                        <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                        <asp:BoundField DataField="SourceCodeLocationDetails" HeaderText="SourceCodeLocationDetails"
                            SortExpression="SourceCodeLocationDetails" />
                        <asp:BoundField DataField="SourceCodeMethodDetails" HeaderText="SourceCodeMethodDetails"
                            SortExpression="SourceCodeMethodDetails" />
                        <asp:BoundField DataField="ProcessID" HeaderText="ProcessID" SortExpression="ProcessID" />
                        <asp:BoundField DataField="ThreadID" HeaderText="ThreadID" SortExpression="ThreadID" />
                        <asp:BoundField DataField="LogLevel" HeaderText="LogLevel" SortExpression="LogLevel" />
                        <asp:BoundField DataField="LogText" HeaderText="LogText" SortExpression="LogText" />
                        <asp:BoundField DataField="LogSummary" HeaderText="LogSummary" SortExpression="LogSummary" />
                        <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                        <asp:BoundField DataField="XmlLogData" HeaderText="XmlLogData" SortExpression="XmlLogData" />
                    </Columns>
                </asp:GridView>
                <asp:SqlDataSource ID="SqlDataSource3" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                    SelectCommand="SELECT [Index], [LogTime], [MessageID], [DomainInternalMessageID], [ActivityID], [SourceCodeLocationDetails], [SourceCodeMethodDetails], [ProcessID], [ThreadID], [LogLevel], [LogText], [LogSummary], [Status], [XmlLogData] FROM [ESBLogDetail] WHERE ([ActivityID] = (select [ActivityID] FROM [ESBLogHeader] WHERE [Index] = @Index)) ORDER BY [Index]">
                    <SelectParameters>
                        <asp:ControlParameter ControlID="GridView2" Name="Index" PropertyName="SelectedValue"
                            Type="Int32" />
                    </SelectParameters>
                </asp:SqlDataSource>
               
            </asp:View>
            <asp:View ID="View4" runat="server">
                <span style="height: 100%">
                    <asp:Button ID="btnFormatXml" runat="server" Text="Format XML" Visible="False" />
                    <asp:Label ID="Label1" runat="server"></asp:Label><br />
                    <asp:TextBox ID="TextBox2" runat="server"  Height="900px" TextMode="MultiLine" Width="95%"></asp:TextBox>
                    <asp:SqlDataSource ID="SqlDataSource4" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                        SelectCommand="SELECT [XmlLogData] FROM [ESBLogDetail] WHERE ([Index] = @Index)">
                        <SelectParameters>
                            <asp:ControlParameter ControlID="GridView3" Name="Index" PropertyName="SelectedValue"
                                Type="Int32" />
                        </SelectParameters>
                    </asp:SqlDataSource>
                    
               <%--   
                    <ww:WebTextBox ID="WebTextBox1" runat="server" Height="500px" TextMode="MultiLine" Width="95%"  BindingItem-BindingSource="SqlDataSource4.DataBindingItem"
                        BindingItem-ControlId="WebTextBox1"  BindingItem-BindingProperty="XmlLogData" Visible="False" ></ww:WebTextBox>
               --%>             
                    <asp:GridView ID="GridView4" runat="server" AutoGenerateColumns="False" DataSourceID="SqlDataSource4"
                        Visible="False">
                        <Columns>
                            <asp:BoundField DataField="XmlLogData" HeaderText="XmlLogData" HtmlEncode="False" SortExpression="XmlLogData" />
                        </Columns>
                    </asp:GridView>
                    &nbsp;
                    <asp:Xml ID="Xml1" runat="server"></asp:Xml></span></asp:View>
            <asp:View ID="View5" runat="server">
                <uc1:SendRequestUserControl ID="SendRequestUserControl1" runat="server" />
            </asp:View>
        </asp:MultiView>
    </form>
</body>
</html>
