<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:a="urn:au.com.keystroke.esb.config.servicePipelineCfg.version_1_0_7_0" xmlns="urn:au.com.keystroke.esb.config.servicePipelineCfg.version_1_0_7_0">
	<xsl:template match="/">
		<Services>
			<xsl:for-each select="configuration/ESB.Core.Pipeline/a:Config/a:PipelineConfig/*/a:PipelineMapSection/a:PipelineEntry">
				<ServiceData>
					<xsl:attribute name="Index">
						<xsl:value-of select="concat('V', position())"/>
					</xsl:attribute>
					<xsl:attribute name="Context">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:Context"/>
					</xsl:attribute>
					<xsl:attribute name="ResolveName">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:ResolveName"/>
					</xsl:attribute>
					<xsl:attribute name="AlwaysExecute">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:MultiLevelOverrides/a:AlwaysExecute"/>
					</xsl:attribute>
					<xsl:attribute name="Layer">
					<!-- Get the HorizontalPre, Vertical or HorizontalPost value... -->
						<xsl:value-of select="name(../..)"/>
						<!-- above is same as:...	<xsl:value-of select="name(../parent::node())"/>-->
					</xsl:attribute>
					<xsl:attribute name="UrlEncodedContext"><xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:Context"/></xsl:attribute>
          <xsl:attribute name="ServiceDefinition">ServiceDefinition.<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:Context"/>.xml</xsl:attribute>
          <xsl:attribute name="ServiceType">Configured.Instance</xsl:attribute>
          <xsl:attribute name="ServiceVersion"></xsl:attribute>
          <xsl:attribute name="ServiceHandler"></xsl:attribute>
        </ServiceData>
			</xsl:for-each>
		</Services>
	</xsl:template>
</xsl:stylesheet>
