Imports System.IO


Partial Class UrlEncodeAndShowWSDL
    Inherits System.Web.UI.Page

    Dim m_sUrlEncodedContext As String
    Dim m_sRootPathName As String
    Dim m_sServiceDefinitionFileName As String
    Dim m_sServiceDefinitionFileNameExpanded As String

    Dim C_sServiceTypeConfigured As String = "Configured"
    Dim C_sServiceTypeConventionOverConfiguration As String = "ConventionOverConfiguration"

    Protected m_sServiceType As String

    Dim m_sContext As String
    Dim m_sResolveName As String
    Dim m_sSchemaNamespace As String
    Dim m_sRootElementName As String
    Dim m_sServiceVersion As String
    Dim m_sServiceHandler As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
        MultiView1.ActiveViewIndex = e.Item.Value
    End Sub

    Protected Sub Page_PreLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreLoad
        Dim oServiceDefinitionHelper As New ServiceDefinitionHelper(Server, ESB.Core.Util.Utils.GetDNSName(ESB.Core.Util.ESBGlobalVariables.RequestAbsoluteUri))
        oServiceDefinitionHelper.m_sServiceType = Session("servicetype")
        oServiceDefinitionHelper.m_sContext = Session("context")
        oServiceDefinitionHelper.m_sResolveName = Session("resolvename")
        oServiceDefinitionHelper.m_sServiceVersion = Session("serviceversion")
        oServiceDefinitionHelper.m_sServiceHandler = Session("servicehandler")
        oServiceDefinitionHelper.m_sUrlEncodedContext = Session("urlencodedcontext")

        oServiceDefinitionHelper.CreateServiceDefinitionFile()
        Dim oWSDL As ServiceDefinitionHelper.WSDL = oServiceDefinitionHelper.CreateWSDLFile()

        With oWSDL.m_oOutputs

            ' lblCommandToRun.Text = .sWSDLOutputFileNameRelativePathIIS
            lblWsdlOutputFileName.Text = .sWSDLOutputFileName

            lblServiceDefinition.Text = oServiceDefinitionHelper.m_sUrlEncodedContext
            lblServiceDefinitionFilePath.Text = oServiceDefinitionHelper.m_sServiceDefinitionFileNameExpanded

            HyperLink1.NavigateUrl = .sWSDLOutputFileNameRelativePathIIS
            HyperLink1.Target = "_blank"
        End With


    End Sub
End Class
