<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="Root">
    <html>
      <head>
        <title />
      </head>
      <body>
        <table>
          <tbody>
            <xsl:apply-templates select="*" />
          </tbody>
        </table>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="*[not(*)]">
    <tr>
      <td>
        <xsl:for-each select="ancestor::*[not(self::Root)] | .">
          <xsl:if test="not(position() = 1)"> - </xsl:if>
          <xsl:value-of select="name()" />
        </xsl:for-each>
      </td>
      <td>
        <xsl:value-of select="." />
      </td>
    </tr>
  </xsl:template>


</xsl:stylesheet> 

