<%@ Page Language="vb" AutoEventWireup="false" Inherits="ESB.Management.Portal.ManageDocumentTransformCfg"
    CodeFile="ManageDocumentTransformCfg.aspx.vb" %>

<%@ Register TagPrefix="uc1" TagName="SimpleDataGridWebUserControl" Src="../../../UserControls/SimpleDataGridWebUserControl.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ViewLogs</title>
    <link href="~/Styles.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="Form1" method="post" runat="server">
    <asp:Label ID="lblTitle" runat="server" Height="28px" Font-Size="Medium" Font-Bold="True"
        ForeColor="Blue">Manage Document Transform Configuration</asp:Label>&nbsp;
    <asp:Label ID="lblFontSize" runat="server" Font-Size="XX-Small" Font-Bold="True"
        ForeColor="Blue" Height="1px" Width="54px">Status</asp:Label>
    <asp:TextBox ID="txtStatus" runat="server" Font-Size="XX-Small" Height="71px" Width="396px"
        TextMode="MultiLine" Wrap="False"></asp:TextBox>&nbsp;
    <asp:Menu ID="Menu1" runat="server" BackColor="#FFFBD6" DynamicHorizontalOffset="2"
        Font-Names="Verdana" Font-Size="0.8em" ForeColor="#990000" Orientation="Horizontal"
        StaticSubMenuIndent="10px">
        <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
        <DynamicHoverStyle BackColor="#990000" ForeColor="White" />
        <DynamicMenuStyle BackColor="#FFFBD6" />
        <StaticSelectedStyle BackColor="#FFCC66" />
        <DynamicSelectedStyle BackColor="#FFCC66" />
        <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
        <Items>
            <asp:MenuItem Text="Configured items grid" Value="0" Selected="True"></asp:MenuItem>
            <asp:MenuItem Text="Raw XML" Value="1"></asp:MenuItem>
            <asp:MenuItem Text="Configured items tree" Value="2"></asp:MenuItem>
        </Items>
        <StaticHoverStyle BackColor="#990000" ForeColor="White" />
    </asp:Menu>
    &nbsp; &nbsp;&nbsp;
    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
        <asp:View runat="server" ID="View1">
            <asp:GridView CssClass="ESBGridStyle_xxSmall" DataSourceID="XmlDataSource1" ID="GridView1"
                runat="server" AllowPaging="True" AutoGenerateColumns="False" CellPadding="4"
                GridLines="Both" CellSpacing="1" PageSize="20">
                <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                <RowStyle BackColor="#EFF3FB" />
                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                <PagerSettings Position="TopAndBottom" />
                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                <EditRowStyle BackColor="#2461BF" />
                <AlternatingRowStyle BackColor="White" />
                <Columns>
                    <asp:CommandField ShowSelectButton="True" />
                    <asp:BoundField DataField="index" HeaderText="index" SortExpression="index" />
                    <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                    <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                </Columns>
            </asp:GridView>
            <asp:XmlDataSource ID="XmlDataSource1" runat="server" DataFile="" TransformFile="">
            </asp:XmlDataSource>
            <%--<asp:XmlDataSource ID="XmlDataSource2" runat="server" DataFile="~/Testing/DocumentTransformPipeline.config"
                TransformFile="~/Testing/DocumentTransformPipeline.xslt"></asp:XmlDataSource>--%>
        </asp:View>
        <asp:View runat="server" ID="View2">
            <asp:Label ID="Label3" runat="server" Font-Size="X-Small" ForeColor="Blue">Config File Path</asp:Label><asp:Button
                ID="btnSave" runat="server" Font-Size="XX-Small" Height="26px" ForeColor="Blue"
                Font-Bold="True" Text="Save" Width="116px"></asp:Button><asp:TextBox ID="txtCfgFilePath"
                    runat="server" Height="26px" Width="760px" ForeColor="Blue" Font-Size="XX-Small"></asp:TextBox><asp:Button
                        ID="btnLoad" runat="server" Font-Size="XX-Small" Height="26px" ForeColor="Blue"
                        Font-Bold="True" Text="ReLoad" Width="121px"></asp:Button><asp:TextBox ID="ctlRawCfgTextBox"
                            runat="server" Height="360px" Width="720px" TextMode="MultiLine" Wrap="False"
                            Font-Size="XX-Small"></asp:TextBox>
        </asp:View>
        <asp:View runat="server" ID="View3">
            <asp:Button ID="btnShowItems" runat="server" Width="250px" Height="26px" Text="Show Configured Items"
                ForeColor="Blue" Font-Size="XX-Small"></asp:Button>
            <asp:Label ID="Label4" runat="server" ForeColor="Blue" Font-Bold="True" Font-Size="XX-Small"
                Height="32px" Width="80px">Expanded Tree Node Levels</asp:Label>
            <asp:TextBox ID="txtNumwTreeLevelsToShow" runat="server" Width="55px" Wrap="False"
                Font-Size="XX-Small">2</asp:TextBox>
            <asp:TreeView ID="TreeView1" ShowExpandCollapse="true" ShowLines="true" runat="server"
                Height="800px" Width="500px" ImageSet="XPFileExplorer" NodeIndent="15" ExpandDepth="3">
                <ParentNodeStyle Font-Bold="False" />
                <HoverNodeStyle Font-Underline="True" ForeColor="#6666AA" />
                <SelectedNodeStyle BackColor="#B5B5B5" Font-Underline="False" HorizontalPadding="0px"
                    VerticalPadding="0px" />
                <NodeStyle Font-Names="Tahoma" Font-Size="8pt" ForeColor="Black" HorizontalPadding="2px"
                    NodeSpacing="0px" VerticalPadding="2px" />
            </asp:TreeView>
        </asp:View>
    </asp:MultiView>
    </form>
</body>
</html>
