<%@ Page Language="vb" AutoEventWireup="false" Inherits="ESB.Management.Portal.ManagePipelineCfg"
    CodeFile="ManagePipelineCfg.aspx.vb" %>

<%@ Register Src="../../../UserControls/SendRequestUserControl.ascx" TagName="SendRequestUserControl"
    TagPrefix="uc1" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ViewLogs</title>
    <link href="~/Styles.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="Form1" method="post" runat="server">
    <p>
        <asp:Label ID="lblTitle" runat="server" Height="28px" Font-Size="Medium" Font-Bold="True"
            ForeColor="Blue">Manage Pipeline Configuration</asp:Label>
        &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
        <asp:Label ID="lblFontSize" runat="server" Font-Size="XX-Small" Font-Bold="True"
            ForeColor="Blue" Height="1px" Width="54px">Status</asp:Label>
        <asp:TextBox ID="txtStatus" runat="server" Font-Size="XX-Small" Height="41px" Width="615px"
            TextMode="MultiLine" Wrap="False"></asp:TextBox></p>
    <p>
        <asp:Menu ID="Menu1" runat="server" BackColor="#FFFBD6" DynamicHorizontalOffset="2"
            Font-Names="Verdana" Font-Size="0.8em" ForeColor="#990000" Orientation="Horizontal"
            StaticSubMenuIndent="10px" Width="1200px" ItemWrap="True">
            <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <DynamicHoverStyle BackColor="#990000" ForeColor="White" />
            <DynamicMenuStyle BackColor="#FFFBD6" />
            <StaticSelectedStyle BackColor="#FFCC66" />
            <DynamicSelectedStyle BackColor="#FFCC66" />
            <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <Items>
                <asp:MenuItem Text="All Services grid view" Value="0" Selected="True"></asp:MenuItem>
                <asp:MenuItem Text="Instance-wide Configured (Virtualized) Services grid view" Value="1">
                </asp:MenuItem>
                <asp:MenuItem Text="Locally Configured (Virtualized) Services grid view" Value="2">
                </asp:MenuItem>
                <asp:MenuItem Text="Convention over configuration Services view" Value="3"></asp:MenuItem>
                <asp:MenuItem Text="Configured (Virtualized) Services and Handlers tree view" Value="4">
                </asp:MenuItem>
                <asp:MenuItem Text="Configured (Virtualized) Services and Handlers raw XML view"
                    Value="5"></asp:MenuItem>
                <asp:MenuItem Text="Configured Service Handlers grid view" Value="6"></asp:MenuItem>
                <asp:MenuItem Text="Submit Request" Value="7"></asp:MenuItem>
            </Items>
            <StaticHoverStyle BackColor="#990000" ForeColor="White" />
        </asp:Menu>
        <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
            <asp:View runat="server" ID="AllServicesView">
                V=Virtualized Services, C=Convention Based Services
                <asp:TextBox ID="txtServiceSearch" runat="server" Width="501px"></asp:TextBox>
                <asp:Button ID="btnSearch" runat="server" Text="Search for service" />
                <asp:Button ID="btnClearServiceSearch" runat="server" Text="Clear service search" />
                &nbsp;<br />
                <asp:Button ID="btnViewBSDL" runat="server" Text="View BSDL" />
                <asp:Button ID="btnViewWSDL" runat="server" Text="View WSDL" />
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView4" runat="server" DataSourceID="XmlDataSource4_AllServicesView"
                    AllowPaging="True" AutoGenerateColumns="False" CellPadding="4" CellSpacing="1"
                    PageSize="15">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <PagerSettings Position="TopAndBottom" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <%-- <asp:BoundField DataField="Id" HeaderText="Id" SortExpression="Id" />--%>
                        <asp:TemplateField HeaderText="Select">
                            <ItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </ItemTemplate>
                            <EditItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </EditItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Business Service Definition (BSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton1" runat="server" CommandName='<%# "AllServicesView_ViewBSDL" %>'>View BSDL</asp:LinkButton>
                                <asp:Label ID="Label2" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Technical Service Definition (WSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton3" runat="server" CommandName='<%# "AllServicesView_ViewWSDL" %>'>View WSDL</asp:LinkButton>
                                <asp:Label ID="Label3" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Generate Sample Request From BSDL">
                            <ItemTemplate>
                                <asp:LinkButton ID="LinkButton2" runat="server" CommandName='<%# "AllServicesView_GenerateSampleRequestFromBSDL" %>'>Sample Request</asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" SortExpression="Index" />
                        <asp:BoundField DataField="Context" HeaderText="Context (Service)" SortExpression="Context" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="AlwaysExecute" HeaderText="AlwaysExecute" SortExpression="AlwaysExecute" />
                        <asp:BoundField DataField="Layer" HeaderText="Layer" SortExpression="Layer" />
                        <asp:TemplateField HeaderText="UrlEncodedContext">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("UrlEncodedContext") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext")) %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="ServiceType" HeaderText="ServiceType" SortExpression="ServiceType" />
                        <asp:BoundField DataField="ServiceVersion" HeaderText="(ServiceVersion)" SortExpression="ServiceVersion" />
                        <asp:BoundField DataField="ServiceHandler" HeaderText="ServiceHandler(=ServiceName)"
                            SortExpression="ServiceHandler" />
                    </Columns>
                </asp:GridView>
                <asp:XmlDataSource ID="XmlDataSource4_AllServicesView" runat="server" TransformFile="">
                </asp:XmlDataSource>
              <%--  <asp:TextBox ID="txtSelectedServices" runat="server" Height="157px" TextMode="MultiLine"
                    Width="301px"></asp:TextBox>--%>
                <br />
            </asp:View>
            <asp:View runat="server" ID="LocallyConfiguredServicesView">
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView1" runat="server" DataSourceID="XmlDataSource2_ConfiguredServicesView_InstanceConfigured"
                    AllowPaging="True" AutoGenerateColumns="False" CellPadding="4" CellSpacing="1"
                    Width="1012px" PageSize="15">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <%-- <asp:BoundField DataField="Id" HeaderText="Id" SortExpression="Id" />--%>
                        <asp:TemplateField>
                            <ItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </ItemTemplate>
                            <EditItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </EditItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Business Service Definition (BSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton1" runat="server" CommandName='<%# "InstanceConfiguredServicesView_ViewBSDL" %>'>View BSDL</asp:LinkButton>
                                <asp:Label ID="Label2" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Technical Service Definition (WSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton3" runat="server" CommandName='<%# "InstanceConfiguredServicesView_ViewWSDL" %>'>View WSDL</asp:LinkButton>
                                <asp:Label ID="Label3" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Generate Sample Request From BSDL">
                            <ItemTemplate>
                                <asp:LinkButton ID="LinkButton2" runat="server" CommandName='<%# "InstanceConfiguredServicesView_GenerateSampleRequestFromBSDL" %>'>Sample Request</asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" SortExpression="Index" />
                        <asp:BoundField DataField="Context" HeaderText="Context (Service)" SortExpression="Context" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="AlwaysExecute" HeaderText="AlwaysExecute" SortExpression="AlwaysExecute" />
                        <asp:BoundField DataField="Layer" HeaderText="Layer" SortExpression="Layer" />
                        <asp:TemplateField HeaderText="UrlEncodedContext">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("UrlEncodedContext") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext")) %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="ServiceType" HeaderText="ServiceType" SortExpression="ServiceType" />
                    </Columns>
                </asp:GridView>
                <asp:XmlDataSource ID="XmlDataSource2_ConfiguredServicesView_InstanceConfigured"
                    runat="server" TransformFile="~/Authenticated/System/XMLConfigurationFiles/ServicePipelineTransform.xslt">
                </asp:XmlDataSource>
            </asp:View>
            <asp:View runat="server" ID="View1">
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView5" runat="server" DataSourceID="XmlDataSource3_ConfiguredServicesView_LocallyConfigured"
                    AllowPaging="True" AutoGenerateColumns="False" CellPadding="4" CellSpacing="1"
                    Width="1012px" PageSize="15">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <%-- <asp:BoundField DataField="Id" HeaderText="Id" SortExpression="Id" />--%>
                        <asp:TemplateField>
                            <ItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </ItemTemplate>
                            <EditItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" />
                            </EditItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Business Service Definition (BSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton1" runat="server" CommandName='<%# "LocallyConfiguredServicesView_ViewBSDL" %>'>View BSDL</asp:LinkButton>
                                <asp:Label ID="Label2" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Technical Service Definition (WSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton3" runat="server" CommandName='<%# "LocallyConfiguredServicesView_ViewWSDL" %>'>View WSDL</asp:LinkButton>
                                <asp:Label ID="Label3" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Generate Sample Request From BSDL">
                            <ItemTemplate>
                                <asp:LinkButton ID="LinkButton2" runat="server" CommandName='<%# "LocallyConfiguredServicesView_GenerateSampleRequestFromBSDL" %>'>Sample Request</asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" SortExpression="Index" />
                        <asp:BoundField DataField="Context" HeaderText="Context (Service)" SortExpression="Context" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="AlwaysExecute" HeaderText="AlwaysExecute" SortExpression="AlwaysExecute" />
                        <asp:BoundField DataField="Layer" HeaderText="Layer" SortExpression="Layer" />
                        <asp:TemplateField HeaderText="UrlEncodedContext">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("UrlEncodedContext") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext")) %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="ServiceType" HeaderText="ServiceType" SortExpression="ServiceType" />
                    </Columns>
                </asp:GridView>
                <asp:XmlDataSource ID="XmlDataSource3_ConfiguredServicesView_LocallyConfigured" runat="server"
                    TransformFile=""></asp:XmlDataSource>
                <br />
                <asp:XmlDataSource ID="XmlDataSource1" runat="server"></asp:XmlDataSource>
                <asp:TreeView ID="TreeView2" runat="server" DataSourceID="" Visible="False" Enabled="False">
                    <DataBindings>
                        <asp:TreeNodeBinding DataMember="ESBServices" Text="ESB Services" Value="ESB Services" />
                        <asp:TreeNodeBinding DataMember="Service" NavigateUrlField="Url" TextField="Context" />
                    </DataBindings>
                </asp:TreeView>
            </asp:View>
            <asp:View runat="server" ID="ConventionOverConfigurationServicesView">
                Convention Over Configuration Services Base Path =
                <asp:Label ID="lblBaseConventionOverConfigurationServicesPath" runat="server" Text="Label"></asp:Label><br />
                Note that the Version Number is also included as part of the Context.
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView2" runat="server" AllowPaging="True"
                    AutoGenerateColumns="False" BackColor="White" BorderColor="#3366CC" BorderStyle="None"
                    BorderWidth="1px" CellPadding="4" Width="1012px" AllowSorting="True" EnableViewState="False"
                    PageSize="15">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <%-- <asp:BoundField DataField="Id" HeaderText="Id" SortExpression="Id" />--%>
                        <asp:CheckBoxField />
                        <asp:TemplateField HeaderText="View Business Service Definition (BSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton1" runat="server" CommandName='<%# "ConventionServicesView_ViewBSDL" %>'
                                    CausesValidation="False">View BSDL</asp:LinkButton>
                                <asp:Label ID="Label2" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="View Technical Service Definition (WSDL)">
                            <ItemTemplate>
                                <%--<asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl='<%# "~/authenticated/system/xmlconfigurationfiles/urlencodeandshowservicedefinition.aspx?UrlEncodedContext=" & System.Web.HttpUtility.UrlEncode(System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext"))) %>'
                                    Text='View Service Definition'></asp:HyperLink>--%>
                                <asp:LinkButton ID="LinkButton3" runat="server" CommandName='<%# "ConventionServicesView_ViewWSDL" %>'
                                    CausesValidation="False">View WSDL</asp:LinkButton>
                                <asp:Label ID="Label3" runat="server"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Generate Sample Request From BSDL">
                            <ItemTemplate>
                                <asp:LinkButton ID="LinkButton2" runat="server" CommandName='<%# "ConventionServicesView_GenerateSampleRequestFromBSDL" %>'
                                    CausesValidation="False">Sample Request</asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" SortExpression="Index" />
                        <asp:BoundField DataField="Context" HeaderText="Context (Service)" SortExpression="Context" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="AlwaysExecute" HeaderText="AlwaysExecute" SortExpression="AlwaysExecute" />
                        <asp:BoundField DataField="Layer" HeaderText="Layer" SortExpression="Layer" />
                        <asp:TemplateField HeaderText="UrlEncodedContext">
                            <%--<EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("UrlEncodedContext") %>'></asp:TextBox>
                            </EditItemTemplate>--%>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# System.Web.HttpUtility.UrlEncode(DataBinder.Eval(Container.DataItem,"UrlEncodedContext")) %>'
                                    CausesValidation="False"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="ServiceType" HeaderText="ServiceType" SortExpression="ServiceType" />
                        <asp:BoundField DataField="ServiceVersion" HeaderText="(ServiceVersion)" SortExpression="ServiceVersion" />
                        <asp:BoundField DataField="ServiceHandler" HeaderText="ServiceHandler(=ServiceName)"
                            SortExpression="ServiceHandler" />
                    </Columns>
                </asp:GridView>
                <!--<asp:XmlDataSource ID="XmlDataSource3" runat="server"></asp:XmlDataSource>-->
                <br />
            </asp:View>
            <asp:View runat="server" ID="ConfiguredItemsTreeView">
                <asp:Button ID="btnShowItems" runat="server" Width="250px" Height="26px" Text="Show Configured Items"
                    ForeColor="Blue" Font-Size="XX-Small" CausesValidation="False"></asp:Button>
                <asp:Label ID="Label4" runat="server" ForeColor="Blue" Font-Bold="True" Font-Size="XX-Small"
                    Height="18px" Width="161px">Expanded Tree Node Levels</asp:Label>
                <asp:TextBox ID="txtNumwTreeLevelsToShow" runat="server" Wrap="False" Font-Size="XX-Small">2</asp:TextBox>
                <asp:TreeView ID="TreeView1" ShowExpandCollapse="true" ShowLines="true" runat="server"
                    Height="800px" Width="500px" ImageSet="XPFileExplorer" NodeIndent="15" ExpandDepth="3">
                    <ParentNodeStyle Font-Bold="False" />
                    <HoverNodeStyle Font-Underline="True" ForeColor="#6666AA" />
                    <SelectedNodeStyle BackColor="#B5B5B5" Font-Underline="False" HorizontalPadding="0px"
                        VerticalPadding="0px" />
                    <NodeStyle Font-Names="Tahoma" Font-Size="8pt" ForeColor="Black" HorizontalPadding="2px"
                        NodeSpacing="0px" VerticalPadding="2px" />
                </asp:TreeView>
            </asp:View>
            <asp:View runat="server" ID="RawXMLView">
                <asp:Label ID="Label3" runat="server" Font-Size="X-Small" ForeColor="Blue">Config File Path</asp:Label><asp:Button
                    ID="btnSave" runat="server" Font-Size="XX-Small" Height="26px" ForeColor="Blue"
                    Font-Bold="True" Text="Save" Width="116px"></asp:Button><asp:TextBox ID="txtCfgFilePath"
                        runat="server" Height="26px" Width="760px" ForeColor="Blue" Font-Size="XX-Small"></asp:TextBox><asp:Button
                            ID="btnLoad" runat="server" Font-Size="XX-Small" Height="26px" ForeColor="Blue"
                            Font-Bold="True" Text="ReLoad" Width="121px"></asp:Button>
                <asp:Button ID="btnFormatXml" runat="server" Font-Bold="True" Font-Size="XX-Small"
                    ForeColor="Blue" Height="26px" Text="Format XML (Pretty Indent)" Width="143px" />
                <asp:TextBox ID="ctlRawCfgTextBox" runat="server" Height="360px" Width="720px" TextMode="MultiLine"
                    Wrap="False" Font-Size="XX-Small"></asp:TextBox>
            </asp:View>
            <asp:View runat="server" ID="ConfiguredServiceHandlersGridPage">
                <asp:Button ID="btnPopulateGrid" runat="server" Width="250px" Height="26px" Text="Show Configured Items"
                    ForeColor="Blue" Font-Size="XX-Small"></asp:Button>
                <asp:CheckBox ID="chkFilterDuplicates" runat="server" ForeColor="Blue" Font-Bold="True"
                    Font-Size="XX-Small" Text="Filter Duplicates"></asp:CheckBox>
                <asp:Label ID="Label1" runat="server" Font-Size="XX-Small" Font-Bold="True" ForeColor="Blue"
                    Height="15px" Width="110px">Num Rows Per Page</asp:Label><asp:TextBox ID="txtNumRowsPerPage"
                        runat="server" Width="40px" Font-Size="XX-Small">100</asp:TextBox>&nbsp;<br />
                <br />
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView3" runat="server" AllowPaging="True"
                    AutoGenerateColumns="False" BackColor="White" BorderColor="#3366CC" BorderStyle="None"
                    BorderWidth="1px" CellPadding="4" Width="1012px" PageSize="15">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>
            </asp:View>
            <asp:View runat="server" ID="SendRequest">
                <uc1:SendRequestUserControl ID="SendRequestUserControl1" runat="server" />
            </asp:View>
        </asp:MultiView>
        &nbsp;&nbsp;
    </p>
    </form>
</body>
</html>
