﻿
Partial Class Logon_Default
    Inherits System.Web.UI.Page

    Protected Sub Login1_Authenticate(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.AuthenticateEventArgs) Handles Login1.Authenticate
        Dim Authenticated As Boolean
        Authenticated = CustomAuthenticateE(Login1.UserName, Login1.Password)

        e.Authenticated = Authenticated

    End Sub

    Private Function CustomAuthenticateE(ByVal sUserName As String, ByVal sPassword As String) As Boolean
        'Authenticate to XML
        Dim MyXMLDocument As System.Xml.XmlDocument
        MyXMLDocument = New System.Xml.XmlDocument()

        Dim sPath As String
       sPath = Server.MapPath(Request.ApplicationPath) + "\Logon\Users.config"

        Dim bValidCredentials As Boolean

        bValidCredentials = False

        Try

            MyXMLDocument.Load(sPath)

            Dim MyXpath As String
            MyXpath = "/configuration/user"

            Dim MyNodeList As System.Xml.XmlNodeList
            Dim MyNode As System.Xml.XmlNode
            Dim sName As String
            Dim sPwd As String

            MyNodeList = MyXMLDocument.SelectNodes(MyXpath)

            For Each MyNode In MyNodeList
                sName = MyNode.Attributes("name").InnerXml.ToString
                sPwd = MyNode.Attributes("password").InnerXml.ToString
                If sName = sUserName Then
                    'found user
                    Dim sHashedPassword As String
                    sHashedPassword = FormsAuthentication.HashPasswordForStoringInConfigFile(sPassword, "sha1")
                    If sHashedPassword = sPwd Then
                        'password match!
                        bValidCredentials = True

                        Exit For
                    End If
                End If
            Next

            Return bValidCredentials
        Catch e As Exception

        Finally

        End Try

    End Function
End Class
