<%@ Control Language="VB" AutoEventWireup="false" CodeFile="ViewLogsControl.ascx.vb" Inherits="UserControls_ViewLogsControl" %>
<asp:Menu ID="Menu1" runat="server" BackColor="#F7F6F3" DynamicHorizontalOffset="2"
    Font-Names="Verdana" Font-Size="1.0em" ForeColor="#7C6F57" Orientation="Horizontal"
    StaticSubMenuIndent="10px" Width="477px">
    <Items>
        <asp:MenuItem Text="Requests" Value="0"></asp:MenuItem>
        <asp:MenuItem Text="Request Details" Value="1"></asp:MenuItem>
        <asp:MenuItem Text="Request Trace" Value="2"></asp:MenuItem>
    </Items>
    <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
    <DynamicHoverStyle BackColor="#7C6F57" ForeColor="White" />
    <DynamicMenuStyle BackColor="#F7F6F3" />
    <StaticSelectedStyle BackColor="#5D7B9D" />
    <DynamicSelectedStyle BackColor="#5D7B9D" />
    <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
    <StaticHoverStyle BackColor="#7C6F57" ForeColor="White" />
</asp:Menu>
<asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
    <asp:View ID="View1" runat="server">
        <strong><span style="color: blue">Request List</span></strong><asp:GridView ID="GridView1"
            runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False"
            DataKeyNames="index" DataSourceID="SqlDataSource1">
            <Columns>
                <asp:CommandField ShowSelectButton="True" />
                <asp:BoundField DataField="index" HeaderText="index" InsertVisible="False" ReadOnly="True"
                    SortExpression="index" />
                <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                <asp:BoundField DataField="InternalMessageID" HeaderText="InternalMessageID" SortExpression="InternalMessageID" />
                <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
            </Columns>
        </asp:GridView>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
            SelectCommand="SELECT [index], [LogTime], [MessageID], [InternalMessageID], [ActivityID], [ResolveName], [Context], [RequestSourceHost], [Duration], [Status], [UserName] FROM [ESBLogSummary] ORDER BY [index], [LogTime], [InternalMessageID]">
        </asp:SqlDataSource>
        <br />
        <span style="color: blue"><strong>Activities for Selected Request</strong>&nbsp;</span>
        <asp:GridView ID="GridView2" runat="server" AllowPaging="True" AllowSorting="True"
            AutoGenerateColumns="False" DataKeyNames="index" DataSourceID="SqlDataSource2">
            <Columns>
                <asp:CommandField ShowSelectButton="True" />
                <asp:BoundField DataField="index" HeaderText="index" InsertVisible="False" ReadOnly="True"
                    SortExpression="index" />
                <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                <asp:BoundField DataField="InternalMessageID" HeaderText="InternalMessageID" SortExpression="InternalMessageID" />
                <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                <asp:BoundField DataField="RequestXML" HeaderText="RequestXML" SortExpression="RequestXML" />
                <asp:BoundField DataField="ResponseXML" HeaderText="ResponseXML" SortExpression="ResponseXML" />
            </Columns>
        </asp:GridView>
        <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
            SelectCommand="SELECT [index], [LogTime], [MessageID], [InternalMessageID], [ActivityID], [ResolveName], [Context], [RequestSourceHost], [Duration], [Status], [UserName], [RequestXML], [ResponseXML] FROM [ESBLogSummary] WHERE ([InternalMessageID] = (select [InternalMessageID] FROM [ESBLogSummary] WHERE [index] = @index))">
            <SelectParameters>
                <asp:ControlParameter ControlID="GridView1" Name="index" PropertyName="SelectedValue"
                    Type="String" />
            </SelectParameters>
        </asp:SqlDataSource>
    </asp:View>
    <asp:View ID="View2" runat="server">
        <br />
        <span style="color: blue"><strong>Trace for Selected Activity</strong>&nbsp;</span>
        <asp:GridView ID="GridView3" runat="server" AllowSorting="True" AutoGenerateColumns="False"
            DataKeyNames="Index" DataSourceID="SqlDataSource3">
            <Columns>
                <asp:CommandField ShowSelectButton="True" />
                <asp:BoundField DataField="Index" HeaderText="Index" InsertVisible="False" ReadOnly="True"
                    SortExpression="Index" />
                <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                <asp:BoundField DataField="InternalMessageID" HeaderText="InternalMessageID" SortExpression="InternalMessageID" />
                <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                <asp:BoundField DataField="SourceCodeLocationDetails" HeaderText="SourceCodeLocationDetails"
                    SortExpression="SourceCodeLocationDetails" />
                <asp:BoundField DataField="SourceCodeMethodDetails" HeaderText="SourceCodeMethodDetails"
                    SortExpression="SourceCodeMethodDetails" />
                <asp:BoundField DataField="ProcessID" HeaderText="ProcessID" SortExpression="ProcessID" />
                <asp:BoundField DataField="ThreadID" HeaderText="ThreadID" SortExpression="ThreadID" />
                <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                <asp:BoundField DataField="ComputerName" HeaderText="ComputerName" SortExpression="ComputerName" />
                <asp:BoundField DataField="LogLevel" HeaderText="LogLevel" SortExpression="LogLevel" />
                <asp:BoundField DataField="LogText" HeaderText="LogText" SortExpression="LogText" />
                <asp:BoundField DataField="LogSummary" HeaderText="LogSummary" SortExpression="LogSummary" />
                <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
            </Columns>
        </asp:GridView>
        <asp:SqlDataSource ID="SqlDataSource3" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
            SelectCommand="SELECT [Index], [LogTime], [MessageID], [InternalMessageID], [ActivityID], [ResolveName], [Context], [SourceCodeLocationDetails], [SourceCodeMethodDetails], [ProcessID], [ThreadID], [RequestSourceHost], [UserName], [ComputerName], [LogLevel], [LogText], [LogSummary], [Status] FROM [ESBLog] WHERE ([ActivityID] = (select [ActivityID] FROM [ESBLogSummary] WHERE [Index] = @Index)) ORDER BY [Index]">
            <SelectParameters>
                <asp:ControlParameter ControlID="GridView2" Name="Index" PropertyName="SelectedValue"
                    Type="Int32" />
            </SelectParameters>
        </asp:SqlDataSource>
    </asp:View>
    <asp:View ID="View3"   runat="server">
        &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
        <asp:TextBox ID="TextBox2" runat="server" Height="100%" TextMode="MultiLine" Width="100%"
            Wrap="False"></asp:TextBox>
        &nbsp;<br />
        <br />
        <br />
        <asp:GridView ID="GridView4" runat="server" AutoGenerateColumns="False" DataSourceID="SqlDataSource4"
            Visible="False">
            <Columns>
                <asp:BoundField DataField="LogText" HeaderText="LogText" HtmlEncode="False" SortExpression="LogText" />
            </Columns>
        </asp:GridView>
        &nbsp; &nbsp; &nbsp;&nbsp; &nbsp;&nbsp;
        <asp:SqlDataSource ID="SqlDataSource4" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
            SelectCommand="SELECT [LogText] FROM [ESBLog] WHERE ([Index] = @Index)">
            <SelectParameters>
                <asp:ControlParameter ControlID="GridView3" Name="Index" PropertyName="SelectedValue"
                    Type="Int32" />
            </SelectParameters>
        </asp:SqlDataSource>
        &nbsp; &nbsp;&nbsp;
    </asp:View>
</asp:MultiView>&nbsp;
