
Partial Class UserControls_ViewLogsControl
    Inherits System.Web.UI.UserControl

    Dim m_sText As String

    Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
        MultiView1.ActiveViewIndex = Int32.Parse(e.Item.Value)

    End Sub

    Protected Sub GridView2_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowDataBound
        '  Make sure that this is a data row and not a header or footer.
        If e.Row.RowType = DataControlRowType.DataRow Then
            '  Get the value of the manager field.
            'Dim sStatusValue As String = CType(DataBinder.Eval(e.Row.DataItem, "Status"), String)
            Dim sStatusValue As String = CType(DataBinder.GetPropertyValue(e.Row.DataItem, "Status"), String)


            '  Set the text and background color.
            If sStatusValue = "eSuccess" Then
                'leave the color alone
            ElseIf sStatusValue = "eWarnings" Then
                e.Row.BackColor = System.Drawing.Color.Yellow
            ElseIf sStatusValue = "eErrors" Then
                e.Row.BackColor = System.Drawing.Color.Red
            ElseIf sStatusValue = "eFailed" Then
                e.Row.BackColor = System.Drawing.Color.OrangeRed
            ElseIf sStatusValue = "eInconsistentEnvelope" Then
                e.Row.BackColor = System.Drawing.Color.Orange
            ElseIf sStatusValue = "" Then
                e.Row.BackColor = System.Drawing.Color.Blue 'pending...?
            Else
                'Some sort of unknown error...
                e.Row.BackColor = System.Drawing.Color.DarkRed
            End If
        End If
    End Sub


    Protected Sub GridView2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView2.SelectedIndexChanged
        'when an activity  is selected...view the part of the Request Trace for it
        MultiView1.ActiveViewIndex = 1
    End Sub

    Protected Sub GridView3_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView3.RowDataBound
        '  Make sure that this is a data row and not a header or footer.
        If e.Row.RowType = DataControlRowType.DataRow Then
            '  Get the value of the manager field.
            'Dim sStatusValue As String = CType(DataBinder.Eval(e.Row.DataItem, "Status"), String)
            Dim sStatusValue As String = CType(DataBinder.GetPropertyValue(e.Row.DataItem, "Status"), String)

            '  Set the text and background color.
            If sStatusValue.ToUpper = "OK" Then
                'leave the color alone
            ElseIf sStatusValue.ToUpper = "WARNING" Then
                e.Row.BackColor = System.Drawing.Color.Yellow
            ElseIf sStatusValue.ToUpper = "ERROR" Then
                e.Row.BackColor = System.Drawing.Color.Red
            Else
                'Some sort of unknown error...
                e.Row.BackColor = System.Drawing.Color.DarkRed
            End If
        End If
    End Sub

    Protected Sub GridView3_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView3.SelectedIndexChanged
        'when a record in the Activity Trace is selected, show the LogText for it
        MultiView1.ActiveViewIndex = 2


    End Sub




    Protected Sub View3_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles View3.PreRender

        Dim x As New ESB.Core.XMLSchemaClasses.XMLUtil

        TextBox2.Text = x.PrettyFormatXML(GridView4.Rows(0).Cells(0).Text)

    End Sub
End Class
