USE [ESBLog]
GO

/****** Object:  Table [dbo].[Services.EnterprisePacks.Management.ESBServiceMetering]    Script Date: 05/10/2009 00:59:15 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Services.EnterprisePacks.Management.ESBServiceMetering](
	[Index] [bigint] IDENTITY(1,1) NOT NULL,
	[ResolveName] [nvarchar](1024) NULL,
	[Context] [nvarchar](1024) NULL,
	[UserName] [nvarchar](1024) NULL,
	[RequestInvocationCount] [bigint] NULL,
	[RequestPriority] [nvarchar](50) NULL,
	[RequestInvocationPeriod] [nvarchar](50) NULL,
	[MessageExchangePattern] [nvarchar](200) NULL,
	[host] [nvarchar](1024) NULL,
	[ESBInstanceName] [nvarchar](1024) NULL,
	[FullyQualifiedInstanceName] [nvarchar](1024) NULL,
	[ServiceDomainName] [nvarchar](1024) NULL,
	[ClusterName] [nvarchar](1024) NULL,
	[IsServiceDomainEntryPoint] [bit] NULL,
	[LastInvocation] [datetime] NULL,
	[FirstInvocation] [datetime] NULL,
	[Channel] [nvarchar](1024) NULL,
	[TransportProfile] [nvarchar](1024) NULL,
	[TransportType] [nvarchar](200) NULL,
	[TransportUrl] [nvarchar](1024) NULL,
	[ExecutionTime] [float] NULL,
	[ServiceInvocationCPUUsage] [float] NULL,
 CONSTRAINT [PK_Services.EnterprisePacks.Management.ESBServiceAccounting] PRIMARY KEY CLUSTERED 
(
	[Index] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Message ResolveName' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'ResolveName'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Message Context' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'Context'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'The Client that invoked the service - or alias to biller for service' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'UserName'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Number of times this service has been invoked by this client and with the specified ServicePriority, ServiceInvocationPeriod and MessageExchangePattern' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'RequestInvocationCount'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'eg. 1-10; 1=lowest, 10=highest' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'RequestPriority'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Peak, Off Peak, Standard...' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'RequestInvocationPeriod'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Synchronous, Asynchronous, Notification, Pub/Sub' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'MessageExchangePattern'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'Elapsed Execution Time in MilliSeconds' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'ExecutionTime'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'CPU Time used in MilliSeconds. To be used for Accounting Purposes' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering', @level2type=N'COLUMN',@level2name=N'ServiceInvocationCPUUsage'
GO

EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'Services.EnterprisePacks.Management.ESBServiceMetering'
GO

