


'''''''''''''''''''''''''''''''''''''''''''''''' ++ HELPER FUNCTIONS'''''''''''''''''''''''''''''''''''''''''''''''''
Dim WshShell
Set WshShell = WScript.CreateObject("WScript.Shell")


dim WshUserEnv
dim WshSysEnv
dim WshProcessEnv
dim WshVolatileEnv

    Set WshSysEnv = WshShell.Environment("System")
    Set WshUserEnv = WshShell.Environment("User")
    Set WshVolatileEnv = WshShell.Environment("Volatile")
    Set WshProcessEnv = WshShell.Environment("Process")

'Test

Sub Test()
'	sNewGUID = GetNewGUID
'	lSrcPos = InStr(sNewGUID, "{")
'    sNewGUID = Mid(sNewGUID, lSrcPos + 1)
'   
'    lSrcPos = InStr(sNewGUID, "}")
'    sNewGUID = Left(sNewGUID, lSrcPos - 1)
'   	
   	sNewGUID = GetNewGUIDWithoutBraces
	call ReplaceTextInFileCaseInsensitive ("C:\ESB\Dev\Source\ESB\Base\Setup\RegistryEntries\MSMQAssignTriggerToQ_PerESBInstance_AutoGen_TEMP.reg", "0b4badd8-9e87-4fa6-9104-50ff1603236d", sNewGUID , false)

End Sub

Sub InitVars()
	'On Error GoTo InitVarsErr

    GetCommandLine
    If UBound(ArgArray) >= 1 Then
        m_param0 = ArgArray(1)
    End If
    
    If UBound(ArgArray) >= 2 Then
        m_param1 = ArgArray(2)
    End If
        
        
    Exit Sub
        
InitVarsErr:
    MsgBox Err.Description & " " & Err.Number
End Sub




Function Run(cmd)
	Dim sCmd, sCmdExpanded
	Dim retcode
       
        sCmd = "CMD.exe /c " & cmd
	
	sCmdExpanded = WshShell.ExpandEnvironmentStrings(sCmd)

        retcode = WshShell.Run(sCmdExpanded, 2, True)
End Function

Function RunWithStartingDirectory(cmd, sStartingDirectory)
	Dim sCmd, sCmdExpanded
	Dim retcode
       
        sCmd = "cmd.exe /c start /d " & sStartingDirectory & " " & cmd
	
	sCmdExpanded = WshShell.ExpandEnvironmentStrings(sCmd)

	msgbox "about to run: " & sCmdExpanded
        retcode = WshShell.Run(sCmdExpanded, 1, True)
End Function


Public Function RunAsync(cmd)
        Dim sCmd
        sCmd = "CMD.exe /c " & cmd
        WshShell.Run sCmd, 1, False
End Function

Function GetEnviron(Env) 

    Dim sTmp

    If (WshUserEnv(Env)) <> "" Then
                sTmp = WshUserEnv(Env)
        ElseIf (WshSysEnv(Env)) <> "" Then
                sTmp = WshSysEnv(Env)
        ElseIf (WshVolatileEnv(Env)) <> "" Then
                sTmp = WshVolatileEnv(Env)
        ElseIf (WshProcessEnv(Env)) <> "" Then
                sTmp = WshProcessEnv(Env)
        End If
        
        GetEnviron = sTmp

End Function

Function SetPath(Env) 
    Dim sPath
    Dim sCILPath

    Dim sTest
    Dim lPos
    
	'add bin to Env
	sCILPath = Env
	
	sPath = WshSysEnv("PATH")

	If InStr(UCase(sPath), UCase(sCILPath)) = 0 then
		'add it to PATH
		'find last character of the path
		lPos = InStrRev(sPath, ";")
		if lPos = Len(sPath) then
			WshSysEnv("PATH") = sPath & sCILPath & ";"
		Else
			WshSysEnv("PATH") = sPath & ";" & sCILPath & ";"
		End If	
	End If
	
End Function

Function ReadWriteFile (sFileName, sIPAddress)
   Const ForReading = 1, ForWriting = 2
   Dim fso, f
   Dim SUdlText
   Dim lSrcPos

   Dim lSrcPosEnd
   Dim sSrcText
   Dim sTmp

   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.OpenTextFile(sFileName, ForReading)
   sUdlText =   f.ReadAll

   lSrcPos = InStr(SUdlText, "Source")
   sSrcText = Mid(sUdlText, lSrcPos)

   lSrcPos = InStr(sSrcText, "=")
   lSrcPosEnd = InStr(sSrcText, ";")

   sTmp = sSrcText
   if lSrcPosEnd > 0 then
      sSrcText= Mid(sTmp, lSrcPos+1, lSrcPosEnd - lSrcPos - 1)
   else
      sSrcText= Mid(sTmp, lSrcPos+1)
   end if

   sTmp = Replace(sUdlText, sSrcText, sIPAddress)


   Set f = fso.OpenTextFile(sFileName, ForWriting, True)
   f.Write sTmp

End Function

Function UpdateUDLFiles(sEnv, sIPAddress)

   dim sUDLLocation
   dim sBizTalkUDL
   dim sLogOleDBUDL
   dim sUdlText

   sUDLLocation = sEnv & "\Install\MiddleTier\Database"

   sBizTalkUDL = sUDLLocation & "\BIZTALK.udl"		
   sLogOleDBUDL = sUDLLocation & "\LOGOLEDB.udl"		

   ReadWriteFile sBizTalkUDL, sIPAddress
   ReadWriteFile sLogOleDBUDL, sIPAddress


End Function


Function GetFirstIPAddress()

dim NetworkAdapter 
dim sIPAddress
dim lPos

for each NetworkAdapter in GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf ("Win32_NetworkAdapterConfiguration")
   if not NetworkAdapter Is  Nothing Then
        On Error Resume Next
	sIPAddress = CSTR(NetworkAdapter.IPAddress(0))

	lPos = len(sIPAddress)

	if (len(sIPAddress) > 0) then
	   if (sIPAddress <> "") and (sIPAddress <> "0.0.0.0") then	
		
		if (false = isempty(lPos) ) then
			GetFirstIPAddress = sIPAddress
			Exit Function
		end if
	   end if
	end if
   end if
Next

	GetFirstIPAddress = ""

End Function



Function ReplaceTextInFile (sFileName, sSearchText, sReplaceText, bMakeBackup)
   Const ForReading = 1, ForWriting = 2
   Dim fso, f
   Dim sFileText
   Dim lSrcPos

   Dim lSrcPosEnd
   Dim sSrcText
   Dim sTmp

   if bMakeBackup = true then
	   Run "copy " & sFileName & " "  & sFileName & ".bak"
   end if

   Set fso = CreateObject("Scripting.FileSystemObject")

   Set f = fso.OpenTextFile(sFileName, ForReading )
   sFileText =   f.ReadAll
  
   sSrcText = sSearchText

   sTmp = Replace(sFileText, sSrcText, sReplaceText)

   Set f = fso.OpenTextFile(sFileName, ForWriting, True)
   f.Write sTmp
   f.close()
	   
End Function

Function ReplaceTextInFileCaseInsensitive (sFileName, sSearchText, sReplaceText, bMakeBackup)
   Const ForReading = 1, ForWriting = 2
   Dim fso, f
   Dim sFileText
   Dim lSrcPos

   Dim lSrcPosEnd
   Dim sSrcText
   Dim sTmp

   if bMakeBackup = true then
	   Run "copy " & sFileName & " "  & sFileName & ".bak"
   end if

   Set fso = CreateObject("Scripting.FileSystemObject")

   Set f = fso.OpenTextFile(sFileName, ForReading )
   sFileText =   f.ReadAll
  
   sSrcText = sSearchText

   sTmp = ReplaceCaseInsensitive(sFileText, sSrcText, sReplaceText)

   Set f = fso.OpenTextFile(sFileName, ForWriting, True)
   f.Write sTmp
   f.close()
	   
End Function

Function ReplaceCaseInsensitive(SrcString, searchStr, replStr)
  Dim regEx, str1, patrn               ' Create variables.
  Set regEx = New RegExp            ' Create regular expression.
  regEx.Pattern = searchStr            ' Set pattern.
  regEx.Global = True				 'Apply to all occurrences...
  regEx.IgnoreCase = True            ' Make case insensitive.
  ReplaceCaseInsensitive = regEx.Replace(SrcString, replStr)   ' Make replacement.
End Function

Function GetNewGUID()
	Set TypeLib = CreateObject("Scriptlet.TypeLib")
	GetNewGUID = TypeLib.Guid
End Function

Function GetNewGUIDWithoutBraces()
	Set TypeLib = CreateObject("Scriptlet.TypeLib")
	sNewGUID = TypeLib.Guid
	
	lSrcPos = InStr(sNewGUID, "{")
    sNewGUID = Mid(sNewGUID, lSrcPos + 1)
   
    lSrcPos = InStr(sNewGUID, "}")
    GetNewGUIDWithoutBraces = Left(sNewGUID, lSrcPos - 1)

End Function

	

Sub WriteToLog(str_in)

	Set ofs = WScript.CreateObject("Scripting.FileSystemObject") 
	Set oPrinter = ofs.OpenTextFile("C:\SetupLog.txt",8,True,0) 
	oPrinter.WriteLine now & " --- " & str_in 
	oPrinter.Close 

End Sub

Sub ShowLogFile()
	Set oShell = WScript.CreateObject ("WScript.Shell")
	oShell.Run "iexplore.exe C:\SetupLog.txt"
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''' -- HELPER FUNCTIONS'''''''''''''''''''''''''''''''''''''''''''''''''
