REM Usage: Setup_Instance.cmd SQLInstance ESBServiceUserPassword ESBManagementUserPassword ESBInstanceName <WebSite Name>
REM eg.Setup_Instance.cmd localhost\esb S3rviceP@$sword M@n@g3m39tP@s$word Source <"Default Web Site">
echo on

set instanceName=%4
if dummy%4==dummy set instanceName=Source

echo %instanceName%
rem pause
REM set instanceName=Source
REM set instanceName=PubSub


REM ------Default Passwords-----
set ESBServiceUserPassword=%2
if dummy%3==dummy set ESBServiceUserPassword=Service3SB

set ESBManagementUserPassword=%3
if dummy%3==dummy set ESBManagementUserPassword=Management3SB
REM ------------

set IISVer=7

REM - Dodgy test for IIS7...
IF dummy==dummy%ProgramData% GOTO SetIIS6 
goto Continue

:SetIIS6
set IISVer=6

echo %IISVer%

set instance=%instanceName%

REM - Setup ESB.NET Instance - Create App Pools
REM - IIS Application Pools for ESB.NET - ESBServerAppPool and ESBMangementAppPool (using above accounts)

:Continue

if %IISVer%==7 goto IIS7

set instance=%instanceName%

:IIS7

REM 'USAGE: Remove.wsf SQLInstanceName ESBInstanceName ESBServiceUsername  ESBServicePassword  ESBMangementUsername  ESBManagementPassword ESBWebSite  
Remove.wsf %1 -i %instance% ESBService %ESBServiceUserPassword% ESBManagement %ESBManagementUserPassword% %5

set instance=%instanceName%

%windir%\system32\inetsrv\appcmd  delete apppool /apppool.name:%instance%_ESBServiceAppPool
%windir%\system32\inetsrv\appcmd  delete apppool /apppool.name:%instance%_ESBAsyncLoggerAppPool
%windir%\system32\inetsrv\appcmd  delete apppool /apppool.name:%instance%_ESBManagementAppPool

set instance=%instanceName%



goto end

:IIS6
REM IIS6 removal not supported.
REM Remove.wsf -i %instance% ESBService %ESBServiceUserPassword% ESBManagement %ESBManagementUserPassword%


:end

