REM Usage: Setup_Instance.cmd SQLInstance ESBServiceUserPassword ESBManagementUserPassword ESBInstanceName <WebSite Name> First|Next
REM eg.Setup_Instance.cmd localhost\esb S3rviceP@$sword M@n@g3m39tP@s$word Source <"Default Web Site"> First
echo on

set instanceName=%4
if dummy%4==dummy set instanceName=Source

echo %instanceName%
rem pause
REM set instanceName=Source
REM set instanceName=PubSub


REM ------Default Passwords-----
set ESBServiceUserPassword=%2
if dummy%3==dummy set ESBServiceUserPassword=Service3SB

set ESBManagementUserPassword=%3
if dummy%3==dummy set ESBManagementUserPassword=Management3SB
REM ------------

set IISVer=7

REM - Dodgy test for IIS7...
IF dummy==dummy%ProgramData% GOTO SetIIS6 
goto Continue

:SetIIS6
set IISVer=6

echo %IISVer%

set instance=%instanceName%

REM - Setup ESB.NET Instance - Create App Pools
REM - IIS Application Pools for ESB.NET - ESBServerAppPool and ESBMangementAppPool (using above accounts)

:Continue

if %IISVer%==7 goto IIS7

set instance=%instanceName%

:IIS7
REM pause
REM IIS7 should use integrated...apppool...
set instance=%instanceName%

%windir%\system32\inetsrv\appcmd  add apppool /name:%instance%_ESBServiceAppPool
%windir%\system32\inetsrv\appcmd  set apppool %instance%_ESBServiceAppPool /managedRuntimeVersion:v4.0

%windir%\system32\inetsrv\appcmd  add apppool /name:%instance%_ESBAsyncLoggerAppPool
%windir%\system32\inetsrv\appcmd  set apppool %instance%_ESBAsyncLoggerAppPool /managedRuntimeVersion:v4.0 /autoStart:true /startMode:AlwaysRunning

%windir%\system32\inetsrv\appcmd  add apppool /name:%instance%_ESBManagementAppPool
%windir%\system32\inetsrv\appcmd  set apppool %instance%_ESBManagementAppPool /managedRuntimeVersion:v4.0


REM pause
set instance=%instanceName%
REM pause
REM - Set the user account for these app pools to the users created above...

REM - ESBService
%windir%\system32\inetsrv\appcmd set config /section:applicationPools /[name='%instance%_ESBServiceAppPool'].processModel.identityType:SpecificUser /[name='%instance%_ESBServiceAppPool'].processModel.userName:.\ESBService /[name='%instance%_ESBServiceAppPool'].processModel.password:%ESBServiceUserPassword%

REM - ESBManagement
%windir%\system32\inetsrv\appcmd set config /section:applicationPools /[name='%instance%_ESBManagementAppPool'].processModel.identityType:SpecificUser /[name='%instance%_ESBManagementAppPool'].processModel.userName:.\ESBManagement /[name='%instance%_ESBManagementAppPool'].processModel.password:%ESBManagementUserPassword%

REM - ESBAsyncLogger
%windir%\system32\inetsrv\appcmd set config /section:applicationPools /[name='%instance%_ESBAsyncLoggerAppPool'].processModel.identityType:SpecificUser /[name='%instance%_ESBAsyncLoggerAppPool'].processModel.userName:.\ESBService /[name='%instance%_ESBAsyncLoggerAppPool'].processModel.password:%ESBServiceUserPassword%

set instance=%instanceName%

REM set this again, as it seems to get lost somewhere above...
set instance=%instanceName%


REM 'USAGE: Setup.wsf SQLInstanceName ESBInstanceName ESBServiceUsername  ESBServicePassword  ESBMangementUsername  ESBManagementPassword ESBWebSite  
Setup.wsf %1 -i %instance% ESBService %ESBServiceUserPassword% ESBManagement %ESBManagementUserPassword% %5 %6

goto end

:IIS6
Setup.wsf -i %instance% ESBService %ESBServiceUserPassword% ESBManagement %ESBManagementUserPassword%


:end