Option Strict On
Option Explicit On 


Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.IO

Public Class SqlLogWriter



    Public Function SetData(ByRef sLogData As String) As String
        Dim hireDate As DateTime = DateTime.Parse("21/5/1999")
        AddEmployee("Jones", "Mary", "Sales Representative", hireDate, 5, "C:\Data\Users\MINA\Pictures\Frantzis2.jpg")
    End Function

    Public Function SetLogData(ByRef sLogData As String) As String
        'Dim hireDate As DateTime = DateTime.Parse("21/5/1999")
        If sLogData = "" Then
            sLogData = "some bloody long log text string goes here. try & make it reaaally long"
        End If
        AddLog(7, "02/05/2004", "Some Log Summary text", sLogData, "PID", "TID", "SomeUserNAme", "and a ComputerName")
    End Function

    Public Function GetLogData() As String
        Dim LogConn As SqlConnection
        Try

            LogConn = New SqlConnection("Data Source=localhost; Integrated Security=SSPI; Initial Catalog=ESBLog;")
            Dim getLog As New SqlCommand("Select LogText from  ESBLog where [Index]=1;", LogConn)
            LogConn.Open()

            Return CType(getLog.ExecuteScalar(), String)
        Catch ex As Exception
            MsgBox(ex.ToString)
        Finally

            LogConn.Close()
        End Try
    End Function


    Public Sub AddEmployee(ByVal lastName As String, ByVal firstName As String, ByVal title As String, ByVal hireDate As DateTime, ByVal reportsTo As Integer, ByVal photoFilePath As String)
        Dim photo As Byte() = GetPhoto(photoFilePath)

        Dim nwindConn As SqlConnection = New SqlConnection("Data Source=localhost; Integrated Security=SSPI; Initial Catalog=Northwind;")
        Dim addEmp As New SqlCommand("INSERT INTO Employees (LastName, FirstName, Title, HireDate, ReportsTo, Photo) " + _
                                      "Values(@LastName, @FirstName, @Title, @HireDate, @ReportsTo, @Photo)", nwindConn)

        addEmp.Parameters.Add("@LastName", SqlDbType.NVarChar, 20).Value = lastName
        addEmp.Parameters.Add("@FirstName", SqlDbType.NVarChar, 10).Value = firstName
        addEmp.Parameters.Add("@Title", SqlDbType.NVarChar, 30).Value = title
        addEmp.Parameters.Add("@HireDate", SqlDbType.DateTime).Value = hireDate
        addEmp.Parameters.Add("@ReportsTo", SqlDbType.Int).Value = reportsTo

        addEmp.Parameters.Add("@Photo", SqlDbType.Image, photo.Length).Value = photo

        nwindConn.Open()

        addEmp.ExecuteNonQuery()

        nwindConn.Close()
    End Sub
    Public Function GetPhoto(ByVal filePath As String) As Byte()
        Dim fs As FileStream = New FileStream(filePath, FileMode.Open, FileAccess.Read)
        Dim br As New BinaryReader(fs)

        Dim photo As Byte() = br.ReadBytes(CType(fs.Length, Integer))

        br.Close()
        fs.Close()

        Return photo
    End Function

    Public Sub AddLog(ByVal nLogLevel As Integer, ByVal sLogTime As String, ByRef sLogSummary As String, ByRef sLogText As String, ByVal sProcessID As String, ByVal sThreadID As String, ByVal sUserName As String, ByVal sComputerName As String)
        Dim LogConn As SqlConnection
        Try

            LogConn = New SqlConnection("Data Source=localhost; Integrated Security=SSPI; Initial Catalog=ESBLog;")
            Dim addEmp As New SqlCommand("INSERT INTO ESBLog ( LogLevel, LogTime, LogSummary, LogText, ProcessID, ThreadID,UserName,ComputerName) " + _
                                           "Values(@LogLevel, @LogTime, @LogSummary, @LogText, @ProcessID, @ThreadID, @UserName, @ComputerName)", LogConn)

            Dim sIndex As String
            LogConn.Open()


            'addEmp.Parameters.Add("@Index", SqlDbType.Int).Value = nIndex
            addEmp.Parameters.Add("@LogLevel", SqlDbType.Int).Value = nLogLevel
            addEmp.Parameters.Add("@LogTime", SqlDbType.NVarChar).Value = sLogTime
            addEmp.Parameters.Add("@LogSummary", SqlDbType.NVarChar).Value = sLogSummary
            addEmp.Parameters.Add("@LogText", SqlDbType.NText).Value = sLogText
            addEmp.Parameters.Add("@ProcessID", SqlDbType.NVarChar).Value = sProcessID
            addEmp.Parameters.Add("@ThreadID", SqlDbType.NVarChar).Value = sThreadID
            addEmp.Parameters.Add("@UserName", SqlDbType.NVarChar).Value = sUserName
            addEmp.Parameters.Add("@ComputerName", SqlDbType.NVarChar).Value = sComputerName


            addEmp.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox(ex.ToString)
        Finally

            LogConn.Close()
        End Try
    End Sub
End Class