Imports System.Net

Public Class ProxyAwareSender
    Inherits BaseSend

    Public Overrides Sub ProcessMsgAsync(ByVal oEnv As IEnvelope)
        StartMethod()
        MyBase.ProcessMsgAsync(oEnv)

    End Sub
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()
        Return MyBase.ProcessMsgSync(oEnv)
        EndMethod()
    End Function
    Public Overridable Sub SetProxyServerSettings(ByRef oProxy As System.Net.IWebProxy)
        If System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.Enabled") = "1" Then
            Dim tmpProxy As WebProxy
            ' Create a new Network Credentials item
            Dim ProxyCredentials As NetworkCredential

            ' Fill Proxy info from host settings
            tmpProxy = New WebProxy(CType(System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.IPAddress"), String), Convert.ToInt32(System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.Port")))
            tmpProxy.BypassProxyOnLocal = True

            If Not CType(System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.Username"), String) = "" Then
                ' Fill the credential info from host settings
                ProxyCredentials = New NetworkCredential(CType(System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.Username"), String), CType(System.Configuration.ConfigurationManager.AppSettings("ESB.ProxyServer.Password"), String))

                'Apply credentials to proxy
                tmpProxy.Credentials = ProxyCredentials
            End If
            oProxy = tmpProxy
        End If
    End Sub
End Class
