'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Imports System.Text

Public Class File : Inherits Object

    Public Sub WriteBinary(ByVal sFilePath As String, ByRef baData As Byte())
        My.Computer.FileSystem.WriteAllBytes(sFilePath, baData, False)
        'Dim fs As New System.IO.FileStream(sFilePath, IO.FileMode.Create) ' + IO.FileMode.Truncate)
        'fs.Write(baData, 0, baData.Length)
        'fs.Close()
    End Sub
    Private Function ReadBinaryExtracted(ByVal sFilePath As String) As Byte()
        Return My.Computer.FileSystem.ReadAllBytes(sFilePath)
    End Function
    Public Function ReadBinary(ByVal sFilePath As String, ByRef badata As Byte()) As Long


        Dim fs As New System.IO.FileStream(sFilePath, IO.FileMode.Open, IO.FileAccess.Read)
        Dim oFile As New System.IO.FileInfo(sFilePath)

        ReDim badata(oFile.Length() - 1)

        Dim len As Long
        len = fs.Read(badata, 0, oFile.Length())

        fs.Close()
        Return len
    End Function


    Public Shared Sub Write(ByVal sFilePath As String, ByVal sData As String)
        My.Computer.FileSystem.WriteAllText(sFilePath, sData, False)
        'Dim fs As New System.IO.FileStream(sFilePath, IO.FileMode.Create) ' + IO.FileMode.Truncate)

        'Dim baData() As Byte
        'Dim oEnc As System.Text.Encoding = System.Text.Encoding.UTF8
        'baData = oEnc.GetBytes(sData)

        'fs.Write(baData, 0, baData.Length)
        'fs.Close()
    End Sub

    Public Shared Function Read(ByVal sFilePath As String) As String
        Return My.Computer.FileSystem.ReadAllText(sFilePath)

        'Dim fs As New System.IO.FileStream(sFilePath, IO.FileMode.Open, IO.FileAccess.Read)
        'Dim oFile As New System.IO.FileInfo(sFilePath)

        'Dim baData() As Byte

        'ReDim baData(oFile.Length() - 1)

        'Dim len As Long
        'len = fs.Read(baData, 0, oFile.Length())



        'fs.Close()


        'Dim oEnc As System.Text.Encoding = GetEncodingType(baData)
        ''Dim oEnc As System.Text.Encoding = System.Text.Encoding.UTF8
        ''Dim oEnc As System.Text.Encoding = System.Text.Encoding.Convert(
        'Return oEnc.GetString(baData)
    End Function


    Public Function GetEncodingType(ByRef badata As Byte()) As Encoding

        ' Get the preamble for the Unicode encoder. 
        ' In this case the preamble contains the byte order mark (BOM).

        'UTF-16 big endian      = FE FF
        'UTF-16 little endian   = FF FE
        'UTF-8                  = EF BB FF

        ' Make sure a preamble was returned 
        ' and is large enough to contain a BOM.
        If badata.Length >= 2 Then
            If badata(0) = &HFE And badata(1) = &HFF Then
                Return Encoding.BigEndianUnicode
                'Console.WriteLine("The Unicode encoder is encoding in big-endian order.")
            Else
                If badata(0) = &HFF And badata(1) = &HFE Then
                    'Console.WriteLine("The Unicode encoder is encoding in little-endian order.")
                    Return Encoding.Unicode
                End If
            End If

            If badata.Length >= 3 Then
                If badata(0) = &HEF And badata(1) = &HBB And badata(2) = &HFF Then
                    Return Encoding.UTF8
                End If
            End If

            Return Encoding.ASCII

        Else
            Return Encoding.Default
            'Assume it's ascii or UTF-8?
        End If
    End Function

    '                          Imports System
    'Imports System.Text

    'Namespace GetPreambleExample
    '        Class GetPreambleExampleClass
    '            Shared Sub Main()
    '                Dim [unicode] As Encoding = Encoding.Unicode

    '                ' Get the preamble for the Unicode encoder. 
    '                ' In this case the preamble contains the byte order mark (BOM).
    '                Dim preamble As Byte() = [unicode].GetPreamble()

    '                ' Make sure a preamble was returned 
    '                ' and is large enough to contain a BOM.
    '                If preamble.Length >= 2 Then
    '                    If preamble(0) = &HFE And preamble(1) = &HFF Then
    '                        Console.WriteLine("The Unicode encoder is encoding in big-endian order.")
    '                    Else
    '                        If preamble(0) = &HFF And preamble(1) = &HFE Then
    '                            Console.WriteLine("The Unicode encoder is encoding in little-endian order.")
    '                        End If
    '                    End If
    '                End If
    '            End Sub
    '        End Class
    '    End Namespace

End Class
