'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Public Class Timer

    Public m_oStopwatch As New Stopwatch

    'TODO: Replace this with the new StopWatch class in .NET FX 2.0

    'Use Kernel32 functions for near-microsecond timing of processes
    'Declare Function QueryPerformanceCounter Lib "Kernel32" (byval X As Long) As Short
    'Declare Function QueryPerformanceFrequency Lib "Kernel32" (byval X As Long) As Short

    'Private _start As Long
    'Private _end As Long
    'Private _freq As Long
    'Private _overhead As Long
    'Private _desc As String

    Public Sub StartTimer()
        m_oStopwatch.Start()

        'QueryPerformanceFrequency(_freq)
        '_end = 0
        'If (QueryPerformanceCounter(_start) = 0) Then
        '    Throw New StopwatchException
        'End If
    End Sub
    Public Function StopTimer() As Double
        m_oStopwatch.Stop()
        'If (QueryPerformanceCounter(_end) = 0) Then
        '    Throw New StopwatchException
        'End If
        Return Me.ElapsedTime()
    End Function
    Public Function ElapsedTime() As Double
        Return m_oStopwatch.ElapsedMilliseconds
        'If (_end = 0) Then
        '    Dim _now As Long
        '    If (QueryPerformanceCounter(_now) = 0) Then
        '        Throw New StopwatchException
        '    End If
        '    Return (((_now - _start)) / _freq)
        'End If
        'Return (((_end - _start)) / _freq)
    End Function
    Public Function Duration() As String
        'If (_end = 0) Then Me.StopTimer()
        If m_oStopwatch.IsRunning Then : m_oStopwatch.Stop() : End If
        Return String.Format("{0}", Me.ElapsedTime())
        'Return String.Format("{0}", 1000 * Me.ElapsedTime())

    End Function
    Public Sub ResetTimer()
        '_start = 0
        '_end = 0
        '_freq = 0
        '_overhead = 0
        '_desc = ""
        m_oStopwatch.Reset()
    End Sub
    Public Shared Function NowAsString() As String
        Return DateAndTime.Now.ToString("yyyy-MM-dd:HH:mm:ss.fffffff")
    End Function
End Class

'Public Class StopwatchException
'    Inherits System.ApplicationException

'    Overrides ReadOnly Property Message() As String
'        Get
'            Return "Stopwatch: QueryPerformanceCounter[Kernel32] returned 0"
'        End Get
'    End Property
'End Class
