Imports System.Xml.Serialization
Imports System
Imports System.Xml
Imports System.Xml.Xsl
Imports System.IO
Imports Microsoft.VisualBasic
Imports System.Reflection
Imports System.Text
Imports System.Collections.Generic
Imports Wintellect.PowerCollections
Imports ESB.Core
Imports ESB.Core.Util
Imports ESB.Core.XMLSchemaClasses
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports ESB.Core.Interfaces.Envelope
Imports System.Xml.Linq



Namespace ESBMessageEnvelope

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="ESBMessageEnvelope"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="ESBMessageEnvelope"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class ESBMessageEnvelopeProvider : Inherits ESBEnvelope.EnvelopeBase

        Const m_csEnvelopeNamespace As String = "urn:au.com.keystroke.esb.envelope.esbMessageEnvelope.version_1_0_0_0"
        Const m_csEnvelopeRootNode As String = "ESBMessageEnvelope"
        Const m_csEnvelopeVersion As String = "1.0.0.0"

        Friend m_lNumDocs = 0

        Public Shared ReadOnly m_csEnvelopeName As String = "ESB.Core.XMLSchemaClasses.esbMessageEnvelope"

        '''<remarks/>
        Public header As headerType


        Public Sub New()
            header = New ESBMessageEnvelope.headerType(Me)
            'MyBase.New()
        End Sub

        Public Sub New(ByVal _header As headerType, ByVal _payload As payload)
            MyBase.New()
            Me.header = header
            Me.payload = payload
        End Sub

        Public payload As New payload

        '--Routing

#Region "Routing"
        'Declare these properties with the XmlIgnoreAttribute in the implementing envelope classes...

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property XMLSchemaName() As String
            'The XMLSchema name of the default document - this is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                If m_lNumDocs <= 0 Then
                    Return ""
                Else
                    Return GetDocument(0).GetAsXMLDocument.DocumentElement.Name.Trim
                End If
            End Get
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ServiceName() As String
            'This is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                Return Me.header.Service.Name
            End Get
            Set(ByVal Value As String)
                Me.header.Service.Name = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property Context() As String
            Get
                If Trim(Me.ServiceNamespace) = "" Then
                    Return ESB.Core.Util.Utils.TrimStr(Trim(Me.SystemType) & Trim(Me.SystemVersion) & "." & Trim(Me.header.Service.Context) & "." & Trim(Me.ServiceName) & Trim(Me.header.Service.Version), ".")
                Else
                    Return ESB.Core.Util.Utils.TrimStr(Trim(Me.SystemType) & Trim(Me.SystemVersion) & "." & Trim(Me.header.Service.Context) & "." & Trim(Me.ServiceNamespace) & "." & Trim(Me.ServiceName) & Trim(Me.header.Service.Version), ".")
                End If
            End Get
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
       Public Overrides Property MessageContext() As String
            Get
                Return Trim(header.Service.Context)
            End Get

            Set(ByVal Value As String)
                header.Service.Context = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToAddress() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Return ""
                End If
                Return Me.header.Delivery.To.Address
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Me.header.Delivery.To = New [to]
                End If
                Me.header.Delivery.To.Address = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToAddressType() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.To.AddressType = "" Then
                    'get it out of the url...
                    If Me.header.Delivery.To.Address = "" Then
                        Return ""
                    Else
                        Return Me.header.Delivery.To.Address.Substring(0, Me.header.Delivery.To.Address.IndexOf(":"))
                    End If
                Else
                    Return Me.header.Delivery.To.AddressType
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Me.header.Delivery.To = New [to]
                End If
                Me.header.Delivery.To.AddressType = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromAddress() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.From Is Nothing Then
                    Return ""
                End If
                Return Me.header.Delivery.From.Address
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                If Me.header.Delivery.From Is Nothing Then
                    Me.header.Delivery.From = New from
                End If
                Me.header.Delivery.From.Address = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromAddressType() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.From Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.From.AddressType = "" Then
                    'get it out of the url...
                    If Me.header.Delivery.From.Address = "" Then
                        Return ""
                    Else
                        Return Me.header.Delivery.From.Address.Substring(0, Me.header.Delivery.From.Address.IndexOf(":"))
                    End If
                Else
                    Return Me.header.Delivery.From.AddressType
                End If
            End Get
            Set(ByVal Value As String)
                Me.header.Delivery.From.AddressType = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property MessageID() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.Message Is Nothing Then
                    Return ""
                End If
                Return Me.header.Delivery.Message.SenderMessageID
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                If Me.header.Delivery.Message Is Nothing Then
                    Me.header.Delivery.Message = New message
                End If
                Me.header.Delivery.Message.SenderMessageID = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property InternalMessageID() As String
            Get
                Return Me.header.Delivery.Message.ReceiverMessageID
            End Get
            Set(ByVal Value As String)
                Me.header.Delivery.Message.ReceiverMessageID = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property Environment() As String
            Get
                If Me.header.TargetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.TargetSystems(0).Environment
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.TargetSystems.Count = 0 Then
                    Me.header.TargetSystems.Add(New targetSystem)
                End If
                Me.header.TargetSystems(0).Environment = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemName() As String
            Get
                If Me.header.TargetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.TargetSystems(0).SystemID
                End If
            End Get
            Set(ByVal Value As String)
                If header.TargetSystems.Count = 0 Then
                    header.TargetSystems.Add(New targetSystem)
                End If
                header.TargetSystems(0).SystemID = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemType() As String
            Get
                If Me.header.TargetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.TargetSystems(0).SystemType
                End If

            End Get
            Set(ByVal Value As String)
                If header.TargetSystems.Count = 0 Then
                    header.TargetSystems.Add(New targetSystem)
                End If
                header.TargetSystems(0).SystemType = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemVersion() As String
            Get
                If Me.header.TargetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.TargetSystems(0).SystemVersion
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.TargetSystems.Count = 0 Then
                    Me.header.TargetSystems.Add(New targetSystem)
                End If
                Me.header.TargetSystems(0).SystemVersion = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property CallSynchronizationType() As String
            Get

                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.Message Is Nothing Then
                    Return ""
                End If
                Return Me.header.Delivery.ProcessingType
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                Me.header.Delivery.ProcessingType = Value
            End Set
        End Property



        <System.Xml.Serialization.XmlIgnore()> _
   Public Overrides Property FromName() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.from.name
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.from Is Nothing Then
                    Me.header.delivery.from = New from
                End If
                Me.header.delivery.from.name = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
  Public Overrides Property ToName() As String
            Get
                If Me.header.Delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Return ""
                End If
                Return Me.header.Delivery.To.Name
            End Get
            Set(ByVal Value As String)
                If Me.header.Delivery Is Nothing Then
                    Me.header.Delivery = New delivery
                End If
                If Me.header.Delivery.To Is Nothing Then
                    Me.header.Delivery.To = New [to]
                End If
                Me.header.Delivery.To.Name = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
      Public Overrides Property Channel() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.from.channel
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.from Is Nothing Then
                    Me.header.delivery.from = New from
                End If
                Me.header.delivery.from.channel = Trim(Value)
            End Set
        End Property

#End Region



#Region "IEnvelope Overrides"


        Public Overrides Function AddAttachment(Optional ByVal sAttachmentName As String = "", Optional ByVal sAttachmentPath As String = "", Optional ByVal lIndex As Long = 0, Optional ByVal sType As String = "", Optional ByVal sUrl As String = "") As Long
            Dim oAtt As New attachmentDetails
            With oAtt
                .Description = sAttachmentName
                .Filename = sAttachmentPath
                .Index = lIndex
                .Type = sType
                .Url = sUrl

            End With

            header.PayloadManifest.AttachmentDetails.Add(oAtt)
            Return 1
        End Function

        Public Overloads Overrides Function AddDocument(ByVal oEnvDoc As Interfaces.Envelope.IInlineDocument, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oEnvDoc.GetAsXMLDocument, , bCopyDocument)
        End Function

        Public Overloads Overrides Function AddDocument(ByVal oEnvDoc As Interfaces.Envelope.IInlineDocument, ByVal lDocumentIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oEnvDoc.GetAsXMLDocument, lDocumentIndex, bCopyDocument)
        End Function

        Public Overrides ReadOnly Property AttachmentsExist() As Boolean
            Get
                If header.PayloadManifest.AttachmentDetails.Count > 0 Then
                    Return True
                Else
                    Return False
                End If

            End Get
        End Property

        Public Overrides Sub ClearCustomParams()
            header.customAttributes.Clear()
        End Sub
        Public Overloads Overrides Sub SetCustomParam(ByVal sParamName As String, ByVal sParamValue As String)
            StartMethod()
            Try
                If header.customAttributes Is Nothing Then
                    header.customAttributes = New List(Of customAttributes)
                End If
                'try to find a param with that name first. Should not be that many
                'so don't bother with HashTables etc...
                Dim oCustom As customAttributes
                Dim bFoundExisting As Boolean = False

                For Each oCustom In Me.header.customAttributes
                    If oCustom.Name = sParamName Then
                        oCustom.Value = Trim(sParamValue)
                        bFoundExisting = True
                        Exit For
                    End If
                Next

                'none found by that name, so add one...
                If bFoundExisting = False Then
                    oCustom = New customAttributes
                    oCustom.Name = sParamName
                    oCustom.Value = Trim(sParamValue)
                    Me.header.customAttributes.Add(oCustom)
                End If
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            Finally
                EndMethod()
            End Try

        End Sub
        Public Overloads Overrides Function GetCustomParam(ByVal sParamName As String) As String
            StartMethod()
            Try
                Dim oCustom As customAttributes
                For Each oCustom In Me.header.customAttributes
                    If oCustom.Name = sParamName Then
                        Return Trim(oCustom.Value)
                    End If
                Next
                'if no match found, then return an empty string...
                Return ""
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            Finally
                EndMethod()
            End Try
        End Function
        Public Overloads Overrides Sub SetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String, ByVal sParamValue As String)
            StartMethod()
            Try
                SetCustomParam(sParamNodeName & "." & sParamName, sParamValue)
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            Finally
                EndMethod()
            End Try

        End Sub

        Public Overloads Overrides Function GetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String) As String
            StartMethod()
            Try
                Return GetCustomParam(sParamNodeName & "." & sParamName)

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            Finally
                EndMethod()
            End Try
        End Function

        Public Overrides Function CreateResponse() As Interfaces.Envelope.IEnvelope
            Dim oesbEnv As New ESBMessageEnvelopeProvider

            'Should copy header over etc...
            oesbEnv = Me.Clone()

            oesbEnv.header.Delivery.Message.SentTimeStamp = ESB.Core.Util.Timer.NowAsString
            'Remove other stuff...Just leave relavant bits of header...
            If Not oesbEnv.payload.document Is Nothing Then
                oesbEnv.payload.document.Clear()
            End If
            oesbEnv.header.PayloadManifest.AttachmentDetails.Clear()
            If Not oesbEnv.header.PayloadManifest.DocumentDetails Is Nothing Then
                oesbEnv.header.PayloadManifest.DocumentDetails.Clear()
            End If
            oesbEnv.m_lNumDocs = 0

            Dim oEnv As New Envelope
            oEnv.SetInternalEnvelope(oesbEnv)
            oEnv.DefaultEnvelopeType = m_csEnvelopeName
            Return oEnv

        End Function

        Public Overrides Function GetAttachment(ByVal lIndex As Long) As Interfaces.Envelope.IAttachment
            Return header.PayloadManifest.AttachmentDetails(lIndex)
        End Function

        Public Overrides Function GetAttachments() As System.Collections.Generic.IList(Of Interfaces.Envelope.IAttachment)
            Return Algorithms.TypedAs(Of IAttachment)(Me.header.PayloadManifest.AttachmentDetails)
        End Function

        Public Overrides Function GetCustomParams() As System.Collections.IList
            Return CType(header.customAttributes, IList)
        End Function

        Public Overloads Overrides Function GetDocument(ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(, lIndex, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, lIndex, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, ByRef lReturnedDocIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, lIndex, False, lReturnedDocIndex)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If

        End Function

        Public Overrides Function GetDocuments() As System.Collections.Generic.IList(Of Interfaces.Envelope.IInlineDocument)
            Return Algorithms.TypedAs(Of IInlineDocument)(Me.header.PayloadManifest.DocumentDetails)
            'Return Algorithms.TypedAs(Of IInlineDocument)(Me.payload.document)
        End Function

        Public Overloads Overrides Function GetMsgStatus() As Interfaces.Envelope.eEnvelopeStatus
            Return GetMsgStatus(Me)
        End Function

        Public Overloads Overrides Function GetMsgStatus(ByVal sXML As String) As Interfaces.Envelope.eEnvelopeStatus
            Dim oesbEnv As New ESBMessageEnvelopeProvider
            oesbEnv.FromXML(sXML)
            Return GetMsgStatus(oesbEnv)
        End Function

        Public Overloads Overrides Function IsError() As Boolean
            Return IsError(Me)
        End Function

        Public Overloads Overrides Function IsError(ByVal sXML As String) As Boolean
            Return Not ((GetMsgStatus(sXML) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings))
        End Function

        Public Overloads Overrides Function IsWarning() As Boolean
            Return IsWarning(Me)
        End Function

        Public Overloads Overrides Function IsWarning(ByVal sXML As String) As Boolean
            Return GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings
        End Function

        Public Overrides Function Clone() As Object
            'Best way to Clone is probably to Serialise & Deserialize as is done below...
            Dim oEnv As New ESBMessageEnvelopeProvider
            Dim sEnvXML As String = Me.ToXML
            oEnv.FromXML(sEnvXML)
            Return oEnv
        End Function

#Region "IEnvelope Detection"

        Public Overrides Function IsCorrectEnvelopeType(ByVal sXML As String) As Boolean
            Try

                Dim oXMLDoc As New XmlDocument
                oXMLDoc.LoadXml(sXML)

                If oXMLDoc.DocumentElement.Name = "ESBMessageEnvelope" Then
                    If oXMLDoc.DocumentElement.NamespaceURI = m_csEnvelopeNamespace Then
                        Return True
                    Else
                        Return False
                    End If
                Else
                    Return False
                End If
            Catch e As Exception
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Error Parsing envelope:" & e.Message)
                Return False
            End Try
            
        End Function
        Public Overloads Function GetEnvelopeNodeName(Optional ByVal sXML As String = "") As Boolean
            Return "ESBMessageEnvelope"
        End Function
        Public Overloads Function GetEnvelopeNameSpace(Optional ByVal sXML As String = "") As Boolean
            Return m_csEnvelopeNamespace
        End Function
        Public Overloads Function GetEnvelopeVersion(Optional ByVal sXML As String = "") As Boolean
            Return "1.0.0.0"
        End Function

        Public Overrides Function GetEnvelopeType(Optional ByVal sXML As String = "", Optional ByRef oEnvOut As IEnvelopeProvider = Nothing) As String
            If sXML = "" Then
                Return m_csEnvelopeName
            Else
                Return MyBase.GetEnvelopeType(sXML)
            End If
        End Function
#End Region

#Region "IEnvelope Serialization"
        Public Overrides Sub FromXMLDocument(ByVal oXMLdoc As XmlDocument)
            ' Me.FromXML(oXML.OuterXml)
            'Duplicated for optimization

            'need to pull out documents out of the DocumentBodies nodes
            'and put them into the XMLDocuments
            'and remove them from the XML Envelope
            'Then we can deserialize the ESBEnvelopeProvider...
            Dim sXMLEnv As String = ""

            If oXMLdoc Is Nothing Then
                Throw New Exception("XMLDocument Received is Nothing.")
            End If

            Dim sXSDValidationErrors As String = ""
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnDeserialize") Then
                sXMLEnv = oXMLdoc.OuterXml
                If ValidateXMLAgainstXSD(sXMLEnv, "ValidationOnDeserialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelopeProvider.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelopeProvider.ValidationOnDeserialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If

            'Dim oXMLDoc As New XmlDocument
            'oXMLDoc.LoadXml(sXMLEnv)

            'do some XPath here & replace those nodes with nothing...
            Dim oDocumentNL As XmlNodeList
            Dim nsmgr As New XmlNamespaceManager(oXMLdoc.NameTable)
            nsmgr.AddNamespace("esb", m_csEnvelopeNamespace)
            oDocumentNL = oXMLdoc.SelectNodes("/esb:ESBMessageEnvelope/esb:payload/esb:document/node()", nsmgr)

            Dim oDocBodyXMLNode As XmlNode
            Dim i As Long = 0

            For Each oDocBodyXMLNode In oDocumentNL
                'Add an entry to the documents in the envelope
                AddDocument(New InlineDocument(oDocBodyXMLNode))
                i += 1
            Next

            Dim oEnvTmp As ESBMessageEnvelopeProvider
            oEnvTmp = DeSerialize(sXMLEnv, GetType(ESBMessageEnvelopeProvider))
            Me.header = oEnvTmp.header
            Me.header.m_oParent = Me
            Me.header.PayloadManifest.m_oParent = Me
            If Not Me.header.PayloadManifest.DocumentDetails Is Nothing Then
                Me.header.PayloadManifest.DocumentDetails.m_oParent = Me
            End If

        End Sub

        Public Overloads Overrides Function Serialize(ByVal oObjectToSerialize As System.Object) As String
            Dim oXMLUtil As New XMLUtil
            Return oXMLUtil.Serialize(oObjectToSerialize)
        End Function
        Public Overrides Function DeSerialize(ByVal sXMLStringToDeSerialize As String, ByVal tType As Type) As Object
            Dim oXMLUtil As New XMLUtil
            Return oXMLUtil.DeSerialize(sXMLStringToDeSerialize, tType)
        End Function
        Public Overrides Function ToXML() As String
            Dim sSerialisedXML As String = Serialize(Me)
            Dim sXSDValidationErrors As String = ""
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnDeserialize") Then
                If ValidateXMLAgainstXSD(sSerialisedXML, "ValidationOnSerialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelope.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelope.ValidationOnSerialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If
            Return sSerialisedXML
            'Return Serialize(Me)
        End Function
        Public Overrides Function ToXMLDocument() As XmlDocument
            Dim oXmlDoc As New Xml.XmlDocument
            oXmlDoc.LoadXml(ToXML)
            Return oXmlDoc
        End Function

#Region "IEnvelope Serialization Support"

        Public Overrides Sub FromXML(ByVal sXMLEnv As String)
            'need to pull out documents out of the DocumentBodies nodes
            'and put them into the XMLDocuments
            'and remove them from the XML Envelope
            'Then we can deserialize the ESBMessageEnvelope...

            If sXMLEnv = "" Then
                Throw New Exception("Received an empty string instead of an envelope.")
            End If
            

            Dim sXSDValidationErrors As String = ""
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnDeserialize") Then
                If ValidateXMLAgainstXSD(sXMLEnv, "ValidationOnDeserialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelopeProvider.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelopeProvider.ValidationOnDeserialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If

            Dim oXMLDoc As New XmlDocument
            oXMLDoc.LoadXml(sXMLEnv)

            ''
            
            Dim ox As XDocument
            ox = XDocument.Parse(sXMLEnv)
            'ox.do()
            ' ox.



            ''

            'do some XPath here & replace those nodes with nothing...
            Dim oDocumentNL As XmlNodeList
            Dim nsmgr As New XmlNamespaceManager(oXMLDoc.NameTable)
            nsmgr.AddNamespace("esb", m_csEnvelopeNamespace)
            oDocumentNL = oXMLDoc.SelectNodes("/esb:ESBMessageEnvelope/esb:payload/esb:document/node()", nsmgr)

            Dim oDocBodyXMLNode As XmlNode
            Dim i As Long = 0

            For Each oDocBodyXMLNode In oDocumentNL
                'Add an entry to the documents in the envelope
                AddDocument(New InlineDocument(oDocBodyXMLNode))
                i += 1
            Next

            Dim oEnvTmp As ESBMessageEnvelopeProvider
            oEnvTmp = DeSerialize(sXMLEnv, GetType(ESBMessageEnvelopeProvider))
            Me.header = oEnvTmp.header
            Me.header.m_oParent = Me
            Me.header.PayloadManifest.m_oParent = Me
            If Not Me.header.PayloadManifest.DocumentDetails Is Nothing Then
                Me.header.PayloadManifest.DocumentDetails.m_oParent = Me
            End If
            

        End Sub
        Public Function ShouldValidateXMLEnvelopeAgainstXSD(ByVal ValidationContext As String) As Boolean
            If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelopeProvider." & ValidationContext) = "1" Then
                Return True
            Else : Return False : End If
        End Function
        Public Function ValidateXMLAgainstXSD(ByVal sXmlToValidate As String, ByVal ValidationContext As String, Optional ByVal sErrors As String = "") As Boolean
            ' If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBMessageEnvelope." & ValidationContext) = "1" Then
            Dim oXmlUtil As New XMLUtil
            Dim sPath As String = System.Configuration.ConfigurationManager.AppSettings("ESB.ESBMessageEnvelope.XSDFilePath")
            Dim sXSDPath As String = Path.Combine(ESB.Core.Util.ExpandRelativePath(sPath), "ESBMessageEnvelope.xsd")
            Return oXmlUtil.ValidateXMLAgainstXSD(sXSDPath, sXmlToValidate, sErrors)
            'Else
            'Return True
            'End If
        End Function
#End Region

#End Region



#End Region

#Region "IEnvelope Helper Classes"

        Public Overloads Function AddDocumentInternal(ByVal oXmlDocument As System.Xml.XmlDocument, Optional ByVal lDocumentIndex As Long = -1, Optional ByVal bCopyDocument As Boolean = False) As Long

            Dim oNewDoc As XmlDocument

            If bCopyDocument = True Then
                '++Make a copy of the Document...before adding
                oNewDoc = New XmlDocument
                Dim sXMLNewDoc As String = GetXMLAsString(oXmlDocument)
                oNewDoc.LoadXml(sXMLNewDoc)
            Else
                oNewDoc = oXmlDocument
            End If

            Dim oNode As XmlNode

            'Remove the XML Declaration node if one exists - can only have one in an XML document...
            For Each oNode In oNewDoc.ChildNodes()
                If oNode.Name.ToUpper = "XML" Then
                    oNewDoc.RemoveChild(oNode)
                End If
            Next

            'Determine whether to insert at a given position or at the end of the list of any existing documents...
            If lDocumentIndex <> -1 Then
                'insert at a given location - potentially overwrite an existing document...
                If lDocumentIndex > m_lNumDocs Then
                    'error
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Cannot insert document at a position more than 1 greater than the current document count!")
                    Return -1
                End If

                'insert at a specified index
                If payload.document Is Nothing Then
                    payload.document = New Collections.Generic.List(Of System.Xml.XmlDocument)
                    'body.document = New documentBodiesCol
                End If

                payload.document.Insert(lDocumentIndex, oNewDoc)

                If header.PayloadManifest.DocumentDetails Is Nothing Then
                    header.PayloadManifest.DocumentDetails = New documentDetailsCol
                End If

                header.PayloadManifest.DocumentDetails(lDocumentIndex) = New documentDetails
                header.PayloadManifest.DocumentDetails(lDocumentIndex).Namespace = oNewDoc.NamespaceURI
                header.PayloadManifest.DocumentDetails(lDocumentIndex).Name = oNewDoc.DocumentElement.Name
                Return m_lNumDocs - 1 'return the document index - zero based

            Else
                'just insert at next index
                If payload.document Is Nothing Then
                    payload.document = New Collections.Generic.List(Of System.Xml.XmlDocument)
                    'body.document = New documentBodiesCol
                End If

                payload.document.Add(oNewDoc)

                If header.PayloadManifest.DocumentDetails Is Nothing Then
                    header.PayloadManifest.DocumentDetails = New documentDetailsCol
                End If

                header.PayloadManifest.DocumentDetails(m_lNumDocs) = New documentDetails
                header.PayloadManifest.DocumentDetails(m_lNumDocs).Namespace = oNewDoc.DocumentElement.NamespaceURI
                header.PayloadManifest.DocumentDetails(m_lNumDocs).Name = oNewDoc.DocumentElement.Name

                m_lNumDocs += 1
                Return m_lNumDocs - 1 'return the document index - zero based
            End If
        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXMLClassWrapperObj As Object) As Long
            'Currently, I only know how to serialize & pass the XML on to AddDocumentInternal(ByVal sXMLDoc As String)
            'Later, I'll try & figure out a way to have the document attached & still be able to modify it!
            Dim sXMLDoc As String
            sXMLDoc = Serialize(oXMLClassWrapperObj)

            Return AddDocumentInternal(sXMLDoc)
        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXmlNode As System.Xml.XmlNode) As Long
            'need to remove the document node...
            Dim oXMLDoc As New XmlDocument
            Dim oXMLNodeForThisDoc As XmlNode
            oXMLNodeForThisDoc = oXMLDoc.ImportNode(oXmlNode, True)

            oXMLDoc.AppendChild(oXMLNodeForThisDoc)

            Return AddDocumentInternal(oXMLDoc)

        End Function
        Public Overloads Function AddDocumentInternal(ByVal sXMLDoc As String) As Long
            Dim oDoc As New XmlDocument
            oDoc.LoadXml(sXMLDoc)
            Return AddDocumentInternal(oDoc)

        End Function
        Public Overloads Function GetDocumentInternal(Optional ByVal sDocumentName As String = "", Optional ByVal lDocIndex As Long = -1, Optional ByVal bCopyDocument As Boolean = False, Optional ByRef lReturnedDocIndex As Long = -1) As XmlDocument

            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0
            Dim oDoc As XmlDocument

            Dim lMatchIndex As Long = 0

            If (sDocumentName = "" And lDocIndex = -1) Then
                Throw New Exception("Invalid parameters specified - sDocumentName = "" And lDocIndex = -1")
            End If
            If Me.header.PayloadManifest.DocumentDetails.Count <> Me.m_lNumDocs Then
                Throw New Exception("Inconsistent Envelope - Document Body count(" & Me.m_lNumDocs & ") does not match header manifest document count (" & Me.header.PayloadManifest.DocumentDetails.Count & ")")
            End If

            Try
                For i = 0 To Me.m_lNumDocs - 1
                    'Check to see if there's an instance of the document asked for present...

                    If (sDocumentName = "" And lDocIndex <> -1) Or Me.header.PayloadManifest.DocumentDetails(i).Name = sDocumentName Then
                        'there's a match in the manifest - or we don't care to match on a document name...
                        'try & get the doc out of the body now...
                        If sDocumentName = "" Then 'just get the document at the requested index...
                            Try
                                oDoc = payload.document(lDocIndex)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eWarnings
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Index out of range")
                                End If
                            Catch

                            End Try
                        End If
                        If lMatchIndex = lDocIndex Then
                            Try
                                oDoc = payload.document(i)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - ")

                                    'bad envelope - Manifest does not match body etc.
                                    'Also need to count docs in Manifest & Body etc...

                                    'Dim oDocBody As System.Xml.XmlDocument
                                    'protected... for each odocbody in ojskenv.elbody
                                    'Return Nothing
                                    Throw New Exception("Inconsistent Envelope - Body does not match header - ")
                                End If
                            Catch ex As Exception
                                ExceptionManager.Publish(ex)
                                eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                                Throw ex
                            End Try
                        End If
                        lMatchIndex += 1

                    End If

                Next i
                Return Nothing
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                Throw ex
            End Try

        End Function
        Public Overloads Function GetMsgStatus(ByVal oesbEnv As ESBMessageEnvelopeProvider) As eEnvelopeStatus
            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0


            Try

                For i = 0 To oesbEnv.m_lNumDocs - 1
                    'Check to see if there's an instance of the ErrorXMl document present
                    If oesbEnv.header.PayloadManifest.DocumentDetails(i).Name = "ErrorXML" Then

                        Try
                            Dim oPlgErr As ErrorXML.ErrorXML
                            'oPlgErr = oesbEnv.GetDocument(i, GetType(ErrorXML.ErrorXML))
                            oPlgErr = oesbEnv.GetDocument(i).GetAsObject(GetType(ErrorXML.ErrorXML))
                            If Not oPlgErr Is Nothing Then
                                If oPlgErr.ErrorEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eFailed
                                    Exit For
                                End If
                                If oPlgErr.WarningEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eWarnings
                                    Exit For
                                End If

                                'bad envelope - Manifest does not match body etc.
                                'Also need to count docs in Manifest & Body etc...

                                'Dim oDocBody As System.Xml.XmlDocument
                                'protected... for each odocbody in ojskenv.elbody
                                'Hard to do with JSK Envelope implementation - need to change envelope
                                'class - also try iheritance etc...

                                eStatus = eEnvelopeStatus.eSuccess
                            Else
                                eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                Exit For
                            End If
                        Catch ex As Exception
                            ExceptionManager.Publish(ex)
                            LogError(eLogLevel.eLOG_ERROR, "eEnvelopeStatus.eInconsistentEnvelope. " & ex.ToString)
                            eStatus = eEnvelopeStatus.eInconsistentEnvelope
                            Exit For
                        Finally

                        End Try
                    Else
                        eStatus = eEnvelopeStatus.eSuccess
                    End If
                    'i += 1
                Next

                Return eStatus

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                Throw ex
            End Try

        End Function
        Public Overloads Function IsError(ByVal oesbEnv As ESBMessageEnvelopeProvider) As Boolean
            Return Not ((GetMsgStatus(oesbEnv) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(oesbEnv) = eEnvelopeStatus.eWarnings))
        End Function
        Public Overloads Function IsWarning(ByVal oesbEnv As ESBMessageEnvelopeProvider) As Boolean
            Return GetMsgStatus(oesbEnv) = eEnvelopeStatus.eWarnings
        End Function
#End Region

    End Class



    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope.version_1_0_0_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope.version_1_0_0_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class payload
        <System.Xml.Serialization.XmlElementAttribute()> _
        Public document As New Collections.Generic.List(Of System.Xml.XmlDocument)
    End Class



    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", TypeName:="header"), _
     System.Xml.Serialization.XmlRootAttribute("header", [Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="header"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class headerType

        Friend m_oParent As ESBMessageEnvelopeProvider

        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying document object.
        ''' </summary>
        ''' <param name="oParent"></param>
        ''' <remarks>
        ''' When this object is deleted, the associated document object will also need to be delted...
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New(ByVal oParent As ESBMessageEnvelopeProvider)
            m_oParent = oParent
            PayloadManifest = New payloadManifest(m_oParent)
        End Sub

        '''<remarks/>
        Private _delivery As delivery

        '''<remarks/>
        Private _payloadManifest As payloadManifest

        '''<remarks/>
        Private _targetSystems As System.Collections.Generic.List(Of targetSystem)

        '''<remarks/>
        Private _service As service

        '''<remarks/>
        ''' 


        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _delivery As delivery, ByVal _payloadManifest As payloadManifest, ByVal _targetSystems As System.Collections.Generic.List(Of targetSystem), ByVal _service As service, ByVal _customAttributes As List(Of customAttributes))
            MyBase.New()
            Me._delivery = _delivery
            Me._payloadManifest = _payloadManifest
            Me._targetSystems = _targetSystems
            Me._service = _service
            Me.customAttributes = customAttributes
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="delivery")> _
        Public Property Delivery() As delivery
            Get
                Return Me._delivery
            End Get
            Set(ByVal value As delivery)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("Delivery")
                End If
                Me._delivery = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="payloadManifest")> _
        Public Property PayloadManifest() As payloadManifest
            Get
                Return Me._payloadManifest
            End Get
            Set(ByVal value As payloadManifest)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("PayloadManifest")
                End If
                Me._payloadManifest = value
            End Set
        End Property

        <System.Xml.Serialization.XmlArrayItemAttribute("targetSystem", IsNullable:=False), _
         System.Xml.Serialization.XmlArrayAttribute(ElementName:="targetSystems")> _
        Public Property TargetSystems() As System.Collections.Generic.List(Of targetSystem)
            Get
                Return Me._targetSystems
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of targetSystem))
                Me._targetSystems = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="service")> _
        Public Property Service() As service
            Get
                Return Me._service
            End Get
            Set(ByVal value As service)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("Service")
                End If
                Me._service = value
            End Set
        End Property

        Private _customAttributes As List(Of customAttributes)
        <System.Xml.Serialization.XmlElementAttribute(ElementName:="customAttributes")> _
       Public Property customAttributes() As List(Of customAttributes)
            Get
                Return Me._customAttributes
            End Get
            Set(ByVal value As List(Of customAttributes))
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("customAttributes")
                End If
                Me._customAttributes = value
            End Set
        End Property
        '<System.Xml.Serialization.XmlElementAttribute("customAttributes")> _
        'Public customAttributes As List(Of customAttributes)

        '<System.Xml.Serialization.XmlElementAttribute(ElementName:="customAttributes")> _
        'Public Property CustomAttributes() As List(Of customAttributes)
        '    Get
        '        Return Me._customAttributes
        '    End Get
        '    Set(ByVal value As List(Of customAttributes))
        '        If (value Is Nothing) Then
        '            Throw New System.ArgumentNullException("CustomAttributes")
        '        End If
        '        Me._customAttributes = value
        '    End Set
        'End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="delivery"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="delivery"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class delivery

        '''<remarks/>
        Private _message As message

        '''<remarks/>
        Private _to As [to]

        '''<remarks/>
        Private _from As from

        '''<remarks/>
        Private _processingType As processingType

        '''<remarks/>
        Private _processingTypeSpecified As Boolean

        '''<remarks/>
        Private _type As deliveryType

        '''<remarks/>
        Private _typeSpecified As Boolean

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _message As message, ByVal _to As [to], ByVal _from As from, ByVal _processingType As processingType, ByVal _processingTypeSpecified As Boolean, ByVal _type As deliveryType, ByVal _typeSpecified As Boolean)
            MyBase.New()
            Me._message = _message
            Me._to = _to
            Me._from = _from
            Me._processingType = _processingType
            Me._processingTypeSpecified = _processingTypeSpecified
            Me._type = _type
            Me._typeSpecified = _typeSpecified
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="message")> _
        Public Property Message() As message
            Get
                Return Me._message
            End Get
            Set(ByVal value As message)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("Message")
                End If
                Me._message = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="to")> _
        Public Property [To]() As [to]
            Get
                Return Me._to
            End Get
            Set(ByVal value As [to])
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("To")
                End If
                Me._to = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="from")> _
        Public Property From() As from
            Get
                Return Me._from
            End Get
            Set(ByVal value As from)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("From")
                End If
                Me._from = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="processingType")> _
        Public Property ProcessingType() As processingType
            Get
                Return Me._processingType
            End Get
            Set(ByVal value As processingType)
                If (Me._processingType <> value) Then
                    Me._processingType = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property ProcessingTypeSpecified() As Boolean
            Get
                Return Me._processingTypeSpecified
            End Get
            Set(ByVal value As Boolean)
                If (Me._processingTypeSpecified <> value) Then
                    Me._processingTypeSpecified = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlAttributeAttribute(AttributeName:="Type")> _
        Public Property Type() As deliveryType
            Get
                Return Me._type
            End Get
            Set(ByVal value As deliveryType)
                If (Me._type <> value) Then
                    Me._type = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnoreAttribute()> _
        Public Property TypeSpecified() As Boolean
            Get
                Return Me._typeSpecified
            End Get
            Set(ByVal value As Boolean)
                If (Me._typeSpecified <> value) Then
                    Me._typeSpecified = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="message"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="message"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class message

        '''<remarks/>
        Private _senderMessageID As String

        '''<remarks/>
        Private _receiverMessageID As String

        '''<remarks/>
        Private _sentTimeStamp As String

        '''<remarks/>
        Private _receivedTimeStamp As String

        '''<remarks/>
        Private _subject As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _senderMessageID As String, ByVal _receiverMessageID As String, ByVal _sentTimeStamp As String, ByVal _receivedTimeStamp As String, ByVal _subject As String)
            MyBase.New()
            Me._senderMessageID = _senderMessageID
            Me._receiverMessageID = _receiverMessageID
            Me._sentTimeStamp = _sentTimeStamp
            Me._receivedTimeStamp = _receivedTimeStamp
            Me._subject = _subject
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="senderMessageID")> _
        Public Property SenderMessageID() As String
            Get
                Return Me._senderMessageID
            End Get
            Set(ByVal value As String)
                If (Me._senderMessageID <> value) Then
                    Me._senderMessageID = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="receiverMessageID")> _
        Public Property ReceiverMessageID() As String
            Get
                Return Me._receiverMessageID
            End Get
            Set(ByVal value As String)
                If (Me._receiverMessageID <> value) Then
                    Me._receiverMessageID = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="sentTimeStamp")> _
        Public Property SentTimeStamp() As String
            Get
                Return Me._sentTimeStamp
            End Get
            Set(ByVal value As String)
                If (Me._sentTimeStamp <> value) Then
                    Me._sentTimeStamp = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="receivedTimeStamp")> _
        Public Property ReceivedTimeStamp() As String
            Get
                Return Me._receivedTimeStamp
            End Get
            Set(ByVal value As String)
                If (Me._receivedTimeStamp <> value) Then
                    Me._receivedTimeStamp = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="subject")> _
        Public Property Subject() As String
            Get
                Return Me._subject
            End Get
            Set(ByVal value As String)
                If (Me._subject <> value) Then
                    Me._subject = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="to"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="to"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class [to]

        '''<remarks/>
        Private _name As String

        '''<remarks/>
        Private _address As String

        '''<remarks/>
        Private _addressType As String

        '''<remarks/>
        Private _channel As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _name As String, ByVal _address As String, ByVal _addressType As String, ByVal _channel As String)
            MyBase.New()
            Me._name = _name
            Me._address = _address
            Me._addressType = _addressType
            Me._channel = _channel
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="name")> _
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                If (Me._name <> value) Then
                    Me._name = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="address")> _
        Public Property Address() As String
            Get
                Return Me._address
            End Get
            Set(ByVal value As String)
                If (Me._address <> value) Then
                    Me._address = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="addressType")> _
        Public Property AddressType() As String
            Get
                Return Me._addressType
            End Get
            Set(ByVal value As String)
                If (Me._addressType <> value) Then
                    Me._addressType = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="channel")> _
   Public Property Channel() As String
            Get
                Return Me._channel
            End Get
            Set(ByVal value As String)
                If (Me._channel <> value) Then
                    Me._channel = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="from"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="from"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class from

        '''<remarks/>
        Private _name As String

        '''<remarks/>
        Private _address As String

        '''<remarks/>
        Private _addressType As String

        '''<remarks/>
        Private _channel As String


        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _name As String, ByVal _address As String, ByVal _addressType As String, ByVal _channel As String)
            MyBase.New()
            Me._name = _name
            Me._address = _address
            Me._addressType = _addressType
            Me._channel = _channel
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="name")> _
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                If (Me._name <> value) Then
                    Me._name = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="address")> _
        Public Property Address() As String
            Get
                Return Me._address
            End Get
            Set(ByVal value As String)
                If (Me._address <> value) Then
                    Me._address = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="addressType")> _
        Public Property AddressType() As String
            Get
                Return Me._addressType
            End Get
            Set(ByVal value As String)
                If (Me._addressType <> value) Then
                    Me._addressType = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="channel")> _
   Public Property Channel() As String
            Get
                Return Me._channel
            End Get
            Set(ByVal value As String)
                If (Me._channel <> value) Then
                    Me._channel = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="processingType"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="processingType")> _
    Public Enum processingType

        '''<remarks/>
        <System.Xml.Serialization.XmlEnumAttribute("0")> _
        Item0

        '''<remarks/>
        <System.Xml.Serialization.XmlEnumAttribute("1")> _
        Item1
    End Enum

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="deliveryType")> _
    Public Enum deliveryType

        '''<remarks/>
        <System.Xml.Serialization.XmlEnumAttribute("0")> _
        Item0

        '''<remarks/>
        <System.Xml.Serialization.XmlEnumAttribute("1")> _
        Item1
    End Enum

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="payloadManifest"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="payloadManifest"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class payloadManifest
        Friend m_oParent As ESBMessageEnvelopeProvider
        'Private Sub New()
        'End Sub
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying document object.
        ''' </summary>
        ''' <param name="oParent"></param>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New(ByVal oParent As ESBMessageEnvelopeProvider)
            m_oParent = oParent
            _documentDetails = New documentDetailsCol(m_oParent)
        End Sub
        '''<remarks/>
        Private _documentDetails As documentDetailsCol
        'Private _documentDetails As System.Collections.Generic.List(Of documentDetails)

        '''<remarks/>
        Private _attachmentDetails As System.Collections.Generic.List(Of attachmentDetails)

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _documentDetails As documentDetailsCol, ByVal _attachmentDetails As System.Collections.Generic.List(Of attachmentDetails))
            MyBase.New()
            Me._documentDetails = _documentDetails
            Me._attachmentDetails = _attachmentDetails
        End Sub

        <System.Xml.Serialization.XmlElementAttribute("documentDetails")> _
        Public Property DocumentDetails() As documentDetailsCol
            Get
                Return Me._documentDetails
            End Get
            Set(ByVal value As documentDetailsCol)
                Me._documentDetails = value
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute("attachmentDetails")> _
        Public Property AttachmentDetails() As System.Collections.Generic.List(Of attachmentDetails)
            Get
                Return Me._attachmentDetails
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of attachmentDetails))
                Me._attachmentDetails = value
            End Set
        End Property
    End Class


    <Serializable()> _
 Public Class documentDetailsCol : Inherits Collections.CollectionBase

        Friend m_oParent As ESBMessageEnvelopeProvider

        Public Sub New()

        End Sub

        '!!!Bloody! Serialization doesn't work with a private constructor!!!
        'Private Sub New()
        'End Sub
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying document object.
        ''' </summary>
        ''' <param name="oParent"></param>
        ''' <remarks>
        ''' When this object is deleted, the associated document object will also need to be delted...
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New(ByVal oParent As ESBMessageEnvelopeProvider)
            m_oParent = oParent
        End Sub

        Public Sub Add(ByVal item As documentDetails)
            List.Add(item)
        End Sub

        Public Sub Insert(ByVal index As Integer, ByVal item As documentDetails)
            If index > Count Or index < 0 Then
                'ERROR!!!
                Exit Sub
            End If
            List.Insert(index, item)
        End Sub

        Default Public Property Item(ByVal index As Integer) As documentDetails
            Get
                Return CType(List.Item(index), documentDetails)
            End Get
            Set(ByVal value As documentDetails)
                List.Insert(index, value)
            End Set

        End Property

        Protected Overrides Sub OnRemove(ByVal index As Integer, ByVal value As Object)
            'Also remove the appropriate item from the DocumentBodies Collection...
            m_oParent.payload.document.RemoveAt(index)
            m_oParent.m_lNumDocs = m_oParent.m_lNumDocs - 1
        End Sub
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="documentDetails"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="documentDetails"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class documentDetails
        Friend m_oParent As ESBMessageEnvelopeProvider

        '!!!Bloody! Serialization doesn't work with a private constructor!!!
        'Private Sub New()
        'End Sub
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying document object.
        ''' </summary>
        ''' <param name="oParent"></param>
        ''' <remarks>
        ''' When this object is deleted, the associated document object will also need to be delted...
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New(ByVal oParent As ESBMessageEnvelopeProvider)
            m_oParent = oParent
        End Sub
        '''<remarks/>
        Private _name As String

        '''<remarks/>
        Private _namespace As String

        '''<remarks/>
        Private _description As String

        '''<remarks/>
        Private _refKey As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _name As String, ByVal _namespace As String, ByVal _description As String, ByVal _refKey As String)
            MyBase.New()
            Me._name = _name
            Me._namespace = _namespace
            Me._description = _description
            Me._refKey = _refKey
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="name")> _
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                If (Me._name <> value) Then
                    Me._name = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="namespace")> _
        Public Property [Namespace]() As String
            Get
                Return Me._namespace
            End Get
            Set(ByVal value As String)
                If (Me._namespace <> value) Then
                    Me._namespace = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="description")> _
        Public Property Description() As String
            Get
                Return Me._description
            End Get
            Set(ByVal value As String)
                If (Me._description <> value) Then
                    Me._description = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlAttributeAttribute(DataType:="integer", AttributeName:="RefKey")> _
        Public Property RefKey() As String
            Get
                Return Me._refKey
            End Get
            Set(ByVal value As String)
                If (Me._refKey <> value) Then
                    Me._refKey = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="attachmentDetails"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="attachmentDetails"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class attachmentDetails : Implements IAttachment


        '''<remarks/>
        Private _index As String

        '''<remarks/>
        Private _filename As String

        '''<remarks/>
        Private _description As String

        '''<remarks/>
        Private _type As String

        '''<remarks/>
        Private _url As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _index As String, ByVal _filename As String, ByVal _description As String, ByVal _type As String, ByVal _url As String)
            MyBase.New()
            Me._index = _index
            Me._filename = _filename
            Me._description = _description
            Me._type = _type
            Me._url = _url
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="index")> _
        Public Property Index() As String Implements Interfaces.Envelope.IAttachment.index
            Get
                Return Me._index
            End Get
            Set(ByVal value As String)
                If (Me._index <> value) Then
                    Me._index = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="filename")> _
        Public Property Filename() As String Implements Interfaces.Envelope.IAttachment.filename
            Get
                Return Me._filename
            End Get
            Set(ByVal value As String)
                If (Me._filename <> value) Then
                    Me._filename = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="description")> _
        Public Property Description() As String Implements Interfaces.Envelope.IAttachment.description
            Get
                Return Me._description
            End Get
            Set(ByVal value As String)
                If (Me._description <> value) Then
                    Me._description = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="type")> _
        Public Property Type() As String Implements Interfaces.Envelope.IAttachment.type
            Get
                Return Me._type
            End Get
            Set(ByVal value As String)
                If (Me._type <> value) Then
                    Me._type = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="url")> _
        Public Property Url() As String Implements Interfaces.Envelope.IAttachment.url
            Get
                Return Me._url
            End Get
            Set(ByVal value As String)
                If (Me._url <> value) Then
                    Me._url = value
                End If
            End Set
        End Property




    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="targetSystem"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="targetSystem"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class targetSystem

        '''<remarks/>
        Private _systemID As String

        '''<remarks/>
        Private _url As String

        '''<remarks/>
        Private _environment As String

        '''<remarks/>
        Private _systemType As String

        '''<remarks/>
        Private _systemVersion As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _systemID As String, ByVal _url As String, ByVal _environment As String, ByVal _systemType As String, ByVal _systemVersion As String)
            MyBase.New()
            Me._systemID = _systemID
            Me._url = _url
            Me._environment = _environment
            Me._systemType = _systemType
            Me._systemVersion = _systemVersion
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="systemID")> _
        Public Property SystemID() As String
            Get
                Return Me._systemID
            End Get
            Set(ByVal value As String)
                If (Me._systemID <> value) Then
                    Me._systemID = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="url")> _
        Public Property Url() As String
            Get
                Return Me._url
            End Get
            Set(ByVal value As String)
                If (Me._url <> value) Then
                    Me._url = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="environment")> _
        Public Property Environment() As String
            Get
                Return Me._environment
            End Get
            Set(ByVal value As String)
                If (Me._environment <> value) Then
                    Me._environment = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="systemType")> _
        Public Property SystemType() As String
            Get
                Return Me._systemType
            End Get
            Set(ByVal value As String)
                If (Me._systemType <> value) Then
                    Me._systemType = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="systemVersion")> _
        Public Property SystemVersion() As String
            Get
                Return Me._systemVersion
            End Get
            Set(ByVal value As String)
                If (Me._systemVersion <> value) Then
                    Me._systemVersion = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="service"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="service"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class service

        '''<remarks/>
        Private _name As String

        '''<remarks/>
        Private _namespace As String

        '''<remarks/>
        Private _version As String

        '''<remarks/>
        Private _context As String

        '''<remarks/>
        Private _description As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _name As String, ByVal _namespace As String, ByVal _version As String, ByVal _context As String, ByVal _description As String)
            MyBase.New()
            Me._name = _name
            Me._namespace = _namespace
            Me._version = _version
            Me._context = _context
            Me._description = _description
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="name")> _
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                If (Me._name <> value) Then
                    Me._name = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="namespace")> _
        Public Property [Namespace]() As String
            Get
                Return Me._namespace
            End Get
            Set(ByVal value As String)
                If (Me._namespace <> value) Then
                    Me._namespace = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="version")> _
        Public Property Version() As String
            Get
                Return Me._version
            End Get
            Set(ByVal value As String)
                If (Me._version <> value) Then
                    Me._version = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="context")> _
       Public Property Context() As String
            Get
                Return Me._context
            End Get
            Set(ByVal value As String)
                If (Me._context <> value) Then
                    Me._context = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="description")> _
        Public Property Description() As String
            Get
                Return Me._description
            End Get
            Set(ByVal value As String)
                If (Me._description <> value) Then
                    Me._description = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <Serializable()> _
    Partial Public Class customAttributes

        '''<remarks/>
        Private _name As String

        '''<remarks/>
        Private _value As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _name As String, ByVal _value As String)
            MyBase.New()
            Me._name = _name
            Me._value = _value
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="name")> _
        Public Property Name() As String
            Get
                Return Me._name
            End Get
            Set(ByVal value As String)
                If (Me._name <> value) Then
                    Me._name = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="value")> _
        Public Property Value() As String
            Get
                Return Me._value
            End Get
            Set(ByVal value As String)
                If (Me._value <> value) Then
                    Me._value = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", TypeName:="payloadType"), _
     System.Xml.Serialization.XmlRootAttribute("payload", [Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="payloadType"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class payloadType

        '''<remarks/>
        Private _document As System.Collections.Generic.List(Of System.Xml.XmlElement)

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _document As System.Collections.Generic.List(Of System.Xml.XmlElement))
            MyBase.New()
            Me._document = _document
        End Sub

        <System.Xml.Serialization.XmlElementAttribute("document")> _
        Public Property Document() As System.Collections.Generic.List(Of System.Xml.XmlElement)
            Get
                Return Me._document
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of System.Xml.XmlElement))
                Me._document = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="state"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="state"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class state

        '''<remarks/>
        Private _handle As String

        '''<remarks/>
        Private _process As String

        '''<remarks/>
        Private _referenceID As String

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _handle As String, ByVal _process As String, ByVal _referenceID As String)
            MyBase.New()
            Me._handle = _handle
            Me._process = _process
            Me._referenceID = _referenceID
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="handle")> _
        Public Property Handle() As String
            Get
                Return Me._handle
            End Get
            Set(ByVal value As String)
                If (Me._handle <> value) Then
                    Me._handle = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="process")> _
        Public Property Process() As String
            Get
                Return Me._process
            End Get
            Set(ByVal value As String)
                If (Me._process <> value) Then
                    Me._process = value
                End If
            End Set
        End Property

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="referenceID")> _
        Public Property ReferenceID() As String
            Get
                Return Me._referenceID
            End Get
            Set(ByVal value As String)
                If (Me._referenceID <> value) Then
                    Me._referenceID = value
                End If
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute(AnonymousType:=True, TypeName:="targetSystems"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=False, ElementName:="targetSystems"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class targetSystems

        '''<remarks/>
        Private _targetSystem As System.Collections.Generic.List(Of targetSystem)

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _targetSystem As System.Collections.Generic.List(Of targetSystem))
            MyBase.New()
            Me._targetSystem = _targetSystem
        End Sub

        <System.Xml.Serialization.XmlElementAttribute("targetSystem")> _
        Public Property TargetSystem() As System.Collections.Generic.List(Of targetSystem)
            Get
                Return Me._targetSystem
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of targetSystem))
                Me._targetSystem = value
            End Set
        End Property
    End Class

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "2.0.50727.42"), _
     System.SerializableAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", TypeName:="ESBMessageEnvelopeType"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:au.com.keystroke.esb.envelope.esbMessageEnvelope." & _
        "version_1_0_0_0", IsNullable:=True, ElementName:="ESBMessageEnvelopeType"), _
     System.ComponentModel.TypeConverterAttribute(GetType(System.ComponentModel.ExpandableObjectConverter))> _
    Partial Public Class ESBMessageEnvelopeType

        '''<remarks/>
        Private _header As headerType

        '''<remarks/>
        Private _payload As System.Collections.Generic.List(Of System.Xml.XmlElement)

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal _header As headerType, ByVal _payload As System.Collections.Generic.List(Of System.Xml.XmlElement))
            MyBase.New()
            Me._header = _header
            Me._payload = _payload
        End Sub

        <System.Xml.Serialization.XmlElementAttribute(ElementName:="header")> _
        Public Property Header() As headerType
            Get
                Return Me._header
            End Get
            Set(ByVal value As headerType)
                If (value Is Nothing) Then
                    Throw New System.ArgumentNullException("Header")
                End If
                Me._header = value
            End Set
        End Property

        <System.Xml.Serialization.XmlArrayItemAttribute("document", IsNullable:=False), _
         System.Xml.Serialization.XmlArrayAttribute(ElementName:="payload")> _
        Public Property Payload() As System.Collections.Generic.List(Of System.Xml.XmlElement)
            Get
                Return Me._payload
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of System.Xml.XmlElement))
                Me._payload = value
            End Set
        End Property
    End Class
End Namespace
