﻿Imports System.Activities
Imports esb.Core.Interfaces.Envelope
Imports esb.Core.XMLSchemaClasses

Public NotInheritable Class CodeActivity1
    Inherits CodeActivity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope

    'Define an activity input argument of type IEnvelope
    <RequiredArgument()> _
    Property EnvRq() As InArgument(Of IEnvelope)

    Protected Overrides Function Execute(ByVal context As System.Activities.CodeActivityContext) As Core.Interfaces.Envelope.IEnvelope
        'Obtain the runtime value of the Envelope input argument
        Dim oEnv As IEnvelope
        oEnv = context.GetValue(Me.EnvRq)
        oEnv.SetCustomParam("WF4 Custom Param", "Ola!") 'gets stripped at ESB perimeter

        oEnv.AddDocument(New InlineDocument("<Ola/>"))
        oEnv.AddDocument(New InlineDocument("<AS:Ola xmlns:AS='urn:AnSt' />"))

        Return oEnv
    End Function
End Class
