﻿Imports CbaMobileServices
Imports System.Xml
Imports System.Linq



Public Class Form1
    Dim m_oCbaMobileServices As New CbaMobileServices.CbaMobileServices
    Dim m_dAmt As Decimal


    Private Sub btnSendLoginRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendLoginRequest.Click
        m_oCbaMobileServices.Username = txtUsername.Text
        m_oCbaMobileServices.Password = txtPassword.Text

        With m_oCbaMobileServices
            ' TextBox1.Text = .ConvertJsonDataToXml(.SendData(.LoadData2(), .MakeFullUrl("mobile/i/AjaxCalls.aspx")))
            TextBox1.Text = .RetrieveAccountPortfolio()
            lblResponseTime.Text = .ResponseTime
        End With

        PopulateAccountListCombo(TextBox1.Text)



    End Sub
    Private Sub btnSendTxnHistoryRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendTxnHistoryRequest.Click
        With m_oCbaMobileServices
            'TextBox2.Text = .ConvertJsonDataToXml(.SendData(.LoadData3(), .MakeFullUrl("mobile/i/AjaxCalls.aspx")))
            'TextBox2.Text = .RetrieveTxnHistory(1)
            'TextBox2.Text = .RetrieveTxnHistory(2)
            'TextBox2.Text = .RetrieveTxnHistory("5353 1813 0140 1089")
            'TextBox2.Text = .RetrieveTxnHistory(cmbAccounts.SelectedIndex)
            TextBox2.Text = .RetrieveTxnHistory(cmbAccounts.SelectedIndex + 1)
            'TODO: Need to do some paging for when not enough txn's returned.
            'i.e if we only receive 20 txns, we'll need to page. We need 30 days worth of...
            'UNFORTUNATELY, Mobile API DOES NOT SUPPORT PAGING!
            'It only returns first 50-60 records or so. Not sure of exact rules...
            'so workaround will be to reduce the interest free days supported to be whatever the max. number of days returned in txn. History.
            'This is an issue for people who have very active credit cards...


            lblResponseTime.Text = .ResponseTime

        End With
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetNonInterestFreeBalance.Click
        Dim sAccountNumber As String = "5353 1813 0140 1089"
        Dim sXpathAccountBalance As String = "/root/AccountGroups/ListAccount[AccountNumber=""" & sAccountNumber & """]/Balance"
        Dim sXpathAccountId As String = "/root/AccountGroups/ListAccount[AccountNumber=""" & sAccountNumber & """]/Id"
        '/root/AccountGroups/ListAccount[AccountNumber="5353 1813 0140 1089"]/Id
        '/root/AccountGroups/ListAccount[AccountNumber="5353 1813 0140 1089"]/Balance

        Dim oXmlDocument As New XmlDocument()
        oXmlDocument.LoadXml(m_oCbaMobileServices.AccountPortfolio)
        Dim sAccountBalance As String = oXmlDocument.SelectSingleNode(sXpathAccountBalance).InnerText
        Dim sAccountId As String = oXmlDocument.SelectSingleNode(sXpathAccountId).InnerText

        txtCurrentBalance.Text = sAccountBalance
        txtAccountId.Text = sAccountId


    End Sub

    Private Sub btnGetInterestFreeBalance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetInterestFreeBalance.Click
        txtInterestFreeBalance.Text = CalculateInterestFreeBalances(m_oCbaMobileServices.AccountPortfolio)
    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sXml"></param>
    ''' <returns></returns>
    ''' <remarks>
    '''(A)Get the Debit balance that's been accrued in the past 30(or interest free...) days. All of this Debit is Interest Free. eg. $2500 DR
    '''(B)Compare this to the Current Debit Balance.                                                                              eg. $3000 DR
    '''(C) We need to transfer B-A to get the remaining balance into the Interest Free Zone... (only if it's a positive number!)  eg. $500 Transfer...
    ''' </remarks>
    Public Function CalculateInterestFreeBalances(ByVal sXml As String) As String

        Dim oEsbXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

        'AccountBalances
        'Dim oXmlObj As New FOLMobileClient.XmlSchemaClasses.CbaMobile.AccountBalances.root
        'oXmlObj = oEsbXmlUtil.DeSerialize(TextBox1.Text, GetType(FOLMobileClient.XmlSchemaClasses.CbaMobile.AccountBalances.root))

        'TransactionHistory
        Dim oXmlTh As New FOLMobileClient.XmlSchemaClasses.CbaMobile.TransactionHistoryRs.version_1_0_0_0.root
        oXmlTh = oEsbXmlUtil.DeSerialize(TextBox2.Text, GetType(FOLMobileClient.XmlSchemaClasses.CbaMobile.TransactionHistoryRs.version_1_0_0_0.root))
        Dim oTS As New TimeSpan(30, 0, 0, 0)

        For Each oTxn As FOLMobileClient.XmlSchemaClasses.CbaMobile.TransactionHistoryRs.version_1_0_0_0.rootTransactions In oXmlTh.Transactions
            If oTxn.EffectiveDate > Today() - oTS Then
                CumulateAmount(oTxn.Amount)
            End If
        Next

        Return m_dAmt.ToString


    End Function

    Public Function CumulateAmount(ByVal sAmt As String) As Decimal
        If InStr(sAmt, "CR") Then Return 0
        If InStr(sAmt, "DR") Then
            sAmt = Replace(sAmt, "DR", "")
            sAmt = Replace(sAmt, "$", "")

            m_dAmt += sAmt
            Return sAmt
        End If
    End Function



    Public Sub PopulateAccountListCombo(ByVal sXml As String)
        cmbAccounts.Items.Clear()

        Dim sXpathAccounts As String = "/root/AccountGroups/ListAccount"

        Dim oXmlDocument As New XmlDocument()
        oXmlDocument.LoadXml(sXml)
        Dim oNodelist As XmlNodeList = oXmlDocument.SelectNodes(sXpathAccounts)

        For Each onode As XmlNode In oNodelist

            'Dim oListItem As New System.Windows.Forms.ComboBox

            cmbAccounts.Items.Add(onode.InnerText)
        Next

    End Sub

    Private Sub Button3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PopulateAccountListCombo(TextBox1.Text)
    End Sub

    Private Sub CreateXMLforJSONData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateXMLforJSONData.Click
        CreateXML_XSD_Code("C:\Data\Projects\CBA\NetBankJsonApi\FOLMobileClient\Data\Json")
    End Sub

    Public Sub CreateXML_XSD_Code(ByVal sJsonDataPath As String)
        Dim oCbaMobSvcs As New CbaMobileServices.CbaMobileServices
        Dim sBaseXSDPath As String = "C:\Program Files (x86)\Microsoft SDKs\Windows\v6.0A\bin\"
        Dim sBaseXSD2CodePath As String = "C:\ESB\Dev\Source\ESB\Base\Bin\Tools\"

        Dim sXmlFilenamePath As String
        Dim sXsdFilenamePath As String
        Dim sCodeFilenamePath As String

        Dim scXsdCmdLine As New System.Collections.Specialized.StringCollection()
        Dim saXsdCmdLine(0) As String
        scXsdCmdLine.Add("")

        Dim scXsd2CodeCmdLine As New System.Collections.Specialized.StringCollection()
        Dim saXsd2CodeCmdLine(0) As String
        scXsd2CodeCmdLine.Add("")

        Dim sFilePath As String
        Dim sFileName As String




        For Each sFilePath In My.Computer.FileSystem.GetFiles(oCbaMobSvcs.BaseFilePath & "Json")
            sFileName = My.Computer.FileSystem.GetName(sFilePath)
            With oCbaMobSvcs
                'Convert JSON to XML
                sXmlFilenamePath = oCbaMobSvcs.BaseFilePath & "XML\" & sFileName & ".xml"
                My.Computer.FileSystem.WriteAllText(sXmlFilenamePath, .ConvertJsonDataToXml(.GetRequestFromFile("json\" & sFileName)), False)

                'Generate XSD from XML
                'scXsdCmdLine(0) = sBaseXSDPath & "xsd.exe " & sXmlFilenamePath & " /outputdir:" & oCbaMobSvcs.BaseFilePath & "XSD\"
                'scXsdCmdLine.CopyTo(saXsdCmdLine, 0)
                sXsdFilenamePath = oCbaMobSvcs.BaseFilePath & "XSD\" & sFileName & ".xsd"

                Dim op As New System.Diagnostics.Process
                op = System.Diagnostics.Process.Start(sBaseXSDPath & "xsd.exe", sXmlFilenamePath & " /outputdir:" & oCbaMobSvcs.BaseFilePath & "XSD\")
                op.WaitForExit()
                'Generate Code Serialization Classes from XSD
                'C:\ESB\Dev\Source\ESB\Base\Bin\Tools\xsd2code AccountBalances.xsd CbaMobile.AccountBalances.version_1_0_0_0 AccountBalances.vb vb 

                scXsd2CodeCmdLine(0) = sBaseXSD2CodePath & "xsd2code.exe " & sXsdFilenamePath & " " & GetNamespaceFromFileName(sFileName) & " " & oCbaMobSvcs.BaseFilePath & "Code\" & GetCodeFileNameFromFileName(sFileName)
                scXsd2CodeCmdLine.CopyTo(saXsd2CodeCmdLine, 0)

                op = System.Diagnostics.Process.Start(sBaseXSD2CodePath & "xsd2code.exe", sXsdFilenamePath & " " & GetNamespaceFromFileName(sFileName) & " " & oCbaMobSvcs.BaseFilePath & "Code\" & GetCodeFileNameFromFileName(sFileName) & " vb")
                op.WaitForExit()

                sCodeFilenamePath = oCbaMobSvcs.BaseFilePath & "Code\" & sFileName & ".vb"
            End With

        Next

    End Sub

    Private Function GetNamespaceFromFileName(ByVal sFilename As String) As String
        Return "CbaMobile." & Split(sFilename, ".")(0) & Split(sFilename, ".")(1) & ".version_1_0_0_0"
    End Function

    Private Function GetCodeFileNameFromFileName(ByVal sFilename As String) As String
        Return Split(sFilename, ".")(0) & Split(sFilename, ".")(1) & ".vb"
    End Function


    Private Sub btnSendInitTransferRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendInitTransferRequest.Click
        txtInitTransferRs.Text = m_oCbaMobileServices.InitTransfer()
        lblResponseTime.Text = m_oCbaMobileServices.ResponseTime

        PopulateAccountListComboForTransfer(txtInitTransferRs.Text)

    End Sub

    '/root/AccountsFrom[AccountNumber="2799 1066 5512"]/Id

    Private Sub btnCalcAmtToTransfer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalcAmtToTransfer.Click
        txtTransferAmountToEnsureInterestFreeBalance.Text = -GetBalance(txtCurrentBalance.Text) - GetBalance(txtInterestFreeBalance.Text)
    End Sub

    Private Function GetBalance(ByVal sAmt As String) As Decimal

        If InStr(sAmt, "CR") Then
            sAmt = Replace(sAmt, "CR", "")
            sAmt = Replace(sAmt, "$", "")

            Return sAmt

        ElseIf InStr(sAmt, "DR") Then
            sAmt = Replace(sAmt, "DR", "")
            sAmt = Replace(sAmt, "$", "")

            Return -sAmt


        Else
            sAmt = Replace(sAmt, "$", "")
            Return sAmt
            'Throw New Exception("Invalid Amount Format" & sAmt)
        End If



    End Function

    Public Sub PopulateAccountListComboForTransfer(ByVal sXml As String)
        cmbAccounts.Items.Clear()

        Dim sXpathAccountsFrom As String = "/root/AccountsFrom"
        Dim sXpathAccountsToLinked As String = "/root/AccountsToLinked"
        Dim sXpathAccountsToNotlinked As String = "/root/AccountsToNotLinked"

        Dim oXmlDocument As New XmlDocument()
        oXmlDocument.LoadXml(sXml)
        Dim oNodelist As XmlNodeList = oXmlDocument.SelectNodes(sXpathAccountsFrom)

        For Each onode As XmlNode In oNodelist
            cmbFromAccounts.Items.Add(onode.InnerText)
        Next

        'Dim oNodelistTo As XmlNodeList = oXmlDocument.SelectNodes(sXpathAccountsToLinked)

        'For Each onode As XmlNode In oNodelistTo
        '    cmbToAccounts.Items.Add(onode.InnerText)
        '    'cmbToAccounts.Items.Add(onode.id onode.InnerText)
        'Next

        'Dim oNodelistToNL As XmlNodeList = oXmlDocument.SelectNodes(sXpathAccountsToNotlinked)

        'For Each onode As XmlNode In oNodelistToNL
        '    cmbToAccounts.Items.Add(onode.InnerText)
        'Next


        Dim xeAccounts As XDocument = XDocument.Parse(sXml)
        'Dim xeAccounts As XElement = XElement.Parse(sXml)
        For Each xe As XElement In xeAccounts.<root>.<AccountsToLinked>
            'MsgBox(xe.<Id>.Value)
            cmbToAccounts.Items.Add(xe.<Id>.Value & "***" & xe.<AccountNumber>.Value)
        Next


    End Sub

    Private Sub btnTransferMinForIntFreeBalance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTransferMinForIntFreeBalance.Click
        If txtTransferAmountToEnsureInterestFreeBalance.Text > 0 Then
            'do the transfer...



        End If
    End Sub

    Private Function ConstructTransferRq() As String
        Dim srcTree As XDocument = _
    <?xml version="1.0" encoding="utf-8"?>
    <root>
        <Params>
            <Name>Request</Name>
            <Value>validateTransfer</Value>
        </Params>
        <Params>
            <Name>AccountFromId</Name>
            <Value>1</Value>
        </Params>
        <Params>
            <Name>AccountToId</Name>
            <Value>10</Value>
        </Params>
        <Params>
            <Name>Description</Name>
            <Value>x200903232327x</Value>
        </Params>
        <Params>
            <Name>Amount</Name>
            <Value>1.05</Value>
        </Params>
    </root>

        srcTree.<root>.<Params>.<Name>.Ancestors().<Value> = 99



        'Dim doc As XDocument = _
        '    <?xml version="1.0" encoding="utf-8" standalone="yes"?>
        '    <!--this is a comment-->
        '    <root>
        '        <%= From el In srcTree.<root>.Elements _
        '            Where CStr(el).StartsWith("data") _
        '            Select el %>
        '    </root>
        ''Console.WriteLine(doc)


    End Function


    Private Sub btnTestInitTransferResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTestInitTransferResponse.Click
        PopulateAccountListComboForTransfer(txtInitTransferRs.Text)
    End Sub
End Class


