﻿Imports ESB.Core.XMLSchemaClasses.ErrorXML


Module ExtensionMethods

    <System.Runtime.CompilerServices.Extension()> _
Public Sub AddError(ByRef oEnv As ESBEnvelope.Envelope, Optional ByVal sErrorCode As String = "", Optional ByVal sErrorSource As String = "", Optional ByVal sErrorDescription As String = "")
        Dim oErr As New ErrorXML
        Dim oErrEntry As New ErrorEntry
        oErrEntry.Code = sErrorCode
        oErrEntry.Description = sErrorDescription
        oErrEntry.Source = sErrorSource
        oErr.ErrorEntry.Add(oErrEntry)

        oEnv.AddDocument(New InlineDocument(oErr))
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
Public Sub AddError(ByRef oEnv As IEnvelope, Optional ByVal sErrorCode As String = "", Optional ByVal sErrorSource As String = "", Optional ByVal sErrorDescription As String = "")
        Dim oErr As New ErrorXML
        Dim oErrEntry As New ErrorEntry
        oErrEntry.Code = sErrorCode
        oErrEntry.Description = sErrorDescription
        oErrEntry.Source = sErrorSource
        oErr.ErrorEntry.Add(oErrEntry)

        oEnv.AddDocument(New InlineDocument(oErr))
    End Sub

    <System.Runtime.CompilerServices.Extension()> _
Public Sub AddWarning(ByRef oEnv As IEnvelope, Optional ByVal sWarningCode As String = "", Optional ByVal sWarningSource As String = "", Optional ByVal sWarningDescription As String = "")
        Dim oErr As New ErrorXML
        Dim oWrnEntry As New WarningEntry
        oWrnEntry.Code = sWarningCode
        oWrnEntry.Description = sWarningDescription
        oWrnEntry.Source = sWarningSource
        oErr.WarningEntry.Add(oWrnEntry)

        oEnv.AddDocument(New InlineDocument(oErr))
    End Sub
End Module
