﻿Imports System.Activities
Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses

Public NotInheritable Class WarehouseDecisionActivity
    Inherits CodeActivity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope

    'Define an activity input argument of type IEnvelope
    <RequiredArgument()> _
    Property EnvRq() As InArgument(Of IEnvelope)
    Property ShouldWarehouse() As InOutArgument(Of Boolean)

    Protected Overrides Function Execute(ByVal context As System.Activities.CodeActivityContext) As Core.Interfaces.Envelope.IEnvelope
        Dim oEnv As IEnvelope = Nothing

        Try
            oEnv = context.GetValue(Me.EnvRq)

            'Dim oISO20022Doc As CBA.Payments.ISO20022.Document
            '  oISO20022Doc = oEnv.GetDocumentAsObject(GetType(CBA.Payments.ISO20022.Document))

            Me.ShouldWarehouse.Set(context, False)

            '  oEnv.SetCustomParam("WF4 Custom Param", "Ola!") 'gets stripped at ESB perimeter
            oEnv.AddDocument(New InlineDocument("<AS:Ola xmlns:AS='urn:AnSt' >Not warehousing payment.</>"))

            Return oEnv

        Catch ex As Exception
            Me.ShouldWarehouse.Set(context, False)
            oEnv.AddDocument(New InlineDocument("<AS:Ola xmlns:AS='urn:AnSt'>" & Util.EscapeXmlString(ex.ToString) & "</AS:Ola>"))
            Return oEnv
        Finally

        End Try

    End Function
End Class
