'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

''' 
'''  <summary>
''' 
''' </summary>
''' <remarks></remarks>

<ESB.Core.Util.Attributes.Service(), ESB.Core.Util.Attributes.Documents("BuildCmd2", "urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2")> _
Public Class serviceHandler1
    Inherits ServiceBase

    Dim m_oDocRq As Object 'Todo: replace 'Object' with your schema request class eg.Dim m_oDocRq As MemberEnquiryRQ.MemberDetailsEnquiryRQ
    Dim m_oDocRs As Object 'Todo: replace 'Object' with your schema response class eg. Dim m_oDocRs As MemberEnqRSUpdRQ.MemberEnqRSUpdRQ 

    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)

            '(This statement gets a document out of the request envelope. This is your service input.)
            'todo: replace this with your schema request class
            'm_oDocRq = oEnv.GetDocumentAsObject(GetType(MemberEnquiryRQ.MemberDetailsEnquiryRQ)  

            'todo: replace this with your schema response class
            'm_oDocRs = New MemberEnqRSUpdRQ.MemberEnqRSUpdRQ	  


            'Uncomment to get any custom parameters specified in the Pipeline config file for this request
            'sParam1 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param1Name")
            'sParam2 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param2Name")

            'This is where you manipulate your document, create a response etc.
            DoWork()

            'Example method to do XSLT
            'DoXslt()

            'Add the response document to the response envelope
            '(This is how your response is sent back)
            m_oEnvRs.AddDocument(New InlineDocument("<a>Hello Convention over Configuration in ESB.NET !!! Woohoo47!!!</a>"))
            'm_oEnvRs.AddDocument(New InlineDocument(m_oDocRs))

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        'Todo: Populate this method with your logic

    End Sub

    'This method shows you how to invoke an XSLT Transformation based upon config parameters
    'for a particular service configuration
    Protected Sub DoXslt()

        ' Get the custom parameters which indicate the xslt Resolvename and Context
        'These parameters are used to lookup the XSLT Pipeline Config file
        'which you need to configure to point to your XSLT file.
        Dim sXsltResolveName1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTResolveName1")
        Dim sXsltContext1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTContext1")

        ' Get the xml we will pass to xslt processing...
        'Get document from envelope by index or by type (or both)
        'sXsltInputXml = m_oEnvrq.GetDocument(GetType(<InsertDocumentTypeHere>)).GetAsString()
        'Get first document from Envelope & transform
        Dim sXsltInputXml As String = m_oEnvRq.GetDocument(0).GetAsString()

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml)

        ' Output from xslt processing goes here... 

        'Get the XSLT Manager to do the transform for us to extract the address information...
        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Calling XSLT processing, passing ResolveName = " _
                                            & sXsltResolveName1 _
                                            & ", Context = " _
                                            & sXsltContext1)
        Dim sXsltOutputXml As String = ""

        GetContext.Transform(sXsltResolveName1, sXsltContext1, sXsltInputXml, sXsltOutputXml)

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml & vbNewLine & " XSLT Output XML= " & sXsltOutputXml)

    End Sub
End Class

'Configure this class name 
'i.e. "ESB.Adaptors.Application.serviceHandler1.ServicedComponent"
'in the ESB.NET Service Pipeline if this service is to be hosted by COM+ rather than directly by the .NET Runtime
'<EventTrackingEnabled(True), Transaction(TransactionOption.Supported), System.Runtime.InteropServices.ProgId("ESB.Adaptors.Application.serviceHandler1.ServicedComponent")> _
'Public Class Service1ServicedComponent
'    Inherits ESBServicedComponent

'    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
'        Dim o As New serviceHandler1
'        Return o.ProcessMsgSync(oEnvRq)
'    End Function
'End Class