'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

''' 
'''  <summary>
''' 
''' </summary>
''' <remarks></remarks>

<ESB.Core.Util.Attributes.Service(), ESB.Core.Util.Attributes.ServiceVersion("1.0.0.0"), ESB.Core.Util.Attributes.Documents("BuildCmd2", "urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2")> _
Public Class InvokeViaConventionWithObjectBroker
    Inherits InvokeViaConvention
    Private Const STR_ObjectBrokerClass As String = "ObjectBrokerClass"
    Private Const STR_ObjectBrokerAssembly As String = "ObjectBrokerAssembly"


    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sTransactionComponent"></param>
    ''' <param name="sComponentServer"></param>
    ''' <returns></returns>
    ''' <remarks>Get Object Broker from Custom Params and pass in here...</remarks>
    Protected Overrides Function CreateObjectCLR(ByVal sTransactionComponent As String, ByVal sComponentServer As String) As Core.Interfaces.ProcessMsg.IProcessMsg
        Dim sTransactionComponentCP As String = m_oEnvRq.GetCustomParam(STR_ObjectBrokerClass)
        Dim sComponentServerCP As String = m_oEnvRq.GetCustomParam(STR_ObjectBrokerAssembly)

        If sTransactionComponentCP <> "" And sComponentServerCP <> "" Then
            Return MyBase.CreateObjectCLR(sTransactionComponentCP, sComponentServerCP)
        Else
            Return MyBase.CreateObjectCLR(sTransactionComponent, sComponentServer)
        End If
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="oESBIf"></param>
    ''' <param name="oEnvRq"></param>
    ''' <returns></returns>
    ''' <remarks> 
    ''' Invoke Object Broker, passing:
    ''' The equivalent for what a configured service has as
    ''' in Original Pipeline Transaction Component and Component Server...as Custom Params...
    ''' This is just the ResolveName/Context in this case.
    ''' As such, this method's not even required to be overridden...
    ''' Let Object Broker do with it what it likes...
    ''' </remarks>
    'Protected Overrides Function InvokeObjectCLR(ByVal oESBIf As Core.Interfaces.ProcessMsg.IProcessMsg, ByVal oEnvRq As Core.XMLSchemaClasses.ESBEnvelope.Envelope) As Core.XMLSchemaClasses.ESBEnvelope.Envelope
    '    Return MyBase.InvokeObjectCLR(oESBIf, oEnvRq)
    'End Function
End Class

