﻿Imports System.Activities
Imports System.Net.Mail

Public NotInheritable Class SendEmailCodeActivity
    Inherits CodeActivity

#Region "Properties"
    Property FromAddress As InArgument(Of String)
    Property ToAddress As InArgument(Of String)
    Property Body As InArgument(Of String)
    Property Subject As InArgument(Of String)
    Property HtmlBody As InArgument(Of Boolean)
    Property CcAddresses As InArgument(Of String)
    Property BccAddresses As InArgument(Of String)
    Property Port As InArgument(Of Integer)
    Property SmtpHost As InArgument(Of String)
    Property ReplyToAddress As InArgument(Of String)
#End Region

 

    ' If your activity returns a value, derive from CodeActivity(Of TResult)
    ' and return the value from the Execute method.
    Protected Overrides Sub Execute(ByVal context As CodeActivityContext)
        'Obtain the runtime value of the Text input argument
        'Dim text As String
        'text = context.GetValue(Me.ToAddress)

        Me.ToAddress = "minas_casiou@hotmail.com"
        Me.FromAddress = "minas_casiou@hotmail.com"
        Me.SmtpHost = "192.168.1.1"
        Me.Subject = "Test"
        Me.Port = 25

        Console.WriteLine("START attempt to send email")
        Try

            SendEmailUsingSmtp(context)

        Catch ex As Exception

        End Try

        Console.WriteLine("END attempt to send email")
    End Sub
    Protected Sub SendEmailUsingSmtp(ByVal context As CodeActivityContext)
        ' Create a new SmtpClient for sending the email
        Dim client As New SmtpClient()

        ' Use the properties of the activity to construct a new MailMessage
        Dim message As New MailMessage()
        message.From = New MailAddress(Me.FromAddress.Get(context))
        message.To.Add(Me.ToAddress.Get(context))


        ' Assign the message values if they are valid.
        If Not String.IsNullOrEmpty(Me.CcAddresses.Get(context)) Then
            message.CC.Add(Me.CcAddresses.Get(context))
        End If

        If Not String.IsNullOrEmpty(Me.BccAddresses.Get(context)) Then
            message.Bcc.Add(Me.BccAddresses.Get(context))
        End If

        If Not String.IsNullOrEmpty(Me.Subject.Get(context)) Then
            message.Subject = Me.Subject.Get(context)
        End If

        If Not String.IsNullOrEmpty(Me.Body.Get(context)) Then
            message.Body = Me.Body.Get(context)
        End If

        If Not String.IsNullOrEmpty(Me.ReplyToAddress.Get(context)) Then
            message.ReplyTo = New MailAddress(Me.ReplyToAddress.Get(context))
        End If

        message.IsBodyHtml = Me.HtmlBody.Get(context)


        ' Set the SMTP host and send the mail
        client.Host = Me.SmtpHost.Get(context)
        client.Port = Me.Port.Get(context)
        client.Send(message)
    End Sub
End Class
