<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" 
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
				xmlns:tns="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"
				exclude-result-prefixes="tns">
	<xsl:output method="xml" encoding="UTF-8"/>
	
	<xsl:template match="/">
		<xsl:call-template name="ImportServiceDefinitions"/>
	</xsl:template>

	<xsl:template name="ImportServiceDefinitions">
		<tns:Services xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
						  xmlns:sd="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"
						  xsi:schemaLocation="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0 D:\Source\XMLClearinghouse\publish\au\gov\nsw\police\data\cim\technology\serviceDefinition\version_1_0_0_0\ServiceDefinition.xsd"	>

<!-- Edit the list below to specidy which Service Definition Files are to be part of this WSDL.-->

			<xsl:copy-of select="document('ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml')/tns:Services/tns:ServiceDefinition"/>
			<xsl:copy-of select="document('ServiceDefinition.createClassificationMappingOltp.version_1_0_0_0.xml')/tns:Services/tns:ServiceDefinition"/>
			<xsl:copy-of select="document('ServiceDefinition.deleteClassificationCodeOltp.version_1_0_0_0.xml')/tns:Services/tns:ServiceDefinition"/>
			<xsl:copy-of select="document('ServiceDefinition.deleteClassificationMappingOltp.version_1_0_0_0.xml')/tns:Services/tns:ServiceDefinition"/>

		</tns:Services>
	</xsl:template>
</xsl:stylesheet>
<!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="MergeServiceDefinitionsScenario" userelativepaths="yes" externalpreview="no" url="Input\ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml" htmlbaseurl="" outputurl="Output\MergedServiceDefinitions.xml" processortype="msxmldotnet" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="Input\ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml" srcSchemaRoot="ServiceGroup" AssociatedInstance="" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition><template match="/"><block path="xsl:call&#x2D;template" x="383" y="0"/></template><template name="ImportServiceDefinitions"></template></MapperBlockPosition><TemplateContext><template name="ImportServiceDefinitions" mode="" srcContextPath="/ServiceGroup" srcContextFile="file:///d:/Source/Services/TechnologyServices/Utilities/Xslt/ServiceDefinitionToWsdl/Input/ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml" targetContextPath="" targetContextFile=""/></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->