<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" 
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
				xmlns:tns="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"
				exclude-result-prefixes="tns">
	<xsl:output method="xml" encoding="UTF-8"/>
	
	<xsl:template match="/">
		<xsl:call-template name="ImportServiceDefinitions"/>
	</xsl:template>

	<xsl:template name="ImportServiceDefinitions">
		<tns:Services xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
						  xmlns:sd="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0"
						  xsi:schemaLocation="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0 C:\ESB\Dev\Source\ESB\Base\Manage\EMC\BSDL\BSDLtoWsdl\Input\Xsd\ServiceDefinition.xsd"	>

<!-- Edit the list below to specidy which Service Definition Files are to be part of this WSDL.-->

			<xsl:copy-of select="document('..\input\BSDL\ServiceDefinition.xml')/tns:Services/tns:ServiceDefinition"/>

		</tns:Services>
	</xsl:template>
</xsl:stylesheet>
