Imports ESB.XMLSchemaClasses.ESBEnvelope


Namespace IProcessMsg.NET

    Public Interface IProcessMsg
        Function ProcessMsgSync(ByRef oEnv As Envelope) As Envelope
        Sub ProcessMsgAsync(ByRef oEnv As Envelope)
    End Interface

    'Public Interface IProcessMsgIfSB

    '    'Used for convenience
    '    Function ProcessMsgSynchSB(ByVal sXMLrq As System.Text.StringBuilder) As System.Text.StringBuilder
    '    Function ProcessMsgAsynchSB(ByVal sXMLrq As System.Text.StringBuilder)

    '    'This method is only for ease of use...shows errors up separately...
    '    Function ProcessMsgBySB(ByVal sXMLrq As System.Text.StringBuilder, ByVal sXMLrs As System.Text.StringBuilder) As System.Text.StringBuilder


    'End Interface

    'Public Interface IProcessMsgIfByVal


    '    'Used for convenience
    '    Function ProcessMsgSynchByVal(ByVal sXMLrq As String) As String
    '    Function ProcessMsgAsynchByVal(ByVal sXMLrq As String)

    '    'This method is only for ease of use...shows errors up separately...
    '    Function ProcessMsgByVal(ByVal sXMLrq As String, ByVal sXMLrs As String) As String


    'End Interface

    'Public Interface IProcessMsgIfByRef

    '    'More efficient with large XML strings...as less is copied around.
    '    'It is also less likely to have stack overflow errors etc.
    '    Sub ProcessMsgSynch(ByRef sXMLrq As String, ByRef sXMLrs As String)
    '    Sub ProcessMsgASynch(ByRef sXMLrq As String)

    '    'This method is only for ease of use...shows errors up separately...
    '    Function ProcessMsg(ByRef sXMLrq As String, ByRef sXMLrs As String, ByVal sXMLerr As String)


    'End Interface

    'Public Interface IProcessMsgObj

    '    'More efficient with large XML strings...as less is copied around.
    '    'It is also less likely to have stack overflow errors etc.
    '    Sub ProcessMsgSynch(ByRef objIn As Object, ByRef objOut As Object)
    '    Sub ProcessMsgASynch(ByRef obj As Object)

    '    'This method is only for ease of use...shows errors up separately...
    '    Function ProcessMsg(ByRef objIn As Object, ByRef objOut As Object, ByVal objErr As Object)


    'End Interface


End Namespace