''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Imports ESB.Core.Interfaces.Envelope


<System.Workflow.Activities.ExternalDataExchange()> _
Public Interface IProcessMsg
    Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
    Sub ProcessMsgAsync(ByVal oEnv As IEnvelope)
End Interface


Public Interface IProcessMsgIfByVal

    Function ProcessMsgSync(ByVal sXMLrq As String) As String
    Sub ProcessMsgAsync(ByVal sXMLrq As String)

End Interface

Public Interface IProcessMsgIfByRef

    'More efficient with large XML strings...as less is copied around.
    'It is also less likely to have stack overflow errors etc.
    Sub ProcessMsgSync(ByRef sXMLrq As String, ByRef sXMLrs As String)
    Sub ProcessMsgASync(ByRef sXMLrq As String)


End Interface


