Public Class IPipelineTransitionData

    Protected m_oHandlerPipeline As New HandlerPipeline
    Protected m_oXSLTPipeline As New XSLTPipeline

    Public Sub ClearCollections()
        m_oHandlerPipeline.m_oVertical.m_oRqEnvelopesCol = New EnvelopeCol
        m_oHandlerPipeline.m_oVertical.m_oRsEnvelopesCol = New EnvelopeCol
        m_oHandlerPipeline.m_oHorizontal.m_oRqEnvelopesCol = New EnvelopeCol
        m_oHandlerPipeline.m_oHorizontal.m_oRsEnvelopesCol = New EnvelopeCol

        m_oXSLTPipeline.m_oHorizontal.m_oRqXMLNodeCol = New Specialized.StringCollection
        m_oXSLTPipeline.m_oHorizontal.m_oRsXMLNodeCol = New Specialized.StringCollection
        m_oXSLTPipeline.m_oVertical.m_oRqXMLNodeCol = New Specialized.StringCollection
        m_oXSLTPipeline.m_oVertical.m_oRsXMLNodeCol = New Specialized.StringCollection
    End Sub

    Public Property HandlerPipeline() As HandlerPipeline
        Get
            Return m_oHandlerPipeline
        End Get
        Set(ByVal Value As HandlerPipeline)
            m_oHandlerPipeline = Value
        End Set
    End Property

    Public Property XSLTPipeline() As XSLTPipeline
        Get
            Return m_oXSLTPipeline
        End Get
        Set(ByVal Value As XSLTPipeline)
            m_oXSLTPipeline = Value
        End Set
    End Property
End Class

Public Class HandlerPipeline
    Public m_oHorizontal As New HandlerPipelineEnvelopeCollection
    Public m_oVertical As New HandlerPipelineEnvelopeCollection
End Class

Public Class XSLTPipeline
    Public m_oHorizontal As New XSLTPipelineDataCollection
    Public m_oVertical As New XSLTPipelineDataCollection
End Class

Public Class HandlerPipelineEnvelopeCollection
    Public m_oRqEnvelopesCol As New EnvelopeCol
    Public m_oRsEnvelopesCol As New EnvelopeCol
End Class

Public Class XSLTPipelineDataCollection
    Public m_oRqXMLNodeCol As New Specialized.StringCollection
    Public m_oRsXMLNodeCol As New Specialized.StringCollection
End Class

Public Class EnvelopeCol : Inherits Collections.CollectionBase
    Public Sub Add(ByVal item As ESB.Core.Interfaces.Envelope.IEnvelope)
        List.Add(item)
    End Sub
    Public Sub Insert(ByVal index As Integer, ByVal item As ESB.Core.Interfaces.Envelope.IEnvelope)
        If index > Count Or index < 0 Then
            'ERROR!!!
            Exit Sub
        End If
        List.Insert(index, item)
    End Sub
    Default Public Property Item(ByVal index As Integer) As ESB.Core.Interfaces.Envelope.IEnvelope
        Get
            Return CType(List.Item(index), ESB.Core.Interfaces.Envelope.IEnvelope)
        End Get
        Set(ByVal value As ESB.Core.Interfaces.Envelope.IEnvelope)
            List.Insert(index, value)
        End Set
    End Property
End Class

