﻿Imports ESB.Core.XMLSchemaClasses.CustomConfigurationData
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports Microsoft.VisualBasic

Public Class EnvelopeConfigWrapper

    Public Sub New()
        GetConfigData()
    End Sub


    Private m_oCfgData As CustomConfigurationData

    Public Function GetEnvelopesFromConfigData() As EnvelopeCfg()
        Return m_oCfgData.Envelopes
    End Function

    Public Property UserControlCustomConfigurationData() As CustomConfigurationData
        Get
            Return m_oCfgData
        End Get
        Set(ByVal value As CustomConfigurationData)
            m_oCfgData = value
        End Set
    End Property

    Protected Overridable Sub GetConfigData()
        Dim m_sSourceSection As String = "ESB.Core.Envelopes"
        m_oCfgData = CType(ConfigurationManager.Read(m_sSourceSection), CustomConfigurationData)
        If m_oCfgData Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If
    End Sub
End Class
