<%@ Page Language="VB" AutoEventWireup="false" CodeFile="ViewLogsDB3.aspx.vb" Inherits="Authenticated_System_LogsManagement_ViewLogsDB3" %>

<%@ Register Src="../../../../UserControls/SendRequestUserControl.ascx" TagName="SendRequestUserControl"
    TagPrefix="uc1" %>
<%@ Register Assembly="wwDataBinder" Namespace="MsdnMag.Web.Controls" TagPrefix="ww" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>View Logs</title>
    <link href="~/Styles.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .style4
        {
            width: 933px;
        }
        .style5
        {
            width: 319px;
        }
        .style7
        {
            width: 423px;
        }
    </style>
</head>
<body style="height: 100%; width: 100%;">
    <form id="form1" style="height: 100%" runat="server">
    <asp:Menu ID="Menu1" runat="server" Orientation="Horizontal" Width="477px" BackColor="#B5C7DE"
        DynamicHorizontalOffset="2" Font-Names="Verdana" Font-Size="0.8em" ForeColor="#284E98"
        StaticSubMenuIndent="10px">
        <Items>
            <asp:MenuItem Text="Filters" Value="0"></asp:MenuItem>
            <asp:MenuItem Text="Requests" Value="1"></asp:MenuItem>
            <asp:MenuItem Text="Activities" Value="2"></asp:MenuItem>
            <asp:MenuItem Text="Activity Details" Value="3"></asp:MenuItem>
            <asp:MenuItem Text="XmlLogData" Value="4"></asp:MenuItem>
            <asp:MenuItem Text="ReSubmit" Value="5"></asp:MenuItem>
        </Items>
        <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
        <DynamicHoverStyle BackColor="#284E98" ForeColor="White" />
        <DynamicMenuStyle BackColor="#B5C7DE" />
        <StaticSelectedStyle BackColor="#507CD1" />
        <DynamicSelectedStyle BackColor="#507CD1" />
        <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
        <StaticHoverStyle BackColor="#284E98" ForeColor="White" />
    </asp:Menu>
    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
        <asp:View ID="FiltersView" runat="server">
            <table class="style4">
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblIndex" runat="server" Text="Label">Index</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtIndex" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblLogTime" runat="server" Text="Label">LogTime</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtLogTime" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblMessageID" runat="server" Text="Label">MessageID</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtMessageID" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblDomainInternalMessageID" runat="server" Text="Label">DomainInternalMessageID</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtDomainInternalMessageID" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblActivityID" runat="server" Text="Label">ActivityID</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtActivityID" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblResolveName" runat="server" Text="Label">ResolveName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtResolveName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblContext" runat="server" Text="Label">Context</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtContext" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblUserName" runat="server" Text="Label">UserName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtUserName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblESBInstanceName" runat="server" Text="Label">ESBInstanceName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtESBInstanceName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblTransportUrl" runat="server" Text="Label">TransportUrl</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtTransportUrl" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblTransportType" runat="server" Text="Label">TransportType</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtTransportType" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblTransportProfile" runat="server" Text="Label">TransportProfile</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtTransportProfile" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblComputerName" runat="server" Text="Label">ComputerName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtComputerName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblStatus" runat="server" Text="Label">Status</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtStatus" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblRequestSourceHost" runat="server" Text="Label">RequestSourceHost</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtRequestSourceHost" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblConversationID" runat="server" Text="Label">ConversationID</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtConversationID" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblServiceDomainName" runat="server" Text="Label">ServiceDomainName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtServiceDomainName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblClusterName" runat="server" Text="Label">ClusterName</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtClusterName" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblNodeRequestID" runat="server" Text="Label">NodeRequestID</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtNodeRequestID" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="style5">
                        <asp:Label ID="lblExecutionMode" runat="server" Text="Label">ExecutionMode</asp:Label>
                    </td>
                    <td class="style7">
                        <asp:TextBox ID="txtExecutionMode" runat="server" Width="714px"></asp:TextBox>
                    </td>
                </tr>
            </table>
            <asp:Button ID="btnSearch" runat="server" Text="Search" />
            <asp:Button ID="btnClearSearchCriteria" runat="server" Text="ClearSearchCriteria" />
            <asp:SqlDataSource ID="SqlDataSourceFilters" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                SelectCommand="SELECT [Index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, Context, RequestSourceHost, Duration, Status, UserName, ServiceKeys, ComputerName, IsServiceDomainEntryPoint, ServiceDomainName, ClusterName, NodeRequestID, ConversationID, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, ESBInstanceName, TransportUrl, TransportType, TransportProfile, ExecutionMode 
                      FROM ESBLogHeader 
                      WHERE ( IsNodeInstanceRequestMessage = 1 ) AND 
                            ( @varIndex='' OR [Index] Like @varIndex + '%' ) AND                            
                            ( @LogTime='' OR LogTime Like @LogTime + '%' ) AND
                            ( @MessageID='' OR MessageID Like @MessageID + '%' ) AND
                            ( @DomainInternalMessageID='' OR DomainInternalMessageID Like @DomainInternalMessageID + '%' ) AND
                            ( @ActivityID='' OR ActivityID Like @ActivityID + '%' ) AND
                            ( @ResolveName='' OR ResolveName Like @ResolveName + '%' ) AND
                            ( @Context='' OR Context Like @Context + '%' )  AND
                            ( @UserName='' OR UserName Like @UserName + '%' ) AND
                            ( @ESBInstanceName='' OR ESBInstanceName Like @ESBInstanceName + '%' )  AND
                            ( @TransportUrl='' OR TransportUrl Like @TransportUrl + '%' )  AND
                            ( @TransportType='' OR TransportType Like @TransportType + '%' )   AND
                            ( @TransportProfile='' OR TransportProfile Like @TransportProfile + '%' )  AND
                            ( @ComputerName='' OR ComputerName Like @ComputerName + '%' )  AND
                            ( @Status='' OR Status Like @Status + '%' )  AND
                            ( @RequestSourceHost='' OR RequestSourceHost Like @RequestSourceHost + '%' )  AND
                            ( @ConversationID='' OR ConversationID Like @ConversationID + '%' )  AND
                            ( @ServiceDomainName='' OR ServiceDomainName Like @ServiceDomainName + '%' )  AND
                            ( @ClusterName='' OR ClusterName Like @ClusterName + '%' )  AND
                            ( @NodeRequestID='' OR NodeRequestID Like @NodeRequestID + '%' ) AND 
                            ( @ExecutionMode='' OR ExecutionMode Like @ExecutionMode + '%' ) 
                      
                      ORDER BY [Index], LogTime, DomainInternalMessageID">
                <%--AND AND  AND ServiceKeys=@Param11 AND 
					AND IsServiceDomainEntryPoint=@Param13 AND 
					AND IsServiceDomainRequestMessage=@Param18 AND 
                --%>
                <SelectParameters>
                    <asp:ControlParameter ControlID="txtIndex" ConvertEmptyStringToNull="false" Name="varIndex"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtLogTime" ConvertEmptyStringToNull="false" Name="LogTime"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtMessageID" ConvertEmptyStringToNull="false" Name="MessageID"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtDomainInternalMessageID" ConvertEmptyStringToNull="false"
                        Name="DomainInternalMessageID" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtActivityID" ConvertEmptyStringToNull="false"
                        Name="ActivityID" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtResolveName" ConvertEmptyStringToNull="false"
                        Name="ResolveName" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtContext" ConvertEmptyStringToNull="false" Name="Context"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtUserName" ConvertEmptyStringToNull="false" Name="UserName"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtESBInstanceName" ConvertEmptyStringToNull="false"
                        Name="ESBInstanceName" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtTransportUrl" ConvertEmptyStringToNull="false"
                        Name="TransportUrl" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtTransportType" ConvertEmptyStringToNull="false"
                        Name="TransportType" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtTransportProfile" ConvertEmptyStringToNull="false"
                        Name="TransportProfile" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtComputerName" ConvertEmptyStringToNull="false"
                        Name="ComputerName" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtStatus" ConvertEmptyStringToNull="false" Name="Status"
                        PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtRequestSourceHost" ConvertEmptyStringToNull="false"
                        Name="RequestSourceHost" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtConversationID" ConvertEmptyStringToNull="false"
                        Name="ConversationID" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtServiceDomainName" ConvertEmptyStringToNull="false"
                        Name="ServiceDomainName" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtClusterName" ConvertEmptyStringToNull="false"
                        Name="ClusterName" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtNodeRequestID" ConvertEmptyStringToNull="false"
                        Name="NodeRequestID" PropertyName="Text" />
                    <asp:ControlParameter ControlID="txtExecutionMode" ConvertEmptyStringToNull="false"
                        Name="ExecutionMode" PropertyName="Text" />
                </SelectParameters>
            </asp:SqlDataSource>
            <br />
        </asp:View>
        <asp:View ID="Requests" runat="server">
            <strong><span style="color: blue">Request List</span></strong>
            <%--<asp:GridView ID="GridView1" runat="server" AllowPaging="True" AllowSorting="True" AutoGenerate CssClass="ESBGridStyle_xxSmall" Columns="False"
                    DataKeyNames="index" DataSourceID="SqlDataSource1" PageSize="50">
                --%><asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView1" runat="server" AllowPaging="True"
                    AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="Index,ESBInstanceName"
                    DataSourceID="SqlDataSourceFilters" PageSize="50">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <%--<asp:TemplateField ShowHeader="False">
                            <ItemTemplate>
                                <asp:LinkButton ID="ResubmitButton" runat="server" CausesValidation="false" CommandName=""
                                    OnClick="ResubmitButton_Click" Text="Resubmit"></asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>--%>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:BoundField DataField="Index" HeaderText="Index" InsertVisible="False" ReadOnly="True"
                            SortExpression="Index" />
                        <asp:BoundField DataField="ServiceDomainName" HeaderText="ServiceDomainName" SortExpression="ServiceDomainName" />
                        <asp:BoundField DataField="ESBInstanceName" HeaderText="ESBInstanceName" SortExpression="ESBInstanceName" />
                        <asp:BoundField DataField="ClusterName" HeaderText="ClusterName" SortExpression="ClusterName" />
                        <asp:BoundField DataField="ComputerName" HeaderText="ComputerName" SortExpression="ComputerName" />
                        <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                        <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                        <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                        <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                        <asp:BoundField DataField="ConversationID" HeaderText="ConversationID" SortExpression="ConversationID" />
                        <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                        <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID"
                            SortExpression="DomainInternalMessageID" />
                        <asp:BoundField DataField="NodeRequestID" HeaderText="NodeRequestID" SortExpression="NodeRequestID" />
                        <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                        <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                        <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                        <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                        <asp:BoundField DataField="ServiceKeys" HeaderText="ServiceKeys" SortExpression="ServiceKeys" />
                        <asp:BoundField DataField="TransportUrl" HeaderText="TransportUrl" SortExpression="TransportUrl" />
                        <asp:BoundField DataField="TransportType" HeaderText="TransportType" SortExpression="TransportType" />
                        <asp:BoundField DataField="TransportProfile" HeaderText="TransportProfile" SortExpression="TransportProfile" />
                        <asp:CheckBoxField DataField="IsNodeInstanceRequestMessage" HeaderText="IsNodeInstanceRequestMessage"
                            ReadOnly="True" SortExpression="IsNodeInstanceRequestMessage">
                            <ItemStyle Width="5px" />
                        </asp:CheckBoxField>
                        <asp:CheckBoxField DataField="IsServiceDomainRequestMessage" HeaderText="IsServiceDomainRequestMessage"
                            ReadOnly="True" SortExpression="IsServiceDomainRequestMessage" />
                        <asp:CheckBoxField DataField="IsServiceDomainEntryPoint" HeaderText="IsServiceDomainEntryPoint"
                            ReadOnly="True" SortExpression="IsServiceDomainEntryPoint" />
                        <asp:BoundField DataField="ExecutionMode" HeaderText="ExecutionMode" SortExpression="ExecutionMode" />
                    </Columns>
                </asp:GridView>
            <%--<asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                SelectCommand="SELECT  [Index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, Context, RequestSourceHost, Duration, Status, UserName, ServiceKeys, ComputerName, IsServiceDomainEntryPoint, ServiceDomainName, ClusterName, NodeRequestID, ConversationID, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, ESBInstanceName, TransportUrl, TransportType, TransportProfile, ExecutionMode FROM ESBLogHeader WHERE (IsNodeInstanceRequestMessage = 1) ORDER BY [Index], LogTime, DomainInternalMessageID">
            </asp:SqlDataSource>--%>
            <br />
            <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                SelectCommand="SELECT  [Index], LogTime, MessageID, DomainInternalMessageID, ActivityID, ResolveName, Context, RequestSourceHost, Duration, Status, ComputerName, UserName, RequestXML, ResponseXML, ServiceKeys, ConversationID, NodeRequestID, ClusterName, ServiceDomainName, IsServiceDomainEntryPoint, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, ESBInstanceName, TransportUrl, TransportType, TransportProfile, ExecutionMode, ESBInstanceName FROM ESBLogHeader WHERE (DomainInternalMessageID = (SELECT DISTINCT DomainInternalMessageID FROM ESBLogHeader AS ESBLogHeader_1 WHERE ([Index] = @Index )))" >
                <SelectParameters>
                    <asp:ControlParameter ControlID="GridView1" Name="Index" PropertyName="SelectedValue"
                        Type="String" />
                </SelectParameters>
            </asp:SqlDataSource>
        </asp:View>
        <asp:View ID="Activities" runat="server">
            <span style="color: blue"><strong>Activities for Selected Request</strong>&nbsp;</span>
            <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView2" runat="server" AllowPaging="True"
                AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="Index" DataSourceID="SqlDataSource2"
                PageSize="50">
                <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                <PagerSettings Position="TopAndBottom" />
                <RowStyle BackColor="#EFF3FB" />
                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                <EditRowStyle BackColor="#2461BF" />
                <AlternatingRowStyle BackColor="White" />
                <Columns>
                    <asp:TemplateField ShowHeader="False">
                        <ItemTemplate>
                            <asp:LinkButton ID="ResubmitButton" runat="server" CausesValidation="false" CommandArgument='<%#Eval("RequestXML")%>'
                                OnClick="ResubmitButton_Click" Text="Resubmit"> 
                            </asp:LinkButton>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:CommandField ShowSelectButton="True" />
                    <asp:BoundField DataField="Index" HeaderText="Index" InsertVisible="False" ReadOnly="True"
                        SortExpression="Index" />
                    <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                    <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                    <asp:BoundField DataField="ResolveName" HeaderText="ResolveName" SortExpression="ResolveName" />
                    <asp:BoundField DataField="Context" HeaderText="Context" SortExpression="Context" />
                    <asp:BoundField DataField="ConversationID" HeaderText="ConversationID" SortExpression="ConversationID" />
                    <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                    <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID"
                        SortExpression="DomainInternalMessageID" />
                    <asp:BoundField DataField="NodeRequestID" HeaderText="NodeRequestID" SortExpression="NodeRequestID" />
                    <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                    <asp:BoundField DataField="ESBInstanceName" HeaderText="ESBInstanceName" SortExpression="ESBInstanceName" />
                    <asp:BoundField DataField="ServiceDomainName" HeaderText="ServiceDomainName" SortExpression="ServiceDomainName" />
                    <asp:BoundField DataField="ClusterName" HeaderText="ClusterName" SortExpression="ClusterName" />
                    <asp:BoundField DataField="RequestSourceHost" HeaderText="RequestSourceHost" SortExpression="RequestSourceHost" />
                    <asp:BoundField DataField="ComputerName" HeaderText="ComputerName" SortExpression="ComputerName" />
                    <asp:BoundField DataField="UserName" HeaderText="UserName" SortExpression="UserName" />
                    <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                    <asp:BoundField DataField="ServiceKeys" HeaderText="ServiceKeys" SortExpression="ServiceKeys" />
                    <asp:BoundField DataField="RequestXML" HeaderText="RequestXML" SortExpression="RequestXML" />
                    <asp:BoundField DataField="ResponseXML" HeaderText="ResponseXML" SortExpression="ResponseXML" />
                    <asp:BoundField DataField="IsServiceDomainEntryPoint" HeaderText="IsServiceDomainEntryPoint"
                        SortExpression="IsServiceDomainEntryPoint" />
                    <asp:BoundField DataField="ExecutionMode" HeaderText="ExecutionMode" SortExpression="ExecutionMode" />
                </Columns>
            </asp:GridView>
        </asp:View>
        <asp:View ID="ActivityDetails" runat="server">
            <span style="color: blue"><strong>Trace for Selected Activity</strong>&nbsp;</span>
            <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView3" runat="server" AllowSorting="True"
                AutoGenerateColumns="False" DataKeyNames="Index" DataSourceID="SqlDataSource3"
                PageSize="50">
                <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                <PagerSettings Position="TopAndBottom" />
                <RowStyle BackColor="#EFF3FB" />
                <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                <EditRowStyle BackColor="#2461BF" />
                <AlternatingRowStyle BackColor="White" />
                <Columns>
                    <asp:CommandField ShowSelectButton="True" />
                    <asp:BoundField DataField="Index" HeaderText="Index" InsertVisible="False" ReadOnly="True"
                        SortExpression="Index" />
                    <asp:BoundField DataField="LogTime" HeaderText="LogTime" SortExpression="LogTime" />
                    <asp:BoundField DataField="MessageID" HeaderText="MessageID" SortExpression="MessageID" />
                    <asp:BoundField DataField="DomainInternalMessageID" HeaderText="DomainInternalMessageID"
                        SortExpression="DomainInternalMessageID" />
                    <asp:BoundField DataField="ActivityID" HeaderText="ActivityID" SortExpression="ActivityID" />
                    <asp:BoundField DataField="SourceCodeLocationDetails" HeaderText="SourceCodeLocationDetails"
                        SortExpression="SourceCodeLocationDetails" />
                    <asp:BoundField DataField="SourceCodeMethodDetails" HeaderText="SourceCodeMethodDetails"
                        SortExpression="SourceCodeMethodDetails" />
                    <asp:BoundField DataField="ProcessID" HeaderText="ProcessID" SortExpression="ProcessID" />
                    <asp:BoundField DataField="ThreadID" HeaderText="ThreadID" SortExpression="ThreadID" />
                    <asp:BoundField DataField="LogLevel" HeaderText="LogLevel" SortExpression="LogLevel" />
                    <asp:BoundField DataField="LogText" HeaderText="LogText" SortExpression="LogText" />
                    <asp:BoundField DataField="LogSummary" HeaderText="LogSummary" SortExpression="LogSummary" />
                    <asp:BoundField DataField="Status" HeaderText="Status" SortExpression="Status" />
                    <asp:BoundField DataField="XmlLogData" HeaderText="XmlLogData" SortExpression="XmlLogData" />
                    <asp:BoundField DataField="ExecutionMode" HeaderText="ExecutionMode" SortExpression="ExecutionMode" />
                </Columns>
            </asp:GridView>
            <asp:SqlDataSource ID="SqlDataSource3" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                SelectCommand="SELECT [Index], [LogTime], [MessageID], [DomainInternalMessageID], [ActivityID], [SourceCodeLocationDetails], [SourceCodeMethodDetails], [ProcessID], [ThreadID], [LogLevel], [LogText], [LogSummary], [Status], [XmlLogData], [ExecutionMode] FROM [ESBLogDetail] WHERE ([ActivityID] = (select [ActivityID] FROM [ESBLogHeader] WHERE [Index] = @Index)) ORDER BY [Index]">
                <SelectParameters>
                    <asp:ControlParameter ControlID="GridView2" Name="Index" PropertyName="SelectedValue"
                        Type="Int32" />
                </SelectParameters>
            </asp:SqlDataSource>
        </asp:View>
        <asp:View ID="XmlLogData" runat="server">
            <span style="height: 100%">
                <asp:Button ID="btnFormatXml" runat="server" Text="Format XML" Visible="False" />
                <asp:Label ID="Label1" runat="server"></asp:Label><br />
                <asp:TextBox ID="TextBox2" runat="server" Height="900px" TextMode="MultiLine" Width="95%"></asp:TextBox>
                <asp:SqlDataSource ID="SqlDataSource4" runat="server" ConnectionString="<%$ ConnectionStrings:ESBLogConnectionString %>"
                    SelectCommand="SELECT [XmlLogData] FROM [ESBLogDetail] WHERE ([Index] = @Index)">
                    <SelectParameters>
                        <asp:ControlParameter ControlID="GridView3" Name="Index" PropertyName="SelectedValue"
                            Type="Int32" />
                    </SelectParameters>
                </asp:SqlDataSource>
                <%--   
                    <ww:WebTextBox ID="WebTextBox1" runat="server" Height="500px" TextMode="MultiLine" Width="95%"  BindingItem-BindingSource="SqlDataSource4.DataBindingItem"
                        BindingItem-ControlId="WebTextBox1"  BindingItem-BindingProperty="XmlLogData" Visible="False" ></ww:WebTextBox>
               --%>
                <asp:GridView ID="GridView4" runat="server" AutoGenerateColumns="False" DataSourceID="SqlDataSource4"
                    Visible="False">
                    <Columns>
                        <asp:BoundField DataField="XmlLogData" HeaderText="XmlLogData" HtmlEncode="False"
                            SortExpression="XmlLogData" />
                    </Columns>
                </asp:GridView>
                &nbsp;
                <asp:Xml ID="Xml1" runat="server"></asp:Xml></span></asp:View>
        <asp:View ID="ReSubmit" runat="server">
            <uc1:SendRequestUserControl ID="SendRequestUserControl1" runat="server" />
        </asp:View>
    </asp:MultiView>
    </form>
</body>
</html>
