﻿Imports System.Messaging

Partial Class Authenticated_System_MSMQBrowser_QueueBrowser
    Inherits System.Web.UI.Page

    Shared m_oMsgQ As MessageQueue
    Dim m_oMsging As New ESB.Core.Services.Messaging

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Not IsPostBack Then
            Dim msgs As System.Messaging.Message() = GetMsgsList(TextBox2.Text, True)

            For Each a As System.Messaging.Message In msgs
                ListBox1.Items.Add(a.Id.ToString())
            Next
        End If

    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim m_oMsging As New ESB.Core.Services.Messaging
        TextBox1.Text = m_oMsging.PeekNextMsgFromQueue(TextBox2.Text)
        'TextBox1.Text = oMsging.GetNextMsgFromQueue(TextBox2.Text)
    End Sub

    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim sID As String
        sID = ListBox1.SelectedValue
        Dim formatter As XmlMessageFormatter = CType(m_oMsgQ.Formatter, XmlMessageFormatter)
        formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

        Dim oMsg As System.Messaging.Message = m_oMsgQ.PeekById(sID)
        ' Since message will be stored in XML fashion in MSMQ, you are formatting it
        TextBox1.Text = (oMsg.Body())

    End Sub

    Public Function GetMsgsList(ByVal sQPath As String, Optional ByVal bLeaveQOpen As Boolean = False) As System.Messaging.Message()
        Dim sc As New Specialized.StringCollection

        Try
            If (Not MessageQueue.Exists(sQPath)) Then
                Throw New Exception("The queue " & sQPath & " does not exist!")
                Exit Function
            End If

            m_oMsgQ = New MessageQueue
            m_oMsgQ.Path = sQPath

            Try
                Return m_oMsgQ.GetAllMessages()



            Catch ex As MessageQueueException
                ExceptionManager.Publish(ex)
                Throw
                'Return Nothing
            Catch ex As InvalidOperationException
                ExceptionManager.Publish(ex)
                Throw
                'Return Nothing
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw

        Finally
            If bLeaveQOpen = False Then
                If Not m_oMsgQ Is Nothing Then
                    m_oMsgQ.Close()
                End If
            End If
        End Try
    End Function
End Class
