<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:a="urn:Keystroke-com-au:ESB:Config:InteropPipelineCfg:Version:1-0-5" >
	<xsl:template match="/">
		<Services>
			<xsl:for-each select="configuration/ESB.Core.Pipeline/a:Config/a:PipelineConfig/*/a:PipelineMapSection/a:PipelineEntry">
				<ServiceData>
					<xsl:attribute name="Index">
						<xsl:value-of select="position()"/>
					</xsl:attribute>
					<xsl:attribute name="Context">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:Context"/>
					</xsl:attribute>
					<xsl:attribute name="ResolveName">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:ResolveName"/>
					</xsl:attribute>
					<xsl:attribute name="AlwaysExecute">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:MultiLevelOverrides/a:AlwaysExecute"/>
					</xsl:attribute>
					<xsl:attribute name="Layer">
					<!-- Get the HorizontalPre, Vertical or HorizontalPost value... -->
						<xsl:value-of select="name(../..)"/>
						<!-- above is same as:...	<xsl:value-of select="name(../parent::node())"/>-->
					</xsl:attribute>
					<xsl:attribute name="UrlEncodedContext">
						<xsl:value-of select="a:ResolveNameEntry/a:ContextEntry/a:Context"/>
					</xsl:attribute>
				</ServiceData>
			</xsl:for-each>
		</Services>
	</xsl:template>
</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\..\..\..\..\Configuration\XMLConfigFiles\InteropPipelineCfg.xml" htmlbaseurl="" outputurl="ServicePipelineForGridView.xml" processortype="msxmldotnet" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="..\..\..\..\..\Configuration\XMLConfigFiles\InteropPipelineCfg.xml" srcSchemaRoot="configuration" AssociatedInstance="" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition><template match="/"><block path="Services/xsl:for&#x2D;each" x="390" y="36"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute/xsl:value&#x2D;of" x="430" y="54"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute[1]/xsl:value&#x2D;of" x="390" y="72"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute[2]/xsl:value&#x2D;of" x="430" y="90"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute[3]/xsl:value&#x2D;of" x="390" y="108"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute[4]/xsl:value&#x2D;of" x="430" y="126"/><block path="Services/xsl:for&#x2D;each/ServiceData/xsl:attribute[5]/xsl:value&#x2D;of" x="390" y="144"/></template></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->