<%@ Register TagPrefix="uc1" TagName="SimpleDataGridWebUserControl" Src="../../UserControls/SimpleDataGridWebUserControl.ascx" %>

<%@ Page Language="vb" AutoEventWireup="false" Inherits="ESB.Management.Portal.SystemTestGridPage"
    CodeFile="SystemTestGridPage.aspx.vb" %>

<%@ Register Assembly="Chaliy.Web.UI.UpdatableXmlDataSource" Namespace="Chaliy.Web.UI"
    TagPrefix="cc1" %>
<%@ Register Src="../../UserControls/SetEndpointWebUserControl.ascx" TagName="SetEndpointWebUserControl"
    TagPrefix="uc2" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>SystemTestGridPage</title>
    <link href="~/Styles.css" rel="stylesheet" type="text/css" />
</head>
<body runat="server" style="height: 100%">
    <form id="Form1" method="post" runat="server">
    <p style="height: 100%">
        &nbsp;<asp:Menu ID="Menu1" runat="server" Orientation="Horizontal" BackColor="#B5C7DE"
            DynamicHorizontalOffset="2" Font-Names="Verdana" Font-Size="0.8em" ForeColor="#284E98"
            StaticSubMenuIndent="10px">
            <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <DynamicHoverStyle BackColor="#284E98" ForeColor="White" />
            <DynamicMenuStyle BackColor="#B5C7DE" />
            <StaticSelectedStyle BackColor="#507CD1" />
            <DynamicSelectedStyle BackColor="#507CD1" />
            <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
            <Items>
                <asp:MenuItem Selected="True" Text="Test Grid" Value="0"></asp:MenuItem>
                <asp:MenuItem Text="Request/Response Data" Value="1"></asp:MenuItem>
                <asp:MenuItem Text="Url" Value="2"></asp:MenuItem>
            </Items>
            <StaticHoverStyle BackColor="#284E98" ForeColor="White" />
        </asp:Menu>
        <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
            <asp:View ID="View1" runat="server">
                <asp:Button ID="btnTestAll" runat="server" Width="128px" Text="Test all checked">
                </asp:Button><asp:Button ID="btnSingleTest" runat="server" Width="128px" Text="Test single Selected ">
                </asp:Button><asp:Button ID="btnClearResults" runat="server" Width="88px" Text="Clear ">
                </asp:Button>&nbsp;<asp:CheckBox ID="chkGenerateSenderMessage" runat="server" Checked="True"
                    Text="GenerateSenderMessageID" />
                </asp:Button>&nbsp;<asp:CheckBox ID="chkEnableSimulation" runat="server" Checked="False"
                    Text="EnableSimulation" 
                    ToolTip="NOTE: Logging must be synchronous for this to work correctly" />
                <br />
                <asp:GridView CssClass="ESBGridStyle_xxSmall" ID="GridView1" runat="server" AllowPaging="True"
                    AutoGenerateColumns="False" DataSourceID="UpdatableXmlDataSource1" Height="90%"
                    PageSize="50" Width="1012px" runat="server" AllowSorting="True" EmptyDataText="There are no data records to display."
                    CellPadding="4" CellSpacing="1">
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <FooterStyle BackColor="#507CD1" ForeColor="White" Font-Bold="True" />
                    <PagerSettings Position="TopAndBottom" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Left" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <EditRowStyle BackColor="#2461BF" />
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                        <asp:CommandField ShowSelectButton="True" />
                        <asp:TemplateField HeaderText="IncludeInTest" SortExpression="IncludeInTest">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("IncludeInTest") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:CheckBox ID="CheckBox1" runat="server" Checked='<%# Bind("IncludeInTest") %>'
                                    AutoPostBack="True" CommandName='<%# "CheckChanged" %>' OnCheckedChanged="CheckBox1_CheckedChanged" />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="Name" HeaderText="Name" SortExpression="Name" />
                        <asp:BoundField DataField="Description" HeaderText="Description" SortExpression="Description" />
                        <asp:BoundField DataField="Result" HeaderText="Result" SortExpression="Result" />
                        <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                        <asp:BoundField DataField="InputPath" HeaderText="InputPath" SortExpression="InputPath" />
                        <asp:BoundField DataField="OutputPath" HeaderText="OutputPath" SortExpression="OutputPath" />
                        <asp:TemplateField HeaderText="ViewLogForRequest" SortExpression="ViewLogForRequest">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("ViewLogForRequest") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <%--<asp:Label ID="Label1" runat="server" Text='<%# Bind("ViewLogForRequest") %>'></asp:Label>--%>
                                <asp:HyperLink ID="HyperLink1" runat="server" NavigateUrl='<%# Eval("ViewLogForRequest") %>'>ViewLogForRequest</asp:HyperLink>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:CommandField ShowEditButton="True" />
                        <asp:CommandField ShowInsertButton="True" />
                        <asp:CommandField ShowDeleteButton="True" />
                    </Columns>
                </asp:GridView>
                <asp:XmlDataSource ID="XmlDataSource1" runat="server" DataFile="~/Authenticated/Testing/SystemTest2.config">
                </asp:XmlDataSource>
                <cc1:UpdatableXmlDataSource ID="UpdatableXmlDataSource1" runat="server" DataFile="~/Authenticated/Testing/SystemTest.config"
                    ItemNamespace="urn:Keystroke-com-au:ESB:Testing:SystemTest:Version:1-0-0" ItemPrefix="cfg"
                    ItemTagName="Test">
                </cc1:UpdatableXmlDataSource>
                <asp:DetailsView ID="DetailsView1" runat="server" AllowPaging="True" AutoGenerateRows="False"
                    DataSourceID="UpdatableXmlDataSource1" Height="10%" Width="100%">
                    <PagerSettings PageButtonCount="50" />
                    <Fields>
                        <asp:BoundField DataField="IncludeInTest" HeaderText="IncludeInTest" SortExpression="IncludeInTest" />
                        <asp:BoundField DataField="Name" HeaderText="Name" SortExpression="Name" />
                        <asp:BoundField DataField="Description" HeaderText="Description" SortExpression="Description" />
                        <asp:BoundField DataField="Result" HeaderText="Result" SortExpression="Result" />
                        <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" />
                        <asp:BoundField DataField="InputPath" HeaderText="InputPath" SortExpression="InputPath" />
                        <asp:BoundField DataField="OutputPath" HeaderText="OutputPath" SortExpression="OutputPath" />
                        <asp:BoundField DataField="ViewLogForRequest" HeaderText="ViewLogForRequest" SortExpression="ViewLogForRequest" />
                        <asp:CommandField ShowInsertButton="True" />
                        <asp:CommandField ShowEditButton="True" />
                        <asp:CommandField ShowDeleteButton="True" />
                    </Fields>
                </asp:DetailsView>
            </asp:View>
            <asp:View ID="View2" runat="server">
                <asp:Label ID="Label2" runat="server" Font-Size="XX-Small" Font-Names="Lucida Sans Unicode"
                    Font-Bold="True">Messages/Response</asp:Label><asp:Button ID="btnDisplayRequest"
                        runat="server" Style="z-index: 101; left: 21px; top: 506px" Font-Names="Lucida Sans Unicode"
                        Font-Size="XX-Small" Text="Display Request" Width="112px" />
                <asp:Button ID="btnUpdate" runat="server" Font-Names="Lucida Sans Unicode" Font-Size="XX-Small"
                    Style="z-index: 102; left: 143px; top: 507px" Text="Update" Width="112px" /><asp:Button
                        ID="btnClear" runat="server" Font-Names="Lucida Sans Unicode" Font-Size="XX-Small"
                        Style="z-index: 103; left: 265px; top: 506px" Text="Clear" Width="112px" /><br />
                <asp:TextBox ID="txtRequest" runat="server" Font-Names="Arial" Font-Size="X-Small"
                    Height="100%" Style="z-index: 104; left: 148px; top: 516px" TextMode="MultiLine"
                    Width="49%" Wrap="False"></asp:TextBox>
                <asp:TextBox ID="txtMessage" runat="server" Width="49%" Style="z-index: 105; left: 224px;
                    top: 619px" Font-Names="Arial" Font-Size="X-Small" Height="100%" TextMode="MultiLine"
                    Wrap="False"></asp:TextBox></asp:View>
            <asp:View ID="View3" runat="server">
                <uc2:SetEndpointWebUserControl ID="SetEndpointWebUserControl1" runat="server" />
            </asp:View>
        </asp:MultiView>
    </p>
    </form>
</body>
</html>
