<%@ Page Language="vb" AutoEventWireup="false" Inherits="ESB.Management.Portal.StartPage"
    CodeFile="StartPage.aspx.vb" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
    <title>StartPage</title>
    <link href="Styles.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .style17
        {
            width: 279px;
            background-color: #FFFFFF;
        }
        .style18
        {
            width: 375px;
            background-color: #FFFFFF;
        }
        #I1
        {
            height: 549px;
            width: 1010px;
        }
    </style>
</head>
<body>
    <form id="Form1" method="post" runat="server">
    <p class="H2">
        Welcome to the ESB.NET Management Console</p>
    <table class="ESBGridStyle" id="Table1" style="z-index: 102; left: 1px; width: 1308px;
        position: relative; top: 0px; height: 290px; margin-top: 0px;" cellspacing="1"
        cellpadding="1" border="0">
        <tr>
            <td valign="top" align="left" class="style18">
                <asp:Panel ID="Panel4" runat="server" Height="184px">
                    <p class="H3">
                        Quick links</p>
                    <p>
                        <asp:ImageButton ID="ImageButton9" runat="server" 
                            ImageUrl="~\Images\EStar.png" />
                        &nbsp;
                        <asp:HyperLink ID="HyperLink6" runat="server" 
                        NavigateUrl="~/Authenticated/System/Instances/Instances.aspx">Published ESB.NET instances</asp:HyperLink>
                    </p>
                    <p>
                        <asp:ImageButton ID="ImageButton15" runat="server" ImageUrl="~\Images\appr.gif" 
                        Height="12px" />
                        &nbsp;&nbsp;&nbsp;&nbsp;
                        <asp:HyperLink ID="HyperLink12" runat="server" 
                        NavigateUrl="~/Authenticated/System/Instances/Endpoints.aspx">ESB.NET instance endpoints</asp:HyperLink>
                    </p>
                    <p>
                        <asp:ImageButton ID="ImageButton10" runat="server" ImageUrl="~\Images\appr.gif" 
                        Height="12px" />
                        &nbsp;&nbsp;&nbsp;
                        <asp:HyperLink ID="HyperLink7" runat="server" 
                        
                            NavigateUrl="~/Authenticated/System/XMLConfigurationFiles/ManagePipelineCfg.aspx">Services catalog</asp:HyperLink>
                    </p>
                    <p>
                        <asp:ImageButton ID="ImageButton11" runat="server" 
                        ImageUrl="~\Images\EStar.png" />
                        &nbsp;
                        <asp:HyperLink ID="HyperLink8" runat="server" 
                        
                            NavigateUrl="~/Authenticated/System/Instrumentation/LogsManagement/ViewLogsDB3.aspx">Search logs</asp:HyperLink>
                    </p>
                    <p>
                        <asp:ImageButton ID="ImageButton12" runat="server" 
                        ImageUrl="~\Images\EStar.png" />
                        &nbsp;
                        <asp:HyperLink ID="HyperLink9" runat="server" 
                        NavigateUrl="~/Authenticated/Testing/SendRequestPage.aspx">Send ad-hoc requests</asp:HyperLink>
                        &nbsp;</p>
                    <p>
                        <asp:ImageButton ID="ImageButton13" runat="server" 
                        ImageUrl="~\Images\EStar.png" />
                        &nbsp;
                        <asp:HyperLink ID="HyperLink10" runat="server" 
                        NavigateUrl="~/Authenticated/Testing/SystemTestGridPage.aspx">Core system test</asp:HyperLink>
                        &nbsp;</p>
                    <p>
                        <asp:ImageButton ID="ImageButton14" runat="server" 
                        ImageUrl="~\Images\EStar.png" />
                        &nbsp;
                        <asp:HyperLink ID="HyperLink11" runat="server" 
                        
                            NavigateUrl="~/Authenticated/System/Instrumentation/Monitoring/ServiceMetering.aspx">Service metering</asp:HyperLink>
                        &nbsp;</p>
                </asp:Panel>
            </td>
            <td valign="top" align="left" class="style17">
                <iframe id="I1" src="Documentation/Pipelines.htm" runat="server" name="I1" 
                    frameborder="0" scrolling="no" />
            </td>
        </tr>
    </table>
    <br />
    <table class="ESBGridStyle" id="Table2" style="z-index: 102; left: 1px; width: 1089px;
        position: relative; top: 0px; height: 290px" cellspacing="1" cellpadding="1"
        border="0">
        <tr>
            <td valign="top" align="left">
                <p class="H3">
                    Getting started</p>
                <p class="style6">
                    Use the tree control on the left to manage the system.</p>
                <p class="style6">
                    Use the quick links above for common tasks.</p>
                <ul class="style1">
                    <li>
                        <p class="style8">
                            Feature prefix icons</p>
                    </li>
                    <p class="style8">
                        <span class="style11">Items marked with</span></p>
                    <p class="style10">
                        <asp:ImageButton ID="ImageButton1" runat="server" CssClass="style11" ImageUrl="~\Images\appr.gif" />
                        <span class="style11">&nbsp;&nbsp;&nbsp; indicate an implemented feature.</span></p>
                    <p class="style10">
                        <asp:ImageButton ID="ImageButton2" runat="server" CssClass="style11" ImageUrl="~\Images\EStar.png" />
                        <span class="style11">&nbsp;indicate an implemented Enterprise pack feature. These features
                            require a shared database for their functionality.</span></p>
                    <p class="style11">
                        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        *Additional database scripts and services need to be deployed to fully enable this
                        functionality. See
                        <asp:HyperLink ID="HyperLink13" runat="server" NavigateUrl="EnterprisePackConfiguration.mht">here</asp:HyperLink>
                        &nbsp;for more details.*</p>
                    <p class="style10">
                        <asp:ImageButton ID="ImageButton4" runat="server" CssClass="style11" ImageUrl="~\Images\invalid32x32.bmp" />
                        <span class="style11">&nbsp;&nbsp;&nbsp; indicate a planned but currently non-implemented
                            feature.</span></p>
                    <li>
                        <p class="style5">
                            Addins may have been setup under the "ComponentGroups" node. Look there for any
                            configuration information related to any systems being accessed.</p>
                    </li>
                    <li>
                        <p class="style5">
                            Note that&nbsp;some parts of the Management Console require&nbsp;ESB administrator
                            priviliges, as they have the ability to modify the systems parameters.</p>
                    </li>
                </ul>
            </td>
        </tr>
    </table>
    </form>
</body>
</html>
    </table>
    <p>
        &nbsp;</p>
    <br />
