<%@ Control Language="VB" AutoEventWireup="false" CodeFile="SendRequestUserControl.ascx.vb" Inherits="ESB.Management.Portal.UserControls.SendRequestUserControl" %>

<%@ Register Src="SetEndpointWebUserControl.ascx" TagName="SetEndpointWebUserControl" 
TagPrefix="uc1" %>
<%@ Register src="GenerateXmlFromXsdWebUserControl.ascx" tagname="GenerateXmlFromXsdWebUserControl" tagprefix="uc2" %>

<style type="text/css">
    .style3
    {
        font-size: xx-small;
        color: #FF9900;
    }
</style>

<asp:Menu ID="Menu1" runat="server" BackColor="#B5C7DE" DynamicHorizontalOffset="2"
    Font-Names="Verdana" Font-Size="0.8em" ForeColor="#284E98" Orientation="Horizontal"
    StaticSubMenuIndent="10px">
    <StaticMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
    <DynamicHoverStyle BackColor="#284E98" ForeColor="White" />
    <DynamicMenuStyle BackColor="#B5C7DE" />
    <StaticSelectedStyle BackColor="#507CD1" />
    <DynamicSelectedStyle BackColor="#507CD1" />
    <DynamicMenuItemStyle HorizontalPadding="5px" VerticalPadding="2px" />
    <Items>
        <asp:MenuItem Selected="True" Text="Select Request XML or File" Value="0"></asp:MenuItem>
        <asp:MenuItem Text="Send XML Request" Value="1"></asp:MenuItem>
        <asp:MenuItem Text="XML Response" Value="2"></asp:MenuItem>
        <asp:MenuItem Text="URL and Transport Settings" Value="3"></asp:MenuItem>
        <asp:MenuItem Text="Generate XML from XSD" Value="4"></asp:MenuItem>
    </Items>
    <StaticHoverStyle BackColor="#284E98" ForeColor="White" />
</asp:Menu>
&nbsp; &nbsp;
<asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
    <asp:View ID="View1" runat="server">
        <asp:Button ID="btnDisplayRequest" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="31px" Text="Display Request" Width="112px" />
        <asp:TextBox ID="txtRequestFilePath" runat="server" Font-Size="XX-Small" Height="26px"
            Width="1205px"></asp:TextBox>
        <asp:TreeView ID="TreeView1" runat="server" Height="800px" ImageSet="XPFileExplorer"
            NodeIndent="15" Width="500px">
            <asp:Nodes>
                <asp:TreeNode Expanded="True" Text="XMLRequests" Value="XMLRequests"></asp:TreeNode>
            </asp:Nodes>
            <Nodes>
                <asp:TreeNode Text="XMLRequests" Value="XMLRequests"></asp:TreeNode>
            </Nodes>
            <ParentNodeStyle Font-Bold="False" />
            <HoverNodeStyle Font-Underline="True" ForeColor="#6666AA" />
            <SelectedNodeStyle BackColor="#B5B5B5" Font-Underline="False" HorizontalPadding="0px"
                VerticalPadding="0px" />
            <NodeStyle Font-Names="Tahoma" Font-Size="8pt" ForeColor="Black" HorizontalPadding="2px"
                NodeSpacing="0px" VerticalPadding="2px" />
        </asp:TreeView>
    </asp:View>
    <asp:View ID="View2" runat="server">
    <asp:TextBox ID="txtRequestFilePath2" runat="server" Font-Size="XX-Small" Height="26px"
            Width="1205px"></asp:TextBox>
        <br />
        <asp:Button ID="btnSendRequest" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="30px" Text="Send Request" Width="104px" />
        <asp:Button ID="btnFormatRequestXML" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="32px" Text="Format XML" Width="88px" />
        <asp:Button ID="btnSaveRequest" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="30px" Text="Save Request" Width="104px" />
        <asp:Button ID="btnClear" runat="server" Font-Bold="True" Font-Size="XX-Small" ForeColor="Blue"
            Height="31px" Text="Clear" Width="59px" />
        <asp:Label ID="Label4" runat="server" Text="Num Execution Times"></asp:Label><asp:TextBox
            ID="txtNumExecutionTimes" runat="server">1</asp:TextBox><asp:Label ID="Label5" runat="server"
                Text="Num Execution Times Adaptor"></asp:Label><asp:TextBox ID="txtNumExecutionTimesAdaptor"
                    runat="server">1</asp:TextBox>
        <asp:CheckBox ID="chkGenerateSenderMessageID" runat="server" Checked="True" 
            Text="GenerateSenderMessageID" />
        <asp:CheckBox ID="chkEnableSimulation" runat="server" Checked="False" 
            Text="EnableSimulation" 
            ToolTip="NOTE: Logging must be synchronous for this to work correctly" />
        <br />
        <asp:Button ID="btnTestSerializeEnvelope" runat="server" Text="TestSerializeEnvelope" />
        <asp:Button ID="btnSwapToFromAddresses" runat="server" Text="SwapToFromAddresses" />
        <asp:Button ID="btnViewInServiceCatalog" runat="server" 
            Text="View in service catalog" />
        <asp:Button ID="btnInvalidateServicePipelineCache" runat="server" 
            Text="Invalidate Service Pipeline Cache" />
        <asp:Label ID="lblTouchConfigFile" runat="server"></asp:Label>
        <br />
        <asp:Label ID="Label1" runat="server" Text="Resolve Name"></asp:Label>
        <asp:TextBox ID="txtResolveName" runat="server" Width="1073px"></asp:TextBox>
        <br />
        <span class="style3">Resolve Name = &lt;Primary Document Name (Root Element 
        Name)&gt;::&lt;Primary Document Namespace&gt;</span><br />
        <asp:Label ID="Label3" runat="server" Text="Context"></asp:Label>
        &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
        <asp:TextBox ID="txtContext" runat="server" Width="1074px"></asp:TextBox>
        <br />
        <span class="style3">Context = &lt;service/name&gt;</span><br />
        <asp:TextBox ID="txtXMLRequest" runat="server" Font-Size="XX-Small" Height="800px"
            TextMode="MultiLine" Width="1300px" Wrap="False"></asp:TextBox>
        &nbsp; &nbsp;
    </asp:View>
    <asp:View ID="View3" runat="server">
        <asp:Button ID="btnFormatResponseXML" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="32px" Text="Format XML" Width="88px" />
        <asp:Button ID="btnSaveResponse" runat="server" Font-Bold="True" Font-Size="XX-Small"
            ForeColor="Blue" Height="30px" Text="Save Response" Width="104px" />
        <asp:Label ID="Label2" runat="server" Font-Bold="True" Font-Size="XX-Small" ForeColor="Blue"
            Width="130px">Response Time (ms)</asp:Label>
        <asp:TextBox ID="txtResponseTime" runat="server" Font-Size="XX-Small" Height="24px"
            Width="400px"></asp:TextBox>
        &nbsp;<asp:HyperLink ID="lnkViewLog" runat="server">View log for request</asp:HyperLink>
        &nbsp;<asp:TextBox ID="txtXMLResponse" runat="server" Font-Size="XX-Small" Height="800px"
            TextMode="MultiLine" Width="1300px" Wrap="False"></asp:TextBox>
    </asp:View>
    <asp:View ID="View4" runat="server">
       <uc1:SetEndpointWebUserControl ID="SetEndpointWebUserControl1" runat="server" />
    </asp:View>
    <asp:View ID="View5" runat="server">
    
        <uc2:GenerateXmlFromXsdWebUserControl ID="GenerateXmlFromXsdWebUserControl1" 
            runat="server" />
    
    </asp:View>
</asp:MultiView>
      