'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On 

Imports System.EnterpriseServices
Imports System.IO
Imports ESB.core.XMLSchemaClasses
Imports ESB.core.XMLSchemaClasses.ESBEnvelope
Imports ESB.core.XMLSchemaClasses.Management
Imports System.Messaging
Imports System.Text
Imports System.Xml

Imports ESB.core.Util
Imports ESB.Management.Transactions

<EventTrackingEnabled(True), Transaction(TransactionOption.Supported), System.Runtime.InteropServices.ProgId("Keystroke.ESB.Base.Version1.RetrieveLogs")> _
Public Class RetrieveLogsSC
    Inherits ESBServicedComponent

    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
        Dim o As New RetrieveLogs
        Return o.ProcessMsgSync(oEnvRq)
    End Function
End Class

Public Class RetrieveLogs
    Inherits ESBComponent

    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
        StartMethod()

        Dim oPlgRq As CIMRetrieveLogsRQ.CIMRetrieveLogsRQ
        Dim oPlgRs As CIMRetrieveLogsRS.CIMRetrieveLogsRS

        Dim oEnvRs As Envelope

        Dim oLogHlp As New LogHelper


        Try
            'oPlgRq = New CIMRetrieveLogsRQ.CIMRetrieveLogsRQ
            'oPlgRq = oEnvRq.GetDocument(oPlgRq.GetType.Name()).GetAsObject(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ))

            'oPlgRq = oEnvRq.GetDocument(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ).Name()).GetAsObject(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ))
            'Dim t As Type
            't = GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ)
            'oPlgRq = oEnvRq.GetDocument(t).GetAsObject(t)
            'oPlgRq = oEnvRq.GetDocument(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ)).GetAsObject(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ))
            'todo: fix this invalid cast exception crap!!! Build problem???
            oPlgRq = oEnvRq.GetDocumentAsObject(GetType(CIMRetrieveLogsRQ.CIMRetrieveLogsRQ))
            'oEnvRq.GetDocumentAsObject(oPlgRq)

            oLogHlp.m_sMessageID = oPlgRq.MessageID

            oPlgRs = New CIMRetrieveLogsRS.CIMRetrieveLogsRS
            oLogHlp.GetLogData(oPlgRs)


            oEnvRs = New Envelope

            'Dim sLogText As String

            'Dim oHosts(0) As CIMRetrieveLogsRS.Host
            'Dim oLogEntry(oLogHlp.m_sc.Count) As String

            'oPlgRs.Host = oHosts
            'oPlgRs.Host(0) = New CIMRetrieveLogsRS.Host()
            'oPlgRs.Host(0).Log = oLogEntry


            'oLogHlp.m_sc.CopyTo(oLogEntry, 0)

            oEnvRs.AddDocument(New InlineDocument(oPlgRs))

            Return oEnvRs

        Catch e As Exception
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, e.ToString()) : End If

            Dim oErrXML As New ErrorXML.ErrorXML

            oErrXML.ErrorEntry.Add(New ErrorXML.ErrorEntry)
            With oErrXML.ErrorEntry(0)
                .Description = e.Message
                .Source = e.ToString
            End With

            oEnvRs = New Envelope
            oEnvRs.AddDocument(New InlineDocument(oErrXML))

            Return oEnvRs

        Finally

            EndMethod()

        End Try

    End Function

End Class