option explicit 

dim m_sPrevInstallPath 

Function ConfigureConfigFiles(sDeploymentDirectory, sDeploymentDriveLetter, sThisInstanceName, bProdMode)

	WriteToLog("Function ConfigureConfigFiles - sDeploymentDirectory = 		" &  sDeploymentDirectory )
	WriteToLog("Function ConfigureConfigFiles - sDeploymentDriveLetter =	" &  sDeploymentDriveLetter )
	WriteToLog("Function ConfigureConfigFiles - sThisInstanceName =			" &  sThisInstanceName )
	WriteToLog("Function ConfigureConfigFiles - bProdMode =			" &  bProdMode )
	
	'Get the previous deployment path out of: sDeploymentDirectory & "\Configuration\ESB.config"
	'm_sPrevInstallPath  = GetPreviousInstallPath(sDeploymentDirectory & "\ESB\Base\Configuration\ESB.config")
		
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\ESB.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\ESB.Core.Loggers.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\ESB.Core.Services.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\ESB.Core.Services.Server.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\DocumentTransformPipeline.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\ServicePipeline.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Configuration\XMLConfigFiles\Test.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Transports\ESB.Core.Adaptors.Transport.Internet.Receive\Web.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Manage\EMC\Web.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName

	'ReplaceTextInFile sDeploymentDirectory & "\ESB\Base\Manage\EMC\Authenticated\Testing\SendRequestPage.aspx", "/ESB/Source/CoreInternetTransportAdaptors", "/ESB/" & sThisInstanceName & "/CoreInternetTransportAdaptors", true

'	if bProdMode = false then
'		'Rather than doing a search & replace, it's easier to just create these 2 files!
'		CreateWebInfoFile sDeploymentDirectory & "\ESB\Base\Manage\EMC\ESB.Management.Portal.vbproj.webinfo", sThisInstanceName, "/Manage/ESB.Management.Portal.vbproj"
'		CreateWebInfoFile sDeploymentDirectory & "\ESB\Base\Transports\ESB.Core.Adaptors.Transport.Internet.Receive\ESB.Core.Adaptors.Transport.Internet.Receive.vbproj.webinfo", sThisInstanceName, "/CoreInternetTransportAdaptors/ESB.Core.Adaptors.Transport.Internet.Receive.vbproj"
'	end if																																										

on error resume next 'only for dev installs?
	'ModifyConfigFile sDeploymentDirectory & "\ESB\Base\Testing\ESB.Testing.Client\ESB.Testing.Client.exe.config", sDeploymentDriveLetter, sDeploymentDirectory , sThisInstanceName

End Function


Function ModifyConfigFile (sFileName, sSystemDrv, sDeploymentDirectory, sThisInstanceName )

   Const ForReading = 1, ForWriting = 2

   Dim fso, f
   Dim SUdlText
   Dim lSrcPos

   Dim lSrcPosEnd
   Dim sSrcText
   Dim sTmp
   
   WriteToLog("Function ModifyConfigFile - Modifying Config File " & sFileName)
   
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.OpenTextFile(sFileName, ForReading)
   sUdlText =   f.ReadAll

   sSrcText = "c:\"
   sTmp = Replace(sUdlText, sSrcText, sSystemDrv & ":\")
   sSrcText = "C:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")

   sSrcText = "d:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")
   sSrcText = "D:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")

   sSrcText = "e:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")
   sSrcText = "E:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")

   sSrcText = "f:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")
   sSrcText = "F:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")

   sSrcText = "g:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")
   sSrcText = "G:\"
   sTmp = Replace(sTmp, sSrcText, sSystemDrv & ":\")
               

   sSrcText = GetCurrentInstallPath() 

'   sSrcText = sSystemDrv & ":\\Program Files\\Keystroke\\ESBNet\\Source"
	
   dim sReplaceText  
   sReplaceText = sDeploymentDirectory

   WriteToLog("		replacing " & sSrcText & " with " & sReplaceText )
   sTmp = Replace(sTmp, sSrcText,  sReplaceText )
   sTmp = ReplaceCaseInsensitive(sTmp, sSrcText,  sReplaceText )
                 
   f.close
   Set f = fso.OpenTextFile(sFileName, ForWriting, True)
   f.Write sTmp
   f.close

End Function

Function GetCurrentInstallPath()
	'sPrevInstallPath = GetPreviousInstallPath(sPath)
	GetCurrentInstallPath = 	m_sPrevInstallPath '&	"\Main"
	'GetCurrentInstallPath = 	m_sPrevInstallPath &	"\Main"
End Function

Function CreateWebInfoFile	(sFilePath, sInstanceName, sURLSuffix)
'	<VisualStudioUNCWeb>
'    <Web URLPath = "http://localhost/ESB/Source/Manage/ESB.Management.Portal.vbproj" />
'</VisualStudioUNCWeb>
    dim ofs		  
    dim oFile

	WriteToLog("Function CreateWebInfoFile- sFilePath = 		" &  sFilePath )
	WriteToLog("Function CreateWebInfoFile- sInstanceName = 		" &  sInstanceName )
	WriteToLog("Function CreateWebInfoFile- sURLSuffix = 		" &  sURLSuffix )

	Set ofs = WScript.CreateObject("Scripting.FileSystemObject") 

	Set oFile = ofs.OpenTextFile(sFilePath,2,True,0) 
	
	oFile.WriteLine "<VisualStudioUNCWeb>"
	oFile.WriteLine "<Web URLPath = ""http://localhost/ESB/" & sInstanceName & sURLSuffix & """/>"
	oFile.WriteLine "</VisualStudioUNCWeb>"
	
	oFile.Close 

End Function

Function GetPreviousInstallPath(sFileName)
	'
	 
   Const ForReading = 1, ForWriting = 2

   Dim fso, f
   Dim SUdlText
   Dim lSrcPos

   Dim lSrcPosEnd
   Dim sSrcText
   Dim sTmp
   
   WriteToLog("Function GetPreviousInstallPath - Reading Config File " & sFileName)
   
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.OpenTextFile(sFileName, ForReading)
   sUdlText =   f.ReadAll
           	 
 	 dim sSearchString 
	 sSearchString  = "<add key=""ESBRootPath"" value="
	
	dim arr
	arr=split( sUdlText , sSearchString)
	dim s1
	s1 = arr(1)


	dim arr2
	arr2=split( s1, """")
	dim s2
	s2 = arr2(1)


	dim arr3
	arr3=split( s2 , "")
	dim s3
	s3 = arr3(0)

			   'msgbox s3

	f.close
	 
	m_sPrevInstallPath = s3
	GetPreviousInstallPath = s3
End Function