'*******************************************************************
' ------------------------
' GLOBAL VAR'S & CONSTANTS
' ------------------------
Const SCRIPT_TITLE = "ESB MSMQ Queue creator..."

Dim CRLF: CRLF = Chr(13) & Chr(10)
Dim g_strQueueName

if ( Wscript.Arguments.length <> 2 ) then
	Wscript.echo "Wrong number of arguments( QueueName, InstallRemove)."
	Wscript.quit(1)
end if

g_strQueueName 	   = Wscript.Arguments.Item(0)
g_strInstallRemove = Wscript.Arguments.Item(1)

' Create the Queue

if ( g_strInstallRemove = "Install" ) then
	Call CreatePrivateQueue( g_strQueueName )
else
	Call DeletePrivateQueue( g_strQueueName, true )
end if

Wscript.quit(0)
' -----------------------
' SUBROUTINES & FUNCTIONS
' -----------------------

'**********************************************************************
' Sub:      CreatePrivateQueue
' Purpose:  Create a Private Queue
'**********************************************************************
Sub CreatePrivateQueue(QueueName)
	
	On Error Resume Next
    
    
    dim objQueueInfo

    ' Delete the Queue if it already exists
    Call DeletePrivateQueue( QueueName, false )

    set objQueueInfo = WScript.CreateObject( "MSMQ.MSMQQueueInfo" )
    objQueueInfo.PathName = ".\PRIVATE$\" & Trim( QueueName )
    objQueueInfo.Label = QueueName  
    'objQueueInfo.Create True, True  
    'Not transactional...

	objQueueInfo.Create False, True  
    Err.Clear
    WriteToLog ( "Created Private Queue(" & QueueName & ") " )
    
End Sub


'**********************************************************************
' Sub:      DeletePrivateQueue
' Purpose:  Delete the Queue if it Already Exists
'**********************************************************************
Sub DeletePrivateQueue(QueueName, bLogMsg)
    
    On Error Resume Next

   	
    Dim objQueueInfo

    set objQueueInfo = WScript.CreateObject("MSMQ.MSMQQueueInfo")
    objQueueInfo.PathName = ".\PRIVATE$\" & Trim(QueueName)
    objQueueInfo.Label = QueueName  
    objQueueInfo.Delete
    
    Err.Clear
    if bLogMsg = true then
    	WriteToLog ( "Deleted Private Queue(" & QueueName & ") " )
	end if
End Sub


Sub WriteToLog(str_in)

	Set ofs = WScript.CreateObject("Scripting.FileSystemObject") 
	Set oPrinter = ofs.OpenTextFile("C:\SetupLog.txt",8,True,0) 
	oPrinter.WriteLine now & " --- " & str_in 
	oPrinter.Close 

End Sub
