REM Usage Setup_FirstTime.cmd SQLInstanceName ESBServiceUserPassword ESBManagementUserPassword ESBInstanceName <WebSite Name>
REM eg. Setup_FirstTime.cmd localhost\slqdev S3rviceP@$sword M@n@g3m39tP@s$word Source <"Default Web Site">

echo %1
REM - Run one time Installation Steps

md "%ProgramFiles%\Microsoft SQL Server\MSSQL.1\MSSQL\DATA\"

set sqlcmdexe="%ProgramW6432%\Microsoft SQL Server\100\Tools\Binn\sqlcmd.exe"

REM "C:\Program Files\Microsoft SQL Server\100\Tools\Binn\sqlcmd.exe" -E -S localhost\esb -i .\InstallScripts\Database\CreateESBWfPersistenceDB.sql -v ProgramFiles="%ProgramFiles%"

%sqlcmdexe% -E -S %1 -i .\InstallScripts\Database\CreateESBLogDB.sql -v ProgramFiles="%ProgramFiles%"
%sqlcmdexe% -E -S %1 -i .\InstallScripts\Database\CreateESBWfPersistenceDB.sql -v ProgramFiles="%ProgramFiles%"

%sqlcmdexe% -E -S %1 -d EsbLog -i InstallScripts\Database\ESBLog_SQL2k8.sql
%sqlcmdexe% -E -S %1 -d EsbLog -i InstallScripts\Database\ESBInstances.sql
%sqlcmdexe% -E -S %1 -d EsbLog -i InstallScripts\Database\ESBServiceMetering.sql

if %PROCESSOR_ARCHITECTURE%==AMD64 set WFPersistenceScriptPath=%windir%\Microsoft.NET\Framework64\v4.0.30319\SQL\en
if %PROCESSOR_ARCHITECTURE%==x86 set WFPersistenceScriptPath=%windir%\Microsoft.NET\Framework\v4.0.30319\SQL\en

%sqlcmdexe% -E -S %1 -d ESBWfPersistence -i %WFPersistenceScriptPath%\SqlWorkflowInstanceStoreSchema.sql
%sqlcmdexe% -E -S %1 -d ESBWfPersistence -i %WFPersistenceScriptPath%\SqlWorkflowInstanceStoreLogic.sql

REM - Windows User Accounts for ESB.NET - ESBService and ESBMangement


REM ------Default Passwords-----
set ESBServiceUserPassword=%2
if dummy%2==dummy set ESBServiceUserPassword=Service3SB

set ESBManagementUserPassword=%2
if dummy%2==dummy set ESBManagementUserPassword=Management3SB
REM ------------

REM net user ESBService ESBServiceUserPassword /ADD
REM net user ESBManagement ESBManagementUserPassword /ADD

net user ESBService %2 /ADD
net user ESBManagement %3 /ADD

REM NOTE: With Windows 2003 Server, we need to add these users to the IIS_WPG Windows User Group...
net group IIS_WPG ESBService /ADD
net group IIS_WPG ESBManagement /ADD


REM - COM Registration of .NET Class for handling MSMQTriggers...First Uninstall existing...
REM msiexec /uninstall {637E26DD-7571-4799-A9C8-79191E299FDA} /qn /log ESBNETASyncTransportInstall_UnInstall.Log
REM msiexec /i ESBNETASyncTransportInstall\Release\ESBNETASyncTransportInstall.msi /qn /log ESBNETASyncTransportInstall_Install.Log

REM OR...
call ..\Transports\ESB.Core.Async.MSMQTriggersEntryPoint\Setup\Register.cmd


REM - MSMQ Triggers Rule setup
regedit /s RegistryEntries\MSMQTriggerRule_SetupFirstTime.reg

call Setup_Instance.cmd %1 %2 %3 %4 %5 %6

REM - MSMQ Triggers