Option Strict Off
Option Explicit On
Module Win32APIDeclarations


	Public Declare Function GetCurrentProcessId Lib "kernel32" () As Integer
	Public Declare Function GetCurrentThreadId Lib "kernel32" () As Integer
	
	Public Declare Function GetComputerName Lib "kernel32"  Alias "GetComputerNameA"(ByVal lpBuffer As String, ByRef nSize As Integer) As Integer
	'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1016"'
    'Public Declare Function GetComputerNameW Lib "kernel32" (ByRef lpBuffer As Any, ByRef nSize As Integer) As Integer
	
	Public Const MAX_COMPUTERNAME_LENGTH As Short = 31
	Public Const MAX_COMPUTERNAME_LENGTH_PLUS_ONE As Short = 32
	
	Public Declare Function SleepEx Lib "kernel32" (ByVal dwMilliseconds As Integer, ByVal bAlertable As Integer) As Integer
	Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)
	
	Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal dwProcessId As Integer) As Integer
	Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Integer) As Integer
	
	Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Integer, ByVal dwMilliseconds As Integer) As Integer
	Public Declare Function WaitForSingleObjectEx Lib "kernel32" (ByVal hHandle As Integer, ByVal dwMilliseconds As Integer, ByVal bAlertable As Integer) As Integer
	
	Public Structure SECURITY_ATTRIBUTES
		Dim nLength As Integer
		Dim lpSecurityDescriptor As Integer
		Dim bInheritHandle As Integer
	End Structure
	
	Public Const EVENT_ALL_ACCESS As Integer = &H1F0003
	Public Const EVENT_MODIFY_STATE As Integer = 2
	Public Const SYNCHRONIZE As Integer = &H100000
	
	Public Const INFINITE As Short = &HFFFFs '  Infinite timeout
	Public Const QS_SENDMESSAGE As Short = &H40s
	Public Const QS_PAINT As Short = &H20s
	Public Const QS_TIMER As Short = &H10s
	Public Const QS_POSTMESSAGE As Short = &H8s
	Public Const QS_MOUSEBUTTON As Short = &H4s
	Public Const QS_MOUSEMOVE As Short = &H2s
	Public Const QS_HOTKEY As Short = &H80s
	Public Const QS_KEY As Short = &H1s
	Public Const PM_REMOVE As Short = &H1s
	Public Const QS_ALLINPUT As Boolean = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)
	Public Const WAIT_FAILED As Integer = &HFFFFFFFF
	Public Const STATUS_WAIT_0 As Short = &H0s
	Public Const WAIT_OBJECT_0 As Integer = STATUS_WAIT_0 + 0
	'#define WAIT_FAILED (DWORD)0xFFFFFFFF
	'#define WAIT_OBJECT_0       ((STATUS_WAIT_0 ) + 0 )
	'#define STATUS_WAIT_0                    ((DWORD   )0x00000000L)
	
	Public Structure POINTAPI
		Dim x As Integer
		Dim y As Integer
	End Structure
	
	Public Structure MSG
		Dim hwnd As Integer
		Dim message As Integer
		Dim wParam As Integer
		Dim lParam As Integer
		Dim time As Integer
		Dim pt As POINTAPI
	End Structure
	
	
	'UPGRADE_WARNING: Structure SECURITY_ATTRIBUTES may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	Public Declare Function CreateEvent Lib "kernel32"  Alias "CreateEventA"(ByRef lpEventAttributes As SECURITY_ATTRIBUTES, ByVal bManualReset As Integer, ByVal bInitialState As Integer, ByVal lpName As String) As Integer
	Public Declare Function OpenEvent Lib "kernel32"  Alias "OpenEventA"(ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal lpName As String) As Integer
	Public Declare Function ResetEvent Lib "kernel32" (ByVal hEvent As Integer) As Integer
	Public Declare Function GetLastError Lib "kernel32" () As Integer
	Public Declare Function SetEvent Lib "kernel32" (ByVal hEvent As Integer) As Integer
	
	Public Declare Function MsgWaitForMultipleObjects Lib "user32" (ByVal nCount As Integer, ByRef pHandles As Integer, ByVal fWaitAll As Integer, ByVal dwMilliseconds As Integer, ByVal dwWakeMask As Integer) As Integer
	'UPGRADE_WARNING: Structure MSG may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	Public Declare Function PeekMessage Lib "user32"  Alias "PeekMessageA"(ByRef lpMsg As MSG, ByVal hwnd As Integer, ByVal wMsgFilterMin As Integer, ByVal wMsgFilterMax As Integer, ByVal wRemoveMsg As Integer) As Integer
	'UPGRADE_WARNING: Structure MSG may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	Public Declare Function TranslateMessage Lib "user32" (ByRef lpMsg As MSG) As Integer
	'UPGRADE_WARNING: Structure MSG may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1050"'
	Public Declare Function DispatchMessage Lib "user32"  Alias "DispatchMessageA"(ByRef lpMsg As MSG) As Integer
	
	
	
    ''Shell and Wait...
    'Public Function ShellAndWait(ByVal strProg As String, ByVal lStyle As AppWinStyle) As Boolean
    '	Dim ProcessId As Integer
    '	Dim ProcessHandle As Integer
    '	Const Access As Integer = &H100000

    '	On Error Resume Next
    '	ProcessId = Shell(strProg, lStyle)
    '	If 0 = ProcessId Then
    '		ShellAndWait = False
    '		Exit Function
    '	End If
    '	Do 
    '		ProcessHandle = OpenProcess(Access, False, ProcessId)
    '		If ProcessHandle <> 0 Then
    '			CloseHandle(ProcessHandle)
    '		End If
    '		System.Windows.Forms.Application.DoEvents()
    '	Loop Until ProcessHandle = 0
    '	ShellAndWait = True
    'End Function
End Module