Imports System.Xml.Serialization
Imports System.IO
Imports System.Xml
Imports System.Text
Imports System.Xml.Schema

Public Class Form1

    Dim m_oServer As New EsbServerService.ProcessMsgClient

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim sResult As String

        Dim sw As New Stopwatch
        sw.Start()
        Dim x As New ProcessMsgClient

        'initial call to warm up...

        sResult = x.ProcesMsgSync("sss")

        For i As Integer = 1 To TextBox1.Text


            sResult = x.ProcesMsgSync("sss")
        Next
        x.Close()
        sw.Stop()


        TextBox2.Text = sResult

        TextBox3.Text = sw.ElapsedMilliseconds.ToString & " (ms)"



    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Dim x As New localhost.CalculatorService
        'x.AddTo(6, True)
        Dim ci As New System.ServiceModel.InstanceContext(New CallbackHandler)

        Dim x As New CalculatorDuplexClient(ci)
        x.AddTo(5)

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        m_oServer.Close()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_oServer = New EsbServerService.ProcessMsgClient
        m_oServer.Open()

    End Sub
    ' The service contract is defined in generatedClient.vb, generated from the service by the svcutil tool.

    ' Define class which implements callback interface of duplex contract
    Public Class CallbackHandler
        Implements ICalculatorDuplexCallback

        Public Sub Equals(ByVal result As Double) Implements ICalculatorDuplexCallback.Equals

            Console.WriteLine("Equals({0})", result)

        End Sub

        Public Sub Equation(ByVal eqn As String) Implements ICalculatorDuplexCallback.Equation

            Console.WriteLine("Equation({0})", eqn)

        End Sub

    End Class

    Private Sub btnInvokeEsb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInvokeEsb.Click
        Dim swOuter As New Stopwatch
        swOuter.Start()

        Dim oServer As New EsbServerService.ProcessMsgClient
        Dim oMsgRq As New WindowsApplication1.EsbServerService.ESBMessage
        Dim oMsgRs As WindowsApplication1.EsbServerService.ESBMessage

        Dim oDoc As New Xml.XmlDocument()
        oDoc.LoadXml(txtXmlRq.Text)
        oMsgRq.EnvelopeXML = oDoc.DocumentElement
        'oMsgRq.EnvelopeXML.InnerXml = txtXmlRq.Text
        'oMsgRs = oServer.ProcessMsgSync(oMsgRq)
        'txtXmlRs.Text = oMsgRs.EnvelopeXML.OuterXml


        'initial call to warm up...
        oServer.InnerChannel.AllowOutputBatching = False

        'oServer.Open()


        oMsgRs = oServer.ProcessMsgSync(oMsgRq)
        'txtXmlRs.Text = oMsgRs.EnvelopeXML.OuterXml

        Dim sw As New Stopwatch
        sw.Start()

        For i As Integer = 1 To TextBox1.Text
            oMsgRs = oServer.ProcessMsgSync(oMsgRq)
            'oMsgRs = m_oServer.ProcessMsgSync(oMsgRq)

            '`oMsgRs = oServer.EsbServerService_IProcessMsg_ProcessMsgSync(oMsgRq)

        Next
        sw.Stop()

        oServer.Close()

        txtXmlRs.Text = oMsgRs.EnvelopeXML.OuterXml

        TextBox3.Text = sw.ElapsedMilliseconds.ToString & " (ms)"
        TextBox4.Text = swOuter.ElapsedMilliseconds.ToString & " (ms)"

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        txtXmlRs.Text = PrettyFormatXML(txtXmlRs.Text)
    End Sub
    Public Function PrettyFormatXML(ByVal oStream As MemoryStream, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String
        '''bXMLDOMParseFirst 
        '''Not good for large XML (100's of KBytes,MBytes etc.) as it does an XMLDOM parse etc...
        'Default to using it though till we fix the other way. Not using the XMLDom 
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        'If bXMLDOMParseFirst = True Then
        Dim oXMLDoc As New XmlDocument
        oXMLDoc.Load(oStream)

        '++MINA - get rid of that UTF-16 stuff!!!
        Dim oMemStream As New MemoryStream
        Dim sw As New StreamWriter(oMemStream, New System.Text.UTF8Encoding)

        Dim xmlwriter As New XmlTextWriter(sw)
        xmlwriter.Formatting = Formatting.Indented
        oXMLDoc.Save(xmlwriter)

        Dim sXmlOut As String = Encoding.UTF8.GetString(oMemStream.ToArray())

        oMemStream.Flush()
        oMemStream.Close()

        Return sXmlOut
        '--MINA - get rid of that UTF-16 stuff!!!

        'End If


        'TODO: Fix this thing below...
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        'Dim reader As New XmlTextReader(oStream)
        'Dim writer As New StringWriter
        'Dim sTabPrefix As String = "" 'vbTab

        'While reader.Read()

        '    If reader.NodeType = XmlNodeType.Element Or reader.NodeType = XmlNodeType.XmlDeclaration Then
        '        sTabPrefix = New String(vbTab, reader.Depth)
        '        'writer.WriteLine("{0}<{1}>", sTabPrefix, reader.Name)



        '        If reader.NodeType = XmlNodeType.Element And reader.NodeType = XmlNodeType.EndElement Then
        '            writer.Write("{0}<{1}/>", sTabPrefix, Trim(reader.Name))
        '        Else
        '            writer.Write("{0}<{1}", sTabPrefix, Trim(reader.Name))
        '        End If

        '        If reader.HasAttributes Then
        '            While reader.MoveToNextAttribute()
        '                'Dim i As Long = 0
        '                'If i > 0 Then
        '                '    writer.Write(",")
        '                'End If
        '                writer.Write(" ")
        '                writer.Write(Trim(reader.Name))
        '                writer.Write("=""")
        '                writer.Write(Trim(reader.Value))
        '                writer.Write("""")
        '                'i += 1
        '            End While
        '            reader.MoveToElement()
        '        End If
        '        writer.WriteLine(">")

        '    Else
        '        If reader.NodeType = XmlNodeType.Text Then
        '            sTabPrefix = New String(vbTab, reader.Depth + 1)
        '            writer.WriteLine("{0}{1}", sTabPrefix, Trim(reader.Value))
        '        End If
        '        If reader.NodeType = XmlNodeType.EndElement Then
        '            sTabPrefix = New String(vbTab, reader.Depth)
        '            writer.WriteLine("{0}</{1}>", sTabPrefix, Trim(reader.Name))
        '        End If
        '    End If
        'End While

        'Dim buf As String = writer.ToString
        'writer.Close()
        'reader.Close()

        'Return buf

    End Function
    Public Function PrettyFormatXML(ByVal sXML As String, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String
        Dim oStream As New MemoryStream
        'Dim inputByteArray() As Byte = Encoding.Unicode.GetBytes(sXML)
        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sXML)

        oStream.Write(inputByteArray, 0, inputByteArray.Length)
        oStream.Position = 0
        'oStream.Close()

        Return PrettyFormatXML(oStream, bXMLDOMParseFirst)
    End Function
End Class
