'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------


Option Strict On

Imports System.IO

Imports ESB.Core.XMLSchemaClasses.ESBEnvelope

Namespace Wcf

    'Intended to be Used by 'Send' Transport Adaptors
    Public Class AttachmentManagerSend
        Inherits AttachmentManagerBase

        Public Overloads Function ReceiveAttachments(ByVal Request As ESBSoapXmlDocTransportWcfProxyClasses.ESBMessage, ByVal oEnv As ESBEnvelope.Envelope, ByRef oESBContext As Services.BaseContext) As Boolean
            Return MyBase.ReceiveAttachments(Request, oEnv, oESBContext.MessageID.Trim & "." & oESBContext.ActivityID.Trim)
        End Function
        Public Overloads Function SendAttachments(ByVal Request As ESBSoapXmlDocTransportWcfProxyClasses.ESBMessage, ByRef oEnv As ESBEnvelope.Envelope, ByRef oESBContext As Services.BaseContext) As Boolean
            Return MyBase.SendAttachments(Request, oEnv)
        End Function
    End Class
End Namespace
