'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------


Namespace ESB.Core.Adaptors.Transport.Internet.Receive.Wcf




    ''' Use this Pipeline Manager as we don't have ASP.NET for cacheing etc.
    Public Class WcfXsltManager : Inherits Pipeline.XsltManager

        Protected Shared m_oHashTable As Hashtable

        Shared Sub New()
            If m_oHashTable Is Nothing Then
                m_oHashTable = New Hashtable
            End If
        End Sub
        Public Sub New()
            m_PipelineParent = Me
        End Sub
        Public Overrides Sub ClearCache()
            Try
                SyncLock GetType(WcfPipelineManager)
                    m_oHashTable.Clear()
                End SyncLock
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            Finally

            End Try

        End Sub

        Public Overrides Function GetFromCache(ByRef sResolveName As String, ByRef sContext As String) As Object
            Return m_oHashTable.Item(sResolveName & "." & sContext)
        End Function

        Public Overrides Function SetToCache(ByRef sResolveName As String, ByRef sContext As String, ByRef oValue As Object) As Boolean
            SyncLock GetType(WcfPipelineManager)
                If Not GetFromCache(sResolveName, sContext) Is Nothing Then
                    'item already exists - need to remove from cache  & add new object in its place...
                    RemoveContext(sResolveName, sContext)
                End If
                m_oHashTable.Add(sResolveName & "." & sContext, oValue)
            End SyncLock
            Return True
        End Function

        'todo - should extend interface & add a  'm_oHashTable.Remove(sContextKey) method for completeness...
        Public Function RemoveContext(ByRef sResolveName As String, ByRef sContext As String) As Boolean
            SyncLock GetType(WcfPipelineManager)
                m_oHashTable.Remove(sResolveName & "." & sContext)
            End SyncLock
            Return True
        End Function
    End Class
End Namespace
