'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------


Option Strict On

Imports Microsoft.Web.Services3
Imports System.IO

Imports ESB.Core.XMLSchemaClasses.ESBEnvelope

'Intended to be Used by 'Receive' Transport Adaptors
Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Public Class AttachmentManagerReceive
        Inherits AttachmentManagerBase

        Public Overloads Function ReceiveAttachments(ByVal Request As ESBMessage, ByVal oESBContext As ESB.Core.Services.Server.ServerContext) As Boolean
            Return MyBase.ReceiveAttachments(Request, DirectCast(oESBContext.envRq, ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope), oESBContext.ActivityID.Trim & "." & oESBContext.ActivityID.Trim)
        End Function
        Public Overloads Function SendAttachments(ByVal Response As ESBMessage, ByRef oESBContext As ESB.Core.Services.Server.ServerContext) As Boolean
            Return MyBase.SendAttachments(Response, DirectCast(oESBContext.envRs, ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope))
        End Function

    End Class

End Namespace
