Imports System
Imports System.Xml
Imports Microsoft.Web.Services3
Imports System.Collections

Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Public Class SoapHttpHeadersInputFilter
        Inherits Microsoft.Web.Services3.SoapFilter

        'Inherits SoapInputFilter

        Public Overrides Function ProcessMessage(ByVal envelope As Microsoft.Web.Services3.SoapEnvelope) As Microsoft.Web.Services3.SoapFilterResult

            Try

                envelope.Context("SourceHost") = "MyTestServerHostName"


                'This field has been stripped out by other filters. We need to get in before they 
                'do their stuff!!!
                envelope.Context("SourceHost") = envelope.Context.Addressing.To.Value.Host
                'envelope.Context("SourceHost") = envelope.Context.Addressing.From.Address.Value.Host


                '++Get around issues where the time between servers is out of sync...
                'Will this work? or do we need to get to the Timestamp filter & remove it 
                'from the Pipeline? If so, do this in Global.asax ==> Application_Start
                'envelope.Context.Timestamp.Ttl = 0
                envelope.Context.Security.Timestamp.TtlInSeconds = -1

                '--Get around issues where the time between servers is out of sync...

                'envelope.Context("SourceHost") = envelope.Context.Addressing.From.Address.Value()
                'envelope.Context.Channel()
                'envelope.Context.Addressing.From.Address.Value()
                'Dim str As String
                'envelope.Save("c:\temp\se.xml")
                'envelope.Context("RawSOAPEnvelope") = str

                'Dim defaultInputFilters As SoapInputFilterCollection
                'defaultInputFilters = WebServicesConfiguration.FilterConfiguration.InputFilters


                '        private void initWS()
                '{
                '// Creates the Web service proxy.
                'webService = new ws();
                '// Gets the SoapContext associated with the SOAP request.
                'SoapContext requestContext = webService.RequestSoapContext;
                '// Sets the TTL to 60 seconds
                'requestContext.Timestamp.Ttl = 60000;
                '// add serverTime + 60 seconds to the timestamp expiration
                'DateTime serverTime = webService.GetServerTime();
                'requestContext.Timestamp.Expires = serverTime.AddMinutes(1); // compile
                'error.... read-only
                '// Adds the token to the SOAP header.
                'UsernameToken userToken;
                'userToken = new UsernameToken("ted", EncryptPassword("tedpass"),
                'PasswordOption.SendHashed);
                'requestContext.Security.Tokens.Add(userToken);
                '// Signs the SOAP message using the UsernameToken.
                'requestContext.Security.Elements.Add(new Signature(userToken));
                '}



                ''                            SoapInputFilterCollection defaultInputFilters =
                'WebServicesConfiguration.FilterConfiguration.InputFilters;
                'defaultInputFilters.Remove(typeof(TimestampInputFilter));

                'SoapOutputFilterCollection defaultOutputFilters =
                'WebServicesConfiguration.FilterConfiguration.OutputFilters;
                'defaultOutputFilters.Remove(typeof(TimestampOutputFilter));

                'The same thing can be accomplished by modifiying your web.config as well.

                Return Microsoft.Web.Services3.SoapFilterResult.Continue
            Catch ex As Exception
                'ignore for the moment...
                ExceptionManager.Publish(ex)
                Return Microsoft.Web.Services3.SoapFilterResult.Terminate
            End Try

        End Function

        'Protected Overrides Function CanProcessHeader(ByVal header As System.Xml.XmlElement, ByVal context As Microsoft.Web.Services.SoapContext) As Boolean
        'End Function
    End Class

End Namespace
