'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------


Namespace Attributes
    ''' <summary>
    ''' Indicates that this class is a Service.
    ''' </summary>
    ''' <remarks>Metadata used by the ESB Management Console to determine whether to display
    ''' this class in the list of Services for the un-configured (made available via convention) services.
    ''' Unlike with the configured services, the convention-based service handlers have a 1 to 1 correlation
    ''' with the exposed service, and are synonymous with the service itself.
    ''' This relationship can be changed at any time by configuring in the service.
    ''' </remarks>
    <AttributeUsage(AttributeTargets.Class)> _
        Public Class ServiceAttribute
        Inherits Attribute

        Public Sub New()
        End Sub
    End Class
End Namespace
