'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Namespace Attributes
    ''' <summary>
    ''' Specifies the Service Version that this Service Handler is designed to implement. 
    ''' </summary>
    ''' <remarks></remarks>
    <AttributeUsage(AttributeTargets.Class)> _
        Public Class ServiceVersionAttribute
        Inherits Attribute

        Private m_sServiceVersion As String
        Public Property ServiceVersion() As String
            Get
                Return m_sServiceVersion
            End Get
            Set(ByVal value As String)
                m_sServiceVersion = value
            End Set
        End Property

        Public Sub New(Optional ByVal ServiceVersion As String = "")
            m_sServiceVersion = ServiceVersion
        End Sub
    End Class
End Namespace
