﻿Imports ESB.Core

Class Window1

    Dim m_bInit As Boolean = False

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        init()

        'Request and Response Objects
        Dim oEnvRq As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
        Dim oEnvRs As ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope

        'oEnvRq.XML = ESB.Core.Util.File.Read("C:\ESB\Dev\Source\ESB\Base\Manage\EMC\Testing\XMLRequests\ESBCore\ESBTest1_Sync_Stripped.xml")
        'Service invocation parameters: ServiceName and Document name, namespace etc. taken from first document added to envelope
        oEnvRq.ServiceName = "au.com.keystroke.travel.Service1"
        'oEnvRq.ServiceName = "au.com.keystroke.travel.createTravelBooking"

        'Add the payload - Document name, namespace etc. taken from this document
        oEnvRq.AddDocument(New XMLSchemaClasses.InlineDocument(TextBox1.Text))
        'oEnvRq.AddDocument(New XMLSchemaClasses.InlineDocument("<BuildCmd2 xmlns=""urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2""><BuildCmdString>0</BuildCmdString></BuildCmd2>"))

        'Send the request to the server
        Dim oRhp As New ESB.Core.Adaptors.Transport.RequestHandlerProxy.Sender()
        oEnvRs = oRhp.ProcessMsgSync(oEnvRq)

        'Display the response
        TextBox2.Text = oEnvRs.XML
        TextBox3.Text += 1
    End Sub

    ''' <summary>
    ''' This only needs to be set once, not for every request.
    ''' </summary>
    ''' <remarks></remarks>
    Sub init()
        If m_bInit = False Then
            'Set the ESB Root Path on the ServerContextManager
            Dim oDIESB As New System.IO.DirectoryInfo(AppDomain.CurrentDomain.BaseDirectory)

            'Set the ESB Root Path...
            Dim sESBRootPath As String = oDIESB.FullName
            ESB.Core.Util.ESBGlobalVariables.ESBRootPath = sESBRootPath
            m_bInit = True
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button2.Click
        Dim oXmlUtil As New XMLSchemaClasses.XMLUtil
        TextBox1.Text = oXmlUtil.PrettyFormatXML(TextBox1.Text)
    End Sub
End Class
