'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

<ESB.Core.Util.Attributes.Service(), ESB.Core.Util.Attributes.Documents("BuildCmd2", "urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2")> _
Public Class RetrieveAccountPortfolio
    Inherits ServiceBase

    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()
        Try
            MyBase.ProcessMsgSync(oEnv)
            DoWork()
            Return m_oEnvRs
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw
        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        Dim oMobSvc As New application.mobile.MobileServices()
        'Dim sRs = oMobSvc.RetrieveAccountPortfolio(m_oEnvRq.GetDocument(0).GetAsString())
        'Typesafe get (well, as type safe as this particular n-v pair xsd is...)
        Dim sRs = oMobSvc.RetrieveAccountPortfolio(m_oEnvRq.GetDocument(GetType(data.xmlschemaclasses.AccountPortfolio.Rq.json.root)).GetAsString())
        m_oEnvRs.AddDocument(New InlineDocument(sRs))
    End Sub
End Class

