﻿Imports System.IO

Imports System.Text
Imports System.Net
Imports System.Security.Cryptography.X509Certificates
Imports System.Net.Security

Public Class Form1

    Public Sub New()
        InitializeComponent()

        System.Net.ServicePointManager.Expect100Continue = False
        ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback
    End Sub

    Private Sub btnSendRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendRequest.Click
        TextBox1.Text = GetData("https://www2.my.commbank.com.au/mobile/i/default.aspx")
        TextBox2.Text = SendData(LoadData("LoginToProfile_Request_Data.htm"), MakeFullUrl("mobile/i/AjaxCalls.aspx?SID="))
    End Sub
    Private Function LoadData(ByVal sFileName As String) As String
        Dim sBasePath As String = "C:\Data\Projects\CBA\NetBankJsonApi\Apps\Data\"
        Return My.Computer.FileSystem.ReadAllText(sBasePath & sFileName)
    End Function
    Private Function MakeFullUrl(ByVal sUrl As String)
        Dim sBaseUrl As String = "https://www2.my.commbank.com.au/"
        Return sBaseUrl & sUrl
    End Function


    Private Function GetData(ByVal sUrl As String) As String
        Dim oHttpClient As New ESB.Core.HTTPClient.XMLHttpRequest
        oHttpClient.Open("GET", sUrl, False, "", "")
        oHttpClient.Send()

        Dim responseFromServer As String = oHttpClient.GetResponseText()

        'Dim dataStream As Stream = oHttpClient.GetResponseStream()
        'Dim reader As StreamReader
        'If oHttpClient.GetResponseHeader("Content-Encoding").ToLower = "gzip" Then
        '    Dim gz As New System.IO.Compression.GZipStream(dataStream, Compression.CompressionMode.Decompress)
        '    reader = New StreamReader(gz)
        'Else
        '    reader = New StreamReader(dataStream)
        'End If

        'Dim responseFromServer As String = reader.ReadToEnd()

        'reader.Close()
        'dataStream.Close()

        Return responseFromServer
    End Function


    Private Function SendData(ByVal sRqData As String, ByVal sUrl As String) As String
        Dim oHttpClient As New ESB.Core.HTTPClient.XMLHttpRequest
        oHttpClient.Open("POST", sUrl, False, "", "")

        oHttpClient.SetRequestHeader("Content-Type", "application/json")


        oHttpClient.SetRequestHeader("Accept-Encoding", "gzip, deflate")

        oHttpClient.SetRequestHeader("Cache-Control", "no-cache")
        oHttpClient.SetRequestHeader("Accept-Language", "en-au")
        oHttpClient.SetRequestHeader("Accept", "*/*")
        oHttpClient.SetRequestHeader("UA-CPU", "x86")

        oHttpClient.SetRequestHeader("Referer", "https://www2.my.commbank.com.au/mobile/i/default.aspx")
        oHttpClient.SetRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30618; InfoPath.2; OfficeLiveConnector.1.3; OfficeLivePatch.0.0)")



        oHttpClient.Send(sRqData)

        'Dim dataStream As Stream = oHttpClient.GetResponseStream()
        'Dim reader As StreamReader
        'If oHttpClient.GetResponseHeader("Content-Encoding").ToLower = "gzip" Then


        '    Dim gz As New System.IO.Compression.GZipStream(dataStream, Compression.CompressionMode.Decompress)

        '    ' Open the stream using a StreamReader for easy access.
        '    ' If response.Headers.
        '    reader = New StreamReader(gz)
        'Else
        '    reader = New StreamReader(dataStream)
        '    ' Read the content.

        'End If

        'Dim responseFromServer As String = reader.ReadToEnd()


        '' Cleanup the streams and the response.
        'reader.Close()
        'dataStream.Close()

        Dim responseFromServer As String = oHttpClient.GetResponseText()

        Return responseFromServer

    End Function


    Public Function RemoteCertificateValidationCallback(ByVal sender As Object, _
                                                         ByVal certificate As X509Certificate, _
                                                         ByVal chain As X509Chain, _
                                                         ByVal sslPolicyErrors As SslPolicyErrors _
                                                        ) As Boolean

        Return True
    End Function


End Class


