﻿Imports System.IO

Imports System.Text
Imports System.Net
Imports System.Security.Cryptography.X509Certificates
Imports System.Net.Security

Public Class Form1
    Dim myWebClient As New x()

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        System.Net.ServicePointManager.Expect100Continue = False
        'ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3
        ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback

    End Sub
    Dim request As HttpWebRequest
    Dim response As HttpWebResponse
    Private Sub btnSendRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendRequest.Click
        TextBox1.Text = GetData2("https://www2.my.commbank.com.au/mobile/i/default.aspx")


        TextBox2.Text = SendData3(LoadData("LoginToProfile_Request_Data.htm"), MakeFullUrl("mobile/i/AjaxCalls.aspx?SID="))
    End Sub
    Private Function LoadData(ByVal sFileName As String) As String
        Dim sBasePath As String = "C:\Data\Projects\CBA\NetBankJsonApi\Apps\Data\"
        Return My.Computer.FileSystem.ReadAllText(sBasePath & sFileName)
    End Function
    Private Function MakeFullUrl(ByVal sUrl As String)
        Dim sBaseUrl As String = "https://www2.my.commbank.com.au/"
        'Dim sBaseUrl As String = "https://www.my.commbank.com.au/"
        Return sBaseUrl & sUrl
    End Function


    Private Function GetData3(ByVal sUrl As String) As String

      
        request = CType(WebRequest.Create(sUrl), HttpWebRequest)
        'request.ContentType = "application/json"

        request.Accept = "*/*"
        request.CachePolicy = New Cache.RequestCachePolicy(Cache.RequestCacheLevel.NoCacheNoStore)
        request.AutomaticDecompression = DecompressionMethods.GZip + DecompressionMethods.Deflate

        request.CookieContainer = New CookieContainer()
        response = CType(request.GetResponse(), HttpWebResponse)

        request.KeepAlive = True


        Dim dataStream As Stream = response.GetResponseStream()
        ' Open the stream using a StreamReader for easy access.
        Dim reader As New StreamReader(dataStream)
        ' Read the content.
        Dim responseFromServer As String = reader.ReadToEnd()

        'Cleanup the streams and the response.
        reader.Close()
        dataStream.Close()
        response.Close()


        Return responseFromServer

    End Function
    Private Function GetData2(ByVal sUrl As String) As String

        'ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3
        'ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback


        request = CType(WebRequest.Create(sUrl), HttpWebRequest)
        'request.ContentType = "application/json"

        request.Accept = "*/*"
        request.CachePolicy = New Cache.RequestCachePolicy(Cache.RequestCacheLevel.NoCacheNoStore)
        request.AutomaticDecompression = DecompressionMethods.GZip + DecompressionMethods.Deflate

        request.CookieContainer = New CookieContainer()
        response = CType(request.GetResponse(), HttpWebResponse)

        request.KeepAlive = True


        Dim dataStream As Stream = response.GetResponseStream()
        ' Open the stream using a StreamReader for easy access.
        Dim reader As New StreamReader(dataStream)
        ' Read the content.
        Dim responseFromServer As String = reader.ReadToEnd()
        
        'Cleanup the streams and the response.
        reader.Close()
        dataStream.Close()
        response.Close()
        

        Return responseFromServer

    End Function



    Private Function GetData(ByVal sUrl As String) As String
        Return myWebClient.DownloadString(sUrl)
    End Function


    Private Function SendData3(ByVal sRqData As String, ByVal sUrl As String) As String
        Dim oHttpClient As New ESB.Core.HTTPClient.XMLHttpRequest
        oHttpClient.Open("POST", sUrl, False, "", "")


        oHttpClient.SetRequestHeader("Content-Type", "application/json")


        oHttpClient.SetRequestHeader("Accept-Encoding", "gzip, deflate")

        oHttpClient.SetRequestHeader("Cache-Control", "no-cache")
        oHttpClient.SetRequestHeader("Accept-Language", "en-au")
        oHttpClient.SetRequestHeader("Accept", "*/*")
        oHttpClient.SetRequestHeader("UA-CPU", "x86")

        oHttpClient.SetRequestHeader("Referer", "https://www2.my.commbank.com.au/mobile/i/default.aspx")
        oHttpClient.SetRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30618; InfoPath.2; OfficeLiveConnector.1.3; OfficeLivePatch.0.0)")



        oHttpClient.Send(sRqData)

        Dim dataStream As Stream = oHttpClient.GetResponseStream()
        Dim reader As StreamReader
        If oHttpClient.GetResponseHeader("Content-Encoding").ToLower = "gzip" Then


            Dim gz As New System.IO.Compression.GZipStream(dataStream, Compression.CompressionMode.Decompress)

            ' Open the stream using a StreamReader for easy access.
            ' If response.Headers.
            reader = New StreamReader(gz)
        Else
            reader = New StreamReader(dataStream)
            ' Read the content.

        End If

        Dim responseFromServer As String = reader.ReadToEnd()


        ' Cleanup the streams and the response.
        reader.Close()
        dataStream.Close()
        response.Close()



        Return responseFromServer

    End Function
    Private Function SendData2(ByVal sRqData As String, ByVal sUrl As String) As String



        'ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3


        '        ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback
        request = CType(WebRequest.Create(sUrl), HttpWebRequest) ' , "POST", Encoding.ASCII.GetBytes(sRqData))
        request.Method = "POST"

        request.Accept = "*/*"
        request.Headers.Add("Accept-Language", "en-au")
        request.Referer = "https://www2.my.commbank.com.au/mobile/i/default.aspx"
        request.ContentType = "application/json"
        request.Headers.Add("UA-CPU", "x86")
        'request.Headers.Add("Connection", "Keep-Alive")

        request.Headers.Add("Accept-Encoding", "gzip, deflate")
        request.Headers.Add("Cache-Control", "no-cache")

        'request.AutomaticDecompression = DecompressionMethods.GZip + DecompressionMethods.Deflate
        request.UserAgent = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30618; InfoPath.2; OfficeLiveConnector.1.3; OfficeLivePatch.0.0)"
        ''myWebClient.Headers.Add("Host", "www2.my.commbank.com.au")
        request.ContentLength = sRqData.Length
        request.KeepAlive = True
        'request.CachePolicy = New Cache.RequestCachePolicy(Cache.RequestCacheLevel.NoCacheNoStore)

        request.CookieContainer = New CookieContainer
        request.CookieContainer.Add(response.Cookies)



        response = CType(request.GetResponse(), HttpWebResponse)

        response = CType(request.GetResponse(), HttpWebResponse)
        Dim sDesc As String = response.StatusDescription


        Dim dataStream As Stream = response.GetResponseStream()
        ' Open the stream using a StreamReader for easy access.
        Dim reader As New StreamReader(dataStream)
        ' Read the content.
        Dim responseFromServer As String = reader.ReadToEnd()

        ' Cleanup the streams and the response.
        reader.Close()
        dataStream.Close()
        response.Close()

        Return responseFromServer
    End Function


    Private Function SendData(ByVal sRqData As String, ByVal sUrl As String) As String
        'Dim myWebClient As New WebClient()


        'myWebClient.Proxy = New WebProxy()

        myWebClient.Headers.Add("Content-Type", "application/json")


        myWebClient.Headers.Add("Accept-Encoding", "gzip, deflate")

        '   myWebClient.Headers.Add("Cache-Control", "no-cache")
        '    myWebClient.Headers.Add("Accept-Language", "en-au")
        '     myWebClient.Headers.Add("Accept", "*/*")
        '       myWebClient.Headers.Add("UA-CPU", "x86")
        
        '      myWebClient.Headers.Add("Referer", "https://www2.my.commbank.com.au/mobile/i/default.aspx")
        ' myWebClient.Headers.Add("User-Agent", "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30618; InfoPath.2; OfficeLiveConnector.1.3; OfficeLivePatch.0.0)")



        '' ''myWebClient.Headers.Add("Connection", "Keep-Alive")
        '' ''myWebClient.Headers.Add("Host", "www2.my.commbank.com.au")


        'ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls
        ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback



        'Return Encoding.ASCII.GetString(myWebClient.UploadData(sUrl, "POST", Encoding.ASCII.GetBytes(sRqData)))
        Dim ba As Byte() = myWebClient.UploadData(sUrl, "POST", Encoding.ASCII.GetBytes(sRqData))



        Return Encoding.ASCII.GetString(ba)
        ' Dim sRs As String = myWebClient.UploadString(sUrl, "POST", sRqData)
        'Return sRs


    End Function

    Public Function RemoteCertificateValidationCallback(ByVal sender As Object, _
                                                         ByVal certificate As X509Certificate, _
                                                         ByVal chain As X509Chain, _
                                                         ByVal sslPolicyErrors As SslPolicyErrors _
                                                        ) As Boolean

        Return True
    End Function


End Class


Public Class x
    Inherits WebClient
    Protected Overrides Function GetWebRequest(ByVal address As System.Uri) As System.Net.WebRequest
        Dim request As System.Net.HttpWebRequest = DirectCast(MyBase.GetWebRequest(address), System.Net.HttpWebRequest)
        Dim response As System.Net.HttpWebResponse = DirectCast(MyBase.GetWebResponse(request), System.Net.HttpWebResponse)
        'request.KeepAlive = False
        'request.KeepAlive = True
        ' request.ConnectionGroupName = "MINA WAS HERE CHANNEL"
        'request.ConnectionGroupName = Guid.NewGuid().ToString()
        ' request.ProtocolVersion = HttpVersion.Version10

        request.CookieContainer = New CookieContainer(50)
        'request.CookieContainer = New CookieContainer
        request.CookieContainer.Add(response.Cookies)

        Dim utma As New Cookie("__utma", "176409783.1677951979116916500.1236991949.1236991949.1236991949.1", "/")
        utma.Secure = True
        utma.HttpOnly = True
        utma.Domain = "www2.my.commbank.com.au"

        Dim utmz As New Cookie("__utmz", "176409783.1236991949.1.1.utmcsr=(direct)|utmccn=(direct)|utmcmd=(none)", "/")
        utmz.Secure = True
        utmz.HttpOnly = True
        utmz.Domain = "www2.my.commbank.com.au"

        Dim cookieTest As New Cookie("cookieTest", "", "/")
        cookieTest.Secure = True
        cookieTest.HttpOnly = True
        cookieTest.Domain = "www2.my.commbank.com.au"

        request.CookieContainer.Add(utma)
        request.CookieContainer.Add(utmz)
        request.CookieContainer.Add(cookieTest)

        '__utma=176409783.1677951979116916500.1236991949.1236991949.1236991949.1; __utmz=176409783.1236991949.1.1.utmcsr=(direct)|utmccn=(direct)|utmcmd=(none)

        Return MyBase.GetWebRequest(address)
    End Function


End Class