﻿Imports System.Activities
Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses

Public NotInheritable Class ExceptionActivity
    Inherits CodeActivity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope

    'Define an activity input argument of type IEnvelope
    <RequiredArgument()> Property EnvRq() As InArgument(Of IEnvelope)
    <RequiredArgument()> Property ExceptionDescription() As InArgument(Of String)

    Protected Overrides Function Execute(ByVal context As System.Activities.CodeActivityContext) As Core.Interfaces.Envelope.IEnvelope
        'Obtain the runtime value of the Envelope input argument
        Dim oEnv As IEnvelope
        oEnv = context.GetValue(Me.EnvRq)

        oEnv.AddDocument(New InlineDocument("<er:Error xmlns:er='urn:ErSt'>" & Util.EscapeXmlString(context.GetValue(Me.ExceptionDescription)) & "</er:Error>"))

        Return oEnv
    End Function
End Class
