USE [ESBLog]
GO

/****** Object:  Table [dbo].[Services.EnterprisePacks.Management.InstancesHeader]    Script Date: 04/24/2009 00:53:01 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Services.EnterprisePacks.Management.InstancesHeader](
	[index] [bigint] IDENTITY(1,1) NOT NULL,
	[host] [nvarchar](1024) NULL,
	[ESBInstanceName] [nvarchar](1024) NULL,
	[FullyQualifiedInstanceName] [nvarchar](1024) NULL,
	[ServiceDomainName] [nvarchar](1024) NULL,
	[ClusterName] [nvarchar](1024) NULL,
	[IsServiceDomainEntryPoint] [bit] NULL,
	[FirstRecorded] [datetime] NULL,
	[LastUpdated] [datetime] NULL,
 CONSTRAINT [PK_Services.EnterprisePacks.Management.InstancesHeader] PRIMARY KEY CLUSTERED 
(
	[index] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

