
Public Class EsbAwareSequentialWorkflowSample
    Inherits EsbWorkflowServiceBase

    Private Sub IsApproved(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ConditionalEventArgs)
        StartMethod()
        e.Result = m_oEnvRq.GetCustomParam("Amount") < 500
        EndMethod()
    End Sub

    Public Enum eStatusType
        None
        Approved
        Rejected
    End Enum

    Private Sub OnApproved(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()

        m_oEnvRs.SetCustomParam("Status", eStatusType.Approved)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Approved - order value was:" & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()
    End Sub

    Private Sub OnRejected(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()
        If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Hehe, got here!!!Yer inda workflow now!!!") : End If

        m_oEnvRs.SetCustomParam("Status", eStatusType.Rejected)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Rejected! Costs too much  - " & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()

    End Sub


    'Public Overrides Sub ESBInitialized(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    MyBase.ESBInitialized(sender, e)
    '    StartMethod()
    '    MyBase.ProcessMsgSync(m_oEnvRq)
    '    EndMethod()
    'End Sub

    'Public Overrides Sub ESBCompleted(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    StartMethod()
    '    EndMethod()
    '    MyBase.ESBCompleted(sender, e)

    'End Sub
End Class
